function SLcreateF_M(block)
% Level-2 MATLAB file S-Function for times two demo.
%   Copyright 1990-2009 The MathWorks, Inc.
%   $Revision: 1.1.6.2 $ 

  setup(block);
  
%endfunction

function setup(block)
  
  %% Register number of input and output ports
  block.NumInputPorts  = 1;
  block.NumOutputPorts = 1;
  block.NumDialogPrms = 1;
  %block.DialogPrmsTunable = {'Tunable','Nontunable','Nontunable'};

  %% Setup functional port properties to dynamically
  %% inherited.
  block.SetPreCompInpPortInfoToDynamic;
  block.SetPreCompOutPortInfoToDynamic;
  
  
  block.OutputPort(1).Dimensions = [6 1];
  block.InputPort(1).Dimensions = [6 1];

  
  block.InputPort(1).DirectFeedthrough = false;
  
  %% Set block sample time to inherited
  block.SampleTimes = [-1 0];
  
  %% Set the block simStateCompliance to default (i.e., same as a built-in block)
  block.SimStateCompliance = 'DefaultSimState';

  %% Run accelerator on TLC
  block.SetAccelRunOnTLC(true);
  
  %% Register methods
  block.RegBlockMethod('Outputs',@Output);  

  

  
%endfunction

function Output(block)
 
  f=block.DialogPrm(1).Data;
  f1=f(1);
  f2=f(2);
  f3=f(3);
  f4=f(4);
  f5=f(5);
  f6=f(6);

  qdot=block.InputPort(1).Data;
  q1_dot=qdot(1);
  q2_dot=qdot(2);
  q3_dot=qdot(3);
  q4_dot=qdot(4);
  q5_dot=qdot(5);
  q6_dot=qdot(6);
  

  F=[f1*q1_dot;f2*q2_dot;f3*q3_dot;f4*q4_dot;f5*q5_dot;f6*q6_dot];
  
  block.OutputPort(1).Data=F;
  
%endfunction

