function SLcreateFkin_M(block)
% Level-2 MATLAB file S-Function for times two demo.
%   Copyright 1990-2009 The MathWorks, Inc.
%   $Revision: 1.1.6.2 $ 

  setup(block);
  
%endfunction

function setup(block)
  
  %% Register number of input and output ports
  block.NumInputPorts  = 1;
  block.NumOutputPorts = 1;
  block.NumDialogPrms = 1;
  %block.DialogPrmsTunable = {'Tunable','Nontunable','Nontunable'};

  %% Setup functional port properties to dynamically
  %% inherited.
  block.SetPreCompInpPortInfoToDynamic;
  block.SetPreCompOutPortInfoToDynamic;
  
  
  block.OutputPort(1).Dimensions = [3 1];
  
  block.InputPort(1).Dimensions = [6 1];
 
  
  block.InputPort(1).DirectFeedthrough = true;

  %% Set block sample time to inherited
  block.SampleTimes = [-1 0];
  
  %% Set the block simStateCompliance to default (i.e., same as a built-in block)
  block.SimStateCompliance = 'DefaultSimState';

  %% Run accelerator on TLC
  block.SetAccelRunOnTLC(true);
  
  %% Register methods
  block.RegBlockMethod('Outputs',@Output);  

  

  
%endfunction

function Output(block)
    LEN=block.DialogPrm(1).Data;
    q=block.InputPort(1).data;
   
    d6 = LEN(1);
    a1 = LEN(2);
    a2 = LEN(3);
    a3 = LEN (4);
    a4 = LEN (5);
    
    
    
    
    %The joint angles are given as:
    th1=q(1);
    th2=q(2);
    th3=q(3);
    th4=q(4);
    th5= q(5);
    th6=q(6);

    
%The x, y, and z position of the end-effector frame is given as: 
Position = [(-((cos(th1) * cos(th2) * cos(th3) - cos(th1) * sin(th2) * sin(th3)) * cos(th4) + (-cos(th1) * cos(th2) * sin(th3) - cos(th1) * sin(th2) * cos(th3)) * sin(th4)) * sin(th5) + sin(th1) * cos(th5)) * d6 + (cos(th1) * cos(th2) * cos(th3) - cos(th1) * sin(th2) * sin(th3)) * cos(th4) * a4 + (-cos(th1) * cos(th2) * sin(th3) - cos(th1) * sin(th2) * cos(th3)) * sin(th4) * a4 + cos(th1) * cos(th2) * cos(th3) * a3 - cos(th1) * sin(th2) * sin(th3) * a3 + cos(th1) * cos(th2) * a2 + cos(th1) * a1 (-((sin(th1) * cos(th2) * cos(th3) - sin(th1) * sin(th2) * sin(th3)) * cos(th4) + (-sin(th1) * cos(th2) * sin(th3) - sin(th1) * sin(th2) * cos(th3)) * sin(th4)) * sin(th5) - cos(th1) * cos(th5)) * d6 + (sin(th1) * cos(th2) * cos(th3) - sin(th1) * sin(th2) * sin(th3)) * cos(th4) * a4 + (-sin(th1) * cos(th2) * sin(th3) - sin(th1) * sin(th2) * cos(th3)) * sin(th4) * a4 + sin(th1) * cos(th2) * cos(th3) * a3 - sin(th1) * sin(th2) * sin(th3) * a3 + sin(th1) * cos(th2) * a2 + sin(th1) * a1 -((sin(th2) * cos(th3) + cos(th2) * sin(th3)) * cos(th4) + (-sin(th2) * sin(th3) + cos(th2) * cos(th3)) * sin(th4)) * sin(th5) * d6 + (sin(th2) * cos(th3) + cos(th2) * sin(th3)) * cos(th4) * a4 + (-sin(th2) * sin(th3) + cos(th2) * cos(th3)) * sin(th4) * a4 + sin(th2) * cos(th3) * a3 + cos(th2) * sin(th3) * a3 + sin(th2) * a2]';
 
    block.OutputPort(1).Data=Position;
  
%endfunction
