function SLcreateJac_M(block)
% Level-2 MATLAB file S-Function for times two demo.
%   Copyright 1990-2009 The MathWorks, Inc.
%   $Revision: 1.1.6.2 $ 

  setup(block);
  
%endfunction

function setup(block)
  
  %% Register number of input and output ports
  block.NumInputPorts  = 2;
  block.NumOutputPorts = 1;
  block.NumDialogPrms = 2;
  %block.DialogPrmsTunable = {'Tunable','Nontunable','Nontunable'};

  %% Setup functional port properties to dynamically
  %% inherited.
  block.SetPreCompInpPortInfoToDynamic;
  block.SetPreCompOutPortInfoToDynamic;
  
  
  block.OutputPort(1).Dimensions = [6 1];
  
  block.InputPort(1).Dimensions = [6 1];
  block.InputPort(2).Dimensions = [6 1];
  
  block.InputPort(1).DirectFeedthrough = true;
  block.InputPort(2).DirectFeedthrough = true;
  
  %% Set block sample time to inherited
  block.SampleTimes = [-1 0];
  
  %% Set the block simStateCompliance to default (i.e., same as a built-in block)
  block.SimStateCompliance = 'DefaultSimState';

  %% Run accelerator on TLC
  block.SetAccelRunOnTLC(true);
  
  %% Register methods
  block.RegBlockMethod('Outputs',@Output);  

  

  
%endfunction

function Output(block)
    LEN=block.DialogPrm(1).Data;
    PSI=block.DialogPrm(2).Data;
    q=block.InputPort(1).data;
    xddes=block.InputPort(2).data;
   
    d6 = LEN(1);
    a1 = LEN(2);
    a2 = LEN(3);
    a3 = LEN (4);
    a4 = LEN (5);
    
    xdd1=xddes(1);
    xdd2=xddes(2);
    xdd3=xddes(3);
    xdd4=xddes(4);
    xdd5=xddes(5);
    xdd6=xddes(6);
    
    Xdd = [xdd1,xdd2,xdd3,xdd4,xdd5,xdd6]';
    
    
    
    %The joint angles are given as:
    q1=q(1);
    q2=q(2);
    q3=q(3);
    q4=q(4);
    q5=q(5);
    q6=q(6);
    
    k = 0.01;
    
    
 % The C*q vector is given as: 

Jac =  [-(-((sin(q1) * cos(q2) * cos(q3) - sin(q1) * sin(q2) * sin(q3)) * cos(q4) + (-sin(q1) * cos(q2) * sin(q3) - sin(q1) * sin(q2) * cos(q3)) * sin(q4)) * sin(q5) - cos(q1) * cos(q5)) * d6 - (sin(q1) * cos(q2) * cos(q3) - sin(q1) * sin(q2) * sin(q3)) * cos(q4) * a4 - (-sin(q1) * cos(q2) * sin(q3) - sin(q1) * sin(q2) * cos(q3)) * sin(q4) * a4 - sin(q1) * cos(q2) * cos(q3) * a3 + sin(q1) * sin(q2) * sin(q3) * a3 - sin(q1) * cos(q2) * a2 - sin(q1) * a1 -cos(q1) * (-((sin(q2) * cos(q3) + cos(q2) * sin(q3)) * cos(q4) + (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * sin(q4)) * sin(q5) * d6 + (sin(q2) * cos(q3) + cos(q2) * sin(q3)) * cos(q4) * a4 + (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * sin(q4) * a4 + sin(q2) * cos(q3) * a3 + cos(q2) * sin(q3) * a3 + sin(q2) * a2) -cos(q1) * (-((sin(q2) * cos(q3) + cos(q2) * sin(q3)) * cos(q4) + (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * sin(q4)) * sin(q5) * d6 + (sin(q2) * cos(q3) + cos(q2) * sin(q3)) * cos(q4) * a4 + (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * sin(q4) * a4 + sin(q2) * cos(q3) * a3 + cos(q2) * sin(q3) * a3) -cos(q1) * (-((sin(q2) * cos(q3) + cos(q2) * sin(q3)) * cos(q4) + (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * sin(q4)) * sin(q5) * d6 + (sin(q2) * cos(q3) + cos(q2) * sin(q3)) * cos(q4) * a4 + (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * sin(q4) * a4) -((sin(q1) * cos(q2) * cos(q3) - sin(q1) * sin(q2) * sin(q3)) * sin(q4) - (-sin(q1) * cos(q2) * sin(q3) - sin(q1) * sin(q2) * cos(q3)) * cos(q4)) * ((sin(q2) * cos(q3) + cos(q2) * sin(q3)) * cos(q4) + (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * sin(q4)) * sin(q5) * d6 - ((sin(q2) * cos(q3) + cos(q2) * sin(q3)) * sin(q4) - (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * cos(q4)) * (-((sin(q1) * cos(q2) * cos(q3) - sin(q1) * sin(q2) * sin(q3)) * cos(q4) + (-sin(q1) * cos(q2) * sin(q3) - sin(q1) * sin(q2) * cos(q3)) * sin(q4)) * sin(q5) - cos(q1) * cos(q5)) * d6 0; (-((cos(q1) * cos(q2) * cos(q3) - cos(q1) * sin(q2) * sin(q3)) * cos(q4) + (-cos(q1) * cos(q2) * sin(q3) - cos(q1) * sin(q2) * cos(q3)) * sin(q4)) * sin(q5) + sin(q1) * cos(q5)) * d6 + (cos(q1) * cos(q2) * cos(q3) - cos(q1) * sin(q2) * sin(q3)) * cos(q4) * a4 + (-cos(q1) * cos(q2) * sin(q3) - cos(q1) * sin(q2) * cos(q3)) * sin(q4) * a4 + cos(q1) * cos(q2) * cos(q3) * a3 - cos(q1) * sin(q2) * sin(q3) * a3 + cos(q1) * cos(q2) * a2 + cos(q1) * a1 -sin(q1) * (-((sin(q2) * cos(q3) + cos(q2) * sin(q3)) * cos(q4) + (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * sin(q4)) * sin(q5) * d6 + (sin(q2) * cos(q3) + cos(q2) * sin(q3)) * cos(q4) * a4 + (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * sin(q4) * a4 + sin(q2) * cos(q3) * a3 + cos(q2) * sin(q3) * a3 + sin(q2) * a2) -sin(q1) * (-((sin(q2) * cos(q3) + cos(q2) * sin(q3)) * cos(q4) + (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * sin(q4)) * sin(q5) * d6 + (sin(q2) * cos(q3) + cos(q2) * sin(q3)) * cos(q4) * a4 + (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * sin(q4) * a4 + sin(q2) * cos(q3) * a3 + cos(q2) * sin(q3) * a3) -sin(q1) * (-((sin(q2) * cos(q3) + cos(q2) * sin(q3)) * cos(q4) + (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * sin(q4)) * sin(q5) * d6 + (sin(q2) * cos(q3) + cos(q2) * sin(q3)) * cos(q4) * a4 + (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * sin(q4) * a4) ((sin(q2) * cos(q3) + cos(q2) * sin(q3)) * sin(q4) - (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * cos(q4)) * (-((cos(q1) * cos(q2) * cos(q3) - cos(q1) * sin(q2) * sin(q3)) * cos(q4) + (-cos(q1) * cos(q2) * sin(q3) - cos(q1) * sin(q2) * cos(q3)) * sin(q4)) * sin(q5) + sin(q1) * cos(q5)) * d6 + ((cos(q1) * cos(q2) * cos(q3) - cos(q1) * sin(q2) * sin(q3)) * sin(q4) - (-cos(q1) * cos(q2) * sin(q3) - cos(q1) * sin(q2) * cos(q3)) * cos(q4)) * ((sin(q2) * cos(q3) + cos(q2) * sin(q3)) * cos(q4) + (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * sin(q4)) * sin(q5) * d6 0; 0 sin(q1) * ((-((sin(q1) * cos(q2) * cos(q3) - sin(q1) * sin(q2) * sin(q3)) * cos(q4) + (-sin(q1) * cos(q2) * sin(q3) - sin(q1) * sin(q2) * cos(q3)) * sin(q4)) * sin(q5) - cos(q1) * cos(q5)) * d6 + (sin(q1) * cos(q2) * cos(q3) - sin(q1) * sin(q2) * sin(q3)) * cos(q4) * a4 + (-sin(q1) * cos(q2) * sin(q3) - sin(q1) * sin(q2) * cos(q3)) * sin(q4) * a4 + sin(q1) * cos(q2) * cos(q3) * a3 - sin(q1) * sin(q2) * sin(q3) * a3 + sin(q1) * cos(q2) * a2) + cos(q1) * ((-((cos(q1) * cos(q2) * cos(q3) - cos(q1) * sin(q2) * sin(q3)) * cos(q4) + (-cos(q1) * cos(q2) * sin(q3) - cos(q1) * sin(q2) * cos(q3)) * sin(q4)) * sin(q5) + sin(q1) * cos(q5)) * d6 + (cos(q1) * cos(q2) * cos(q3) - cos(q1) * sin(q2) * sin(q3)) * cos(q4) * a4 + (-cos(q1) * cos(q2) * sin(q3) - cos(q1) * sin(q2) * cos(q3)) * sin(q4) * a4 + cos(q1) * cos(q2) * cos(q3) * a3 - cos(q1) * sin(q2) * sin(q3) * a3 + cos(q1) * cos(q2) * a2) sin(q1) * ((-((sin(q1) * cos(q2) * cos(q3) - sin(q1) * sin(q2) * sin(q3)) * cos(q4) + (-sin(q1) * cos(q2) * sin(q3) - sin(q1) * sin(q2) * cos(q3)) * sin(q4)) * sin(q5) - cos(q1) * cos(q5)) * d6 + (sin(q1) * cos(q2) * cos(q3) - sin(q1) * sin(q2) * sin(q3)) * cos(q4) * a4 + (-sin(q1) * cos(q2) * sin(q3) - sin(q1) * sin(q2) * cos(q3)) * sin(q4) * a4 + sin(q1) * cos(q2) * cos(q3) * a3 - sin(q1) * sin(q2) * sin(q3) * a3) + cos(q1) * ((-((cos(q1) * cos(q2) * cos(q3) - cos(q1) * sin(q2) * sin(q3)) * cos(q4) + (-cos(q1) * cos(q2) * sin(q3) - cos(q1) * sin(q2) * cos(q3)) * sin(q4)) * sin(q5) + sin(q1) * cos(q5)) * d6 + (cos(q1) * cos(q2) * cos(q3) - cos(q1) * sin(q2) * sin(q3)) * cos(q4) * a4 + (-cos(q1) * cos(q2) * sin(q3) - cos(q1) * sin(q2) * cos(q3)) * sin(q4) * a4 + cos(q1) * cos(q2) * cos(q3) * a3 - cos(q1) * sin(q2) * sin(q3) * a3) sin(q1) * ((-((sin(q1) * cos(q2) * cos(q3) - sin(q1) * sin(q2) * sin(q3)) * cos(q4) + (-sin(q1) * cos(q2) * sin(q3) - sin(q1) * sin(q2) * cos(q3)) * sin(q4)) * sin(q5) - cos(q1) * cos(q5)) * d6 + (sin(q1) * cos(q2) * cos(q3) - sin(q1) * sin(q2) * sin(q3)) * cos(q4) * a4 + (-sin(q1) * cos(q2) * sin(q3) - sin(q1) * sin(q2) * cos(q3)) * sin(q4) * a4) + cos(q1) * ((-((cos(q1) * cos(q2) * cos(q3) - cos(q1) * sin(q2) * sin(q3)) * cos(q4) + (-cos(q1) * cos(q2) * sin(q3) - cos(q1) * sin(q2) * cos(q3)) * sin(q4)) * sin(q5) + sin(q1) * cos(q5)) * d6 + (cos(q1) * cos(q2) * cos(q3) - cos(q1) * sin(q2) * sin(q3)) * cos(q4) * a4 + (-cos(q1) * cos(q2) * sin(q3) - cos(q1) * sin(q2) * cos(q3)) * sin(q4) * a4) ((cos(q1) * cos(q2) * cos(q3) - cos(q1) * sin(q2) * sin(q3)) * sin(q4) - (-cos(q1) * cos(q2) * sin(q3) - cos(q1) * sin(q2) * cos(q3)) * cos(q4)) * (-((sin(q1) * cos(q2) * cos(q3) - sin(q1) * sin(q2) * sin(q3)) * cos(q4) + (-sin(q1) * cos(q2) * sin(q3) - sin(q1) * sin(q2) * cos(q3)) * sin(q4)) * sin(q5) - cos(q1) * cos(q5)) * d6 - ((sin(q1) * cos(q2) * cos(q3) - sin(q1) * sin(q2) * sin(q3)) * sin(q4) - (-sin(q1) * cos(q2) * sin(q3) - sin(q1) * sin(q2) * cos(q3)) * cos(q4)) * (-((cos(q1) * cos(q2) * cos(q3) - cos(q1) * sin(q2) * sin(q3)) * cos(q4) + (-cos(q1) * cos(q2) * sin(q3) - cos(q1) * sin(q2) * cos(q3)) * sin(q4)) * sin(q5) + sin(q1) * cos(q5)) * d6 0; 0 sin(q1) sin(q1) sin(q1) (cos(q1) * cos(q2) * cos(q3) - cos(q1) * sin(q2) * sin(q3)) * sin(q4) - (-cos(q1) * cos(q2) * sin(q3) - cos(q1) * sin(q2) * cos(q3)) * cos(q4) -((cos(q1) * cos(q2) * cos(q3) - cos(q1) * sin(q2) * sin(q3)) * cos(q4) + (-cos(q1) * cos(q2) * sin(q3) - cos(q1) * sin(q2) * cos(q3)) * sin(q4)) * sin(q5) + sin(q1) * cos(q5); 0 -cos(q1) -cos(q1) -cos(q1) (sin(q1) * cos(q2) * cos(q3) - sin(q1) * sin(q2) * sin(q3)) * sin(q4) - (-sin(q1) * cos(q2) * sin(q3) - sin(q1) * sin(q2) * cos(q3)) * cos(q4) -((sin(q1) * cos(q2) * cos(q3) - sin(q1) * sin(q2) * sin(q3)) * cos(q4) + (-sin(q1) * cos(q2) * sin(q3) - sin(q1) * sin(q2) * cos(q3)) * sin(q4)) * sin(q5) - cos(q1) * cos(q5); 1 0 0 0 (sin(q2) * cos(q3) + cos(q2) * sin(q3)) * sin(q4) - (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * cos(q4) -((sin(q2) * cos(q3) + cos(q2) * sin(q3)) * cos(q4) + (-sin(q2) * sin(q3) + cos(q2) * cos(q3)) * sin(q4)) * sin(q5);];

%Damped Least-Squares Inverse
 Jpi = (Jac')/(Jac * Jac'+ k^2 * eye(6));
  
  

 
 qdd = Jpi*Xdd;
 
    block.OutputPort(1).Data=qdd;
  
%endfunction
