function SLcreatePHI_M(block)
% Level-2 MATLAB file S-Function for times two demo.
%   Copyright 1990-2009 The MathWorks, Inc.
%   $Revision: 1.1.6.2 $ 

  setup(block);
  
%endfunction

function setup(block)
  
  %% Register number of input and output ports
  block.NumInputPorts  = 1;
  block.NumOutputPorts = 1;
  block.NumDialogPrms = 2;
  %block.DialogPrmsTunable = {'Tunable','Nontunable','Nontunable'};

  %% Setup functional port properties to dynamically
  %% inherited.
  block.SetPreCompInpPortInfoToDynamic;
  block.SetPreCompOutPortInfoToDynamic;
  
  
  block.OutputPort(1).Dimensions = [6 1];
  block.InputPort(1).Dimensions = [6 1];

  
  block.InputPort(1).DirectFeedthrough = false;
  
  %% Set block sample time to inherited
  block.SampleTimes = [-1 0];
  
  %% Set the block simStateCompliance to default (i.e., same as a built-in block)
  block.SimStateCompliance = 'DefaultSimState';

  %% Run accelerator on TLC
  block.SetAccelRunOnTLC(true);
  
  %% Register methods
  block.RegBlockMethod('Outputs',@Output);  

  

  
%endfunction

function Output(block)
  g=9.81;
  M=block.DialogPrm(1).Data;
%   m1=M(1);
  m2=M(2);
  m3=M(3);
  m4=M(4);
  m5=M(5);
  m6=M(6);
  
  LENGTH=block.DialogPrm(2).Data;
%   a1 = LENGTH(1);
  a2 = LENGTH(2);
  a3 = LENGTH(3);
  a4 = LENGTH(4);
  a5 = LENGTH(5);
  a6 = LENGTH(6);
  
  
  q=block.InputPort(1).Data;
  q1=q(1);
  q2=q(2);
  q3=q(3);
  q4=q(4);
  q5=q(5);
  q6=q(6);
  
  phi1=0;
  phi2= g * (m2 * a2 * cos(q2) + 0.2e1 * m3 * a2 * cos(q2) + m3 * a3 * cos(q2 + q3) + 0.2e1 * m4 * a2 * cos(q2) + 0.2e1 * m4 * a3 * cos(q2 + q3) + m4 * cos(q2 + q3 + q4) * a4 + 0.2e1 * m5 * a2 * cos(q2) + 0.2e1 * m5 * a3 * cos(q2 + q3) + 0.2e1 * m5 * cos(q2 + q3 + q4) * a4 - m5 * cos(q2 + q3 + q4) * a5 * sin(q5) + 0.2e1 * m6 * a2 * cos(q2) + 0.2e1 * m6 * a3 * cos(q2 + q3) + 0.2e1 * m6 * cos(q2 + q3 + q4) * a4 - 0.2e1 * m6 * cos(q2 + q3 + q4) * a5 * sin(q5) - m6 * cos(q2 + q3 + q4) * sin(q5) * a6) / 0.2e1;

  phi3= g * (m3 * a3 * cos(q2 + q3) + 0.2e1 * m4 * a3 * cos(q2 + q3) + m4 * cos(q2 + q3 + q4) * a4 + 0.2e1 * m5 * a3 * cos(q2 + q3) + 0.2e1 * m5 * cos(q2 + q3 + q4) * a4 - m5 * cos(q2 + q3 + q4) * a5 * sin(q5) + 0.2e1 * m6 * a3 * cos(q2 + q3) + 0.2e1 * m6 * cos(q2 + q3 + q4) * a4 - 0.2e1 * m6 * cos(q2 + q3 + q4) * a5 * sin(q5) - m6 * cos(q2 + q3 + q4) * sin(q5) * a6) / 0.2e1;

  phi4 =g * (m4 * cos(q2 + q3 + q4) * a4 + 0.2e1 * m5 * cos(q2 + q3 + q4) * a4 - m5 * cos(q2 + q3 + q4) * a5 * sin(q5) + 0.2e1 * m6 * cos(q2 + q3 + q4) * a4 - 0.2e1 * m6 * cos(q2 + q3 + q4) * a5 * sin(q5) - m6 * cos(q2 + q3 + q4) * sin(q5) * a6) / 0.2e1;
  phi5 = g * (-m5 * sin(q2 + q3 + q4) * a5 * cos(q5) - 0.2e1 * m6 * sin(q2 + q3 + q4) * a5 * cos(q5) - m6 * sin(q2 + q3 + q4) * cos(q5) * a6) / 0.2e1;
  phi6 = 0;
  
  PHI=[phi1;phi2;phi3;phi4;phi5;phi6];
  
  block.OutputPort(1).Data=PHI;
  
%endfunction

