function SLcreateY_M(block)
% Level-2 MATLAB file S-Function for times two demo.
%   Copyright 1990-2009 The MathWorks, Inc.
%   $Revision: 1.1.6.2 $ 

  setup(block);
  
%endfunction

function setup(block)
  
  %% Register number of input and output ports
  block.NumInputPorts  = 1;
  block.NumOutputPorts = 1;
  block.NumDialogPrms = 2;
  %block.DialogPrmsTunable = {'Tunable','Nontunable','Nontunable'};

  %% Setup functional port properties to dynamically
  %% inherited.
  block.SetPreCompInpPortInfoToDynamic;
  block.SetPreCompOutPortInfoToDynamic;
  
  
  block.OutputPort(1).Dimensions = [6 1];
  block.InputPort(1).Dimensions = 6;
 
  
  block.InputPort(1).DirectFeedthrough = true;

  
  %% Set block sample time to inherited
  block.SampleTimes = [-1 0];
  
  %% Set the block simStateCompliance to default (i.e., same as a built-in block)
  block.SimStateCompliance = 'DefaultSimState';

  %% Run accelerator on TLC
  block.SetAccelRunOnTLC(true);
  
  %% Register methods
  block.RegBlockMethod('Outputs',@Output);  

  

  
%endfunction

function Output(block)

    eps1=block.DialogPrm(1).Data;
    eps2=block.DialogPrm(2).Data;
   

    eps11=eps1(1);
    eps12=eps1(2);
    eps13=eps1(3);
    eps14=eps1(4);
    eps15=eps1(5);
    eps16=eps1(6);

    eps21=eps2(1);
    eps22=eps2(2);
    eps23=eps2(3);
    eps24=eps2(4);
    eps25=eps2(5);
    eps26=eps2(6);
    
    z=block.InputPort(1).Data;
    
    
    z1=z(1);
    z2=z(2);
    z3=z(3);
    z4=z(4);
    z5=z(5);
    z6=z(6);
    
    
   Y1=(1+eps11)*tanh(z1/eps21);
   Y2=(1+eps12)*tanh(z2/eps22);
   Y3=(1+eps13)*tanh(z3/eps23);
   Y4=(1+eps14)*tanh(z4/eps24);
   Y5=(1+eps15)*tanh(z5/eps25);
   Y6=(1+eps16)*tanh(z6/eps26);

   Ytot=[Y1;Y2;Y3;Y4;Y5;Y6];
   

    block.OutputPort(1).Data = Ytot;


%endfunction
