%Plots the joint angles generated from the inverse kinematics algorithm
%against the real joint angles.

figure(1)
subplot(2,1,1);
plot(t,genq(:,1),t,genq(:,2),t,genq(:,3),t,genq(:,4),t,genq(:,5),t,genq(:,6));
%  axis([0 60 -0.1 0.4])
xlabel('Time')
ylabel('Joint Angle (radians)')
title('Time evolution of the generated joint angles','FontSize',18)
legend('1','2','3','4', '5', '6')

subplot(2,1,2);
plot(t,qrad(:,1),t,qrad(:,2),t,qrad(:,3),t,qrad(:,4),t,qrad(:,5),t,qrad(:,6));
% axis([0 60 -0.1 0.4])
xlabel('Time')
ylabel('Joint Angle (radians)')
title('Time evolution of the real joint angles','FontSize',18)
legend('1','2','3','4', '5', '6')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Plots the joint velocities generated from the inverse kinematics algorithm
%against the real joint velocities.

figure(2)
subplot(2,1,1)
plot(t,genq_dot(:,1),t,genq_dot(:,2),t,genq_dot(:,3),t,genq_dot(:,4),t,genq_dot(:,5),t,genq_dot(:,6));
% axis([0 60 -0.1 0.4])
xlabel('Time')
ylabel('Joint Velocities (rad/s)')
title('Time evolution of the generated joint velocities','FontSize',18)
legend('1','2','3','4', '5', '6')

subplot(2,1,2)
plot(t,qrad_dot(:,1),t,qrad_dot(:,2),t,qrad_dot(:,3),t,qrad_dot(:,4),t,qrad_dot(:,5),t,qrad_dot(:,6));
% axis([0 60 -0.1 0.4])
xlabel('Time')
ylabel('Joint Velocities (rad/s)')
title('Time evolution of the real joint velocities','FontSize',18)
legend('1','2','3','4', '5', '6')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Plots the end-effector position as three graphs (x,y,z) against the
%integrated joystick signals.

figure(3)
plot(t,invkinans(:,1),t,invkinans(:,2),t,invkinans(:,3),t,1.697 + joystickxint,t,joystickyint,t,joystickzint);
xlabel('Time')
ylabel('End-Effector position (m)')
title('Time evolution of the task space trajectories','FontSize',18)
legend('x','y','z','joystickx','joysticky','joystickz')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Plots the simulated joystick signals.

figure(4)
plot(t, joystickx, t, joysticky,t,joystickz)
xlabel('Time')
ylabel('Joystick output')
title('Time evolution of simulated joystick outputs','FontSize',18)
legend('x','y','z')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Plots the manipulator configuration before and after the commanded motion
%is performed.

figure(5) 
six_link.plot(qrad(1,:))

figure(6)
six_link.plot(qrad(length(qrad),:))
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Plots the step size of the simulation. Only interesting when using a
%variable step size ODE solver.

stepsize = zeros(1,length(tout)-1);

for i = 1:length(tout)-1
    stepsize(i) = tout(i+1)-tout(i);
end

figure(6)
plot(tout(1:length(tout)-1),stepsize)
 axis([0 20 0 0.43])
xlabel('Time')
ylabel('Step size(s)')
title('Time evolution variable step size values','FontSize',18)



