function SLcreateC_M(block)
% Level-2 MATLAB file S-Function for times two demo.
%   Copyright 1990-2009 The MathWorks, Inc.
%   $Revision: 1.1.6.2 $ 

  setup(block);
  
%endfunction

function setup(block)
  
  %% Register number of input and output ports
  block.NumInputPorts  = 2;
  block.NumOutputPorts = 1;
  block.NumDialogPrms = 3;
  %block.DialogPrmsTunable = {'Tunable','Nontunable','Nontunable'};

  %% Setup functional port properties to dynamically
  %% inherited.
  block.SetPreCompInpPortInfoToDynamic;
  block.SetPreCompOutPortInfoToDynamic;
  
  
  block.OutputPort(1).Dimensions = [6 1];
  
  block.InputPort(1).Dimensions = [6 1];
  block.InputPort(2).Dimensions = [6 1];
  
  block.InputPort(1).DirectFeedthrough = false;
  block.InputPort(2).DirectFeedthrough = false;
  
  %% Set block sample time to inherited
  block.SampleTimes = [-1 0];
  
  %% Set the block simStateCompliance to default (i.e., same as a built-in block)
  block.SimStateCompliance = 'DefaultSimState';

  %% Run accelerator on TLC
  block.SetAccelRunOnTLC(true);
  
  %% Register methods
  block.RegBlockMethod('Outputs',@Output);  

  

  
%endfunction

function Output(block)
 
    M=block.DialogPrm(1).Data;
    Inert=block.DialogPrm(2).Data;
    LEN=block.DialogPrm(3).Data;

    %Masses
    m1=M(1);
    m2=M(2);
    m3=M(3);
    m4=M(4);
    m5=M(5);
    m6=M(6);

    %Parameters from the D-H convention
    d6 = LEN(1);
    a1 = LEN(2);
    a2 = LEN(3);
    a3 = LEN (4);
    a4 = LEN (5);
    
    %Moment of inertia for each link.
     I1x = Inert(1,1);
    I1y = Inert(1,2);
     I1z = Inert(1,3);
    I2x = Inert(2,1);
    I2y = Inert(2,2);
    I2z = Inert (2,3);
    I3x = Inert (3,1);
    I3y = Inert (3,2);
    I3z = Inert (3,3);
    I4x = Inert (4,1);
    I4y = Inert (4,2);
    I4z = Inert (4,3);
    I5x = Inert (5,1);
    I5y = Inert (5,2);
    I5z = Inert (5,3);
    I6x = Inert (6,1);
    I6y = Inert (6,2);
    I6z = Inert (6,3);
    
    


    q=block.InputPort(1).data;
    q_dot=block.InputPort(2).data;

    %The joint angles are given as:
    q1=q(1);
    q2=q(2);
    q3=q(3);
    q4=q(4);
    q5=q(5);
    q6=q(6);
    
    % The angular velocity is given as:
    qdot1=q_dot(1);
    qdot2=q_dot(2);
    qdot3=q_dot(3);
    qdot4=q_dot(4);
    qdot5=q_dot(5);
    qdot6=q_dot(6);
    
    C1 = [qdot4 * m2 * a3 * d6 * cos(-q5 + q4) / 0.4e1 - qdot4 * m2 * a3 * d6 * cos(q5 + q4) / 0.4e1 + qdot4 * m2 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 - qdot4 * m2 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 - qdot4 * m2 * a3 * a4 * sin(q4) / 0.2e1 - qdot4 * m2 * a2 * a4 * sin(q3 + q4) / 0.2e1 - qdot5 * m2 * a3 * d6 * cos(-q5 + q4) / 0.4e1 - qdot5 * m2 * a3 * d6 * cos(q5 + q4) / 0.4e1 - qdot5 * m2 * d6 * a4 * cos(q5) / 0.2e1 - qdot5 * m2 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 - qdot5 * m2 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 - qdot2 * m3 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 - qdot2 * m2 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 - qdot2 * m4 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot2 * m4 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot2 * m4 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot2 * m4 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot2 * m6 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 - qdot2 * m1 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 - qdot2 * m1 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 - qdot2 * m1 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot2 * m1 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot2 * m1 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot2 * m1 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot2 * m2 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot2 * m2 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot2 * m2 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot2 * m2 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot2 * m5 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot2 * m5 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot2 * m5 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot2 * m4 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot2 * m6 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 - qdot2 * m6 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot2 * m3 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 - qdot2 * m3 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot2 * m2 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 + qdot2 * m3 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot2 * m5 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 - qdot2 * m5 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 - qdot2 * m5 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot2 * m4 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 - qdot2 * m6 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot2 * m6 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot2 * m6 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot2 * m3 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot2 * m3 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot3 * m3 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 - qdot3 * m2 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 - qdot3 * m4 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot3 * m4 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot3 * m4 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot3 * m4 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot3 * m1 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 - qdot3 * m1 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot3 * m1 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot3 * m1 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot3 * m1 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot3 * m2 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot3 * m2 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot3 * m2 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot3 * m2 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot3 * m5 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot3 * m5 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot3 * m5 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot3 * m4 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot3 * m6 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 - qdot3 * m6 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot3 * m3 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot3 * m3 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot3 * m5 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 - qdot3 * m5 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot3 * m6 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot3 * m6 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot3 * m6 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot3 * m3 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot3 * m3 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot4 * m4 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot4 * m4 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot4 * m4 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot4 * m1 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot4 * m1 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot4 * m1 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot4 * m1 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot4 * m2 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot4 * m2 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot4 * m2 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot4 * m2 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot4 * m5 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot4 * m5 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot4 * m5 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot4 * m4 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot4 * m6 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot4 * m3 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot4 * m3 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot4 * m5 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot4 * m6 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot4 * m6 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot4 * m6 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot4 * m3 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot4 * m3 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot5 * m1 * d6 ^ 2 * sin(0.2e1 * q5) / 0.4e1 + qdot5 * m4 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot5 * m4 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot5 * m1 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot5 * m1 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot5 * m2 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot5 * m2 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot5 * m5 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot5 * m5 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot5 * m3 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot5 * m6 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot5 * m6 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot5 * m3 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot3 * m2 * a2 * a3 * sin(q3) / 0.2e1 + qdot3 * m2 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 - qdot3 * m2 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 - qdot3 * m2 * a2 * a4 * sin(q3 + q4) / 0.2e1 - qdot2 * m3 * a1 * a4 * sin(q2 + q3 + q4) + qdot2 * m3 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot2 * m3 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot2 * m4 * a1 * a3 * sin(q2 + q3) - qdot2 * m4 * a1 * a2 * sin(q2) - qdot2 * m4 * a1 * a4 * sin(q2 + q3 + q4) + qdot2 * m4 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot2 * m4 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot2 * m3 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot2 * m3 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.2e1 - qdot2 * m3 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.2e1 + qdot2 * m5 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot2 * m5 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot2 * m3 * a2 * a4 * sin((2 * q2) + q3 + q4) - qdot2 * m5 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) - qdot2 * m3 * a2 * a3 * sin((2 * q2) + q3) - qdot2 * m5 * a1 * a3 * sin(q2 + q3) - qdot2 * m5 * a1 * a2 * sin(q2) - qdot2 * m5 * a1 * a4 * sin(q2 + q3 + q4) - qdot2 * m2 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot2 * m2 * a2 * a3 * sin((2 * q2) + q3) - qdot2 * m2 * a4 * a3 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot2 * m2 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot2 * m2 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot2 * m3 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot2 * m3 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot2 * m1 * a1 * a3 * sin(q2 + q3) - qdot2 * m1 * a3 * d6 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot2 * m1 * a3 * d6 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot2 * m1 * a2 * a4 * sin((2 * q2) + q3 + q4) - qdot2 * m1 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.2e1 + qdot2 * m1 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.2e1 + qdot2 * m1 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot2 * m1 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot2 * m2 * a1 * a3 * sin(q2 + q3) - qdot2 * m4 * a2 * a4 * sin((2 * q2) + q3 + q4) + qdot2 * m4 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot3 * m3 * a2 * a3 * sin((2 * q2) + q3) / 0.2e1 - qdot3 * m5 * a1 * a3 * sin(q2 + q3) - qdot3 * m5 * a1 * a4 * sin(q2 + q3 + q4) - qdot3 * m2 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot3 * m2 * a2 * a3 * sin((2 * q2) + q3) / 0.2e1 - qdot3 * m2 * a4 * a3 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot3 * m2 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot3 * m2 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot3 * m3 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot3 * m3 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot3 * m1 * a1 * a3 * sin(q2 + q3) - qdot3 * m1 * a2 * a4 * sin(q3 + q4) / 0.2e1 - qdot3 * m1 * a3 * d6 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot3 * m1 * a3 * d6 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot3 * m1 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 - qdot3 * m1 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot3 * m1 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot3 * m1 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot3 * m1 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot3 * m2 * a1 * a3 * sin(q2 + q3) - qdot3 * m2 * a1 * a4 * sin(q2 + q3 + q4) + qdot3 * m2 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot3 * m2 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot3 * m5 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 - qdot3 * m4 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot3 * m4 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 + qdot3 * m4 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot3 * m4 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 + qdot3 * m2 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot3 * m2 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot3 * m2 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 - qdot3 * m5 * a2 * a3 * sin((2 * q2) + q3) / 0.2e1 + qdot3 * m2 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot3 * m6 * d6 * a2 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot3 * m6 * d6 * a2 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot3 * m6 * a2 * a3 * sin((2 * q2) + q3) / 0.2e1 + qdot3 * m4 * a3 * d6 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot3 * m4 * a3 * d6 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot3 * m4 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot3 * m4 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot3 * m4 * a2 * a3 * sin((2 * q2) + q3) / 0.2e1 + qdot3 * m5 * d6 * a1 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot3 * m5 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot3 * m1 * a3 * a2 * sin(q3) / 0.2e1 - qdot4 * m1 * a1 * a4 * sin(q2 + q3 + q4) + qdot4 * m1 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot4 * m1 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot4 * m1 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) / 0.2e1 + qdot4 * m1 * a3 * d6 * cos(-q5 + q4) / 0.4e1 - qdot4 * m1 * a3 * d6 * cos(q5 + q4) / 0.4e1 + qdot4 * m1 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 - qdot4 * m1 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 + qdot4 * m5 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot4 * m6 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) / 0.2e1 - qdot4 * m3 * a4 * a3 * sin((2 * q2) + 0.2e1 * q3 + q4) / 0.2e1 + qdot4 * m3 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot4 * m5 * d6 * a1 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot4 * m6 * a1 * a4 * sin(q2 + q3 + q4) - qdot4 * m5 * d6 * a2 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot4 * m5 * d6 * a2 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot4 * m6 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 - qdot4 * m6 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot4 * m6 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot4 * m6 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 + qdot4 * m6 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot4 * m6 * d6 * a1 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot4 * m6 * d6 * a1 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot4 * m3 * a1 * a4 * sin(q2 + q3 + q4) + qdot4 * m3 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot4 * m3 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot4 * m4 * a1 * a4 * sin(q2 + q3 + q4) + qdot4 * m4 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot4 * m4 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot4 * m3 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot4 * m3 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot4 * m3 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot4 * m5 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot4 * m5 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot4 * m3 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 - qdot4 * m5 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) / 0.2e1 - qdot4 * m5 * a1 * a4 * sin(q2 + q3 + q4) - qdot4 * m2 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot4 * m2 * a4 * a3 * sin((2 * q2) + 0.2e1 * q3 + q4) / 0.2e1 + qdot4 * m2 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot4 * m2 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot4 * m3 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot4 * m3 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot4 * m1 * a2 * a4 * sin(q3 + q4) / 0.2e1 - qdot4 * m1 * a3 * a4 * sin(q4) / 0.2e1 - qdot4 * m1 * a3 * d6 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot4 * m1 * a3 * d6 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot4 * m1 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 - qdot4 * m1 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot4 * m1 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot4 * m1 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot4 * m1 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot4 * m2 * a1 * a4 * sin(q2 + q3 + q4) + qdot4 * m2 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot4 * m2 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot4 * m5 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 - qdot2 * m4 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 + qdot2 * m2 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.2e1 - qdot2 * m2 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.2e1 - qdot2 * m2 * a2 * a4 * sin((2 * q2) + q3 + q4) - qdot2 * m5 * a2 * a3 * sin((2 * q2) + q3) + qdot2 * m2 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot2 * m6 * d6 * a2 * cos(q5 + q4 + q3 + (2 * q2)) / 0.2e1 + qdot2 * m6 * d6 * a2 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.2e1 - qdot2 * m6 * a2 * a3 * sin((2 * q2) + q3) + qdot2 * m4 * a3 * d6 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot2 * m4 * a3 * d6 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot2 * m4 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot2 * m4 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.2e1 - qdot2 * m4 * a2 * a3 * sin((2 * q2) + q3) + qdot2 * m5 * d6 * a1 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot2 * m5 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot3 * m1 * a1 * a4 * sin(q2 + q3 + q4) + qdot3 * m1 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot3 * m1 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot3 * m1 * a3 * a2 * sin((2 * q2) + q3) / 0.2e1 - qdot3 * m1 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot3 * m1 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 - qdot3 * m1 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 + qdot3 * m5 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot3 * m6 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) - qdot3 * m3 * a4 * a3 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot3 * m3 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot3 * m5 * d6 * a1 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot3 * m6 * a1 * a3 * sin(q2 + q3) - qdot3 * m6 * a1 * a4 * sin(q2 + q3 + q4) - qdot3 * m5 * d6 * a2 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot3 * m5 * d6 * a2 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot3 * m6 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 - qdot3 * m6 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot3 * m6 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot3 * m6 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 + qdot3 * m6 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot3 * m6 * d6 * a1 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot3 * m6 * d6 * a1 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot3 * m3 * a1 * a3 * sin(q2 + q3) - qdot3 * m3 * a1 * a4 * sin(q2 + q3 + q4) + qdot3 * m3 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot3 * m3 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot3 * m4 * a1 * a3 * sin(q2 + q3) - qdot3 * m4 * a1 * a4 * sin(q2 + q3 + q4) + qdot3 * m4 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot3 * m4 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot3 * m3 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot3 * m3 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot3 * m3 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot3 * m5 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot3 * m5 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot3 * m3 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 - qdot3 * m5 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) - qdot4 * m4 * a3 * a4 * sin(q4) / 0.2e1 - qdot4 * m6 * a3 * a4 * sin(q4) / 0.2e1 - qdot4 * m5 * a3 * a4 * sin(q4) / 0.2e1 - qdot5 * m4 * a3 * d6 * cos(-q5 + q4) / 0.4e1 - qdot5 * m4 * a3 * d6 * cos(q5 + q4) / 0.4e1 - qdot3 * m6 * d6 * a2 * cos(q5 + q4 + q3) / 0.4e1 - qdot3 * m5 * d6 * a2 * cos(q5 + q4 + q3) / 0.4e1 + qdot3 * m5 * d6 * a2 * cos(-q5 + q4 + q3) / 0.4e1 + qdot3 * m6 * d6 * a2 * cos(-q5 + q4 + q3) / 0.4e1 - qdot3 * m4 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 + qdot3 * m4 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 + qdot3 * m3 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 - qdot3 * m3 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 - qdot4 * m6 * d6 * a2 * cos(q5 + q4 + q3) / 0.4e1 - qdot4 * m5 * d6 * a2 * cos(q5 + q4 + q3) / 0.4e1 + qdot4 * m5 * d6 * a2 * cos(-q5 + q4 + q3) / 0.4e1 + qdot4 * m6 * d6 * a2 * cos(-q5 + q4 + q3) / 0.4e1 - qdot4 * m4 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 + qdot4 * m4 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 - qdot5 * m6 * d6 * a2 * cos(q5 + q4 + q3) / 0.4e1 - qdot5 * m5 * d6 * a2 * cos(q5 + q4 + q3) / 0.4e1 - qdot5 * m5 * d6 * a2 * cos(-q5 + q4 + q3) / 0.4e1 - qdot5 * m6 * d6 * a2 * cos(-q5 + q4 + q3) / 0.4e1 - qdot5 * m4 * d6 ^ 2 * sin(0.2e1 * q5) / 0.4e1 - qdot5 * m5 * d6 ^ 2 * sin(0.2e1 * q5) / 0.4e1 - qdot5 * m6 * d6 ^ 2 * sin(0.2e1 * q5) / 0.4e1 - qdot5 * m2 * d6 ^ 2 * sin(0.2e1 * q5) / 0.4e1 - qdot6 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 - qdot6 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 + qdot6 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot6 * I6x * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot6 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot6 * I6y * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + 0.3e1 / 0.16e2 * qdot6 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + qdot6 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 + qdot6 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot5 * I6z * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot5 * I6x * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot5 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.16e2 + qdot5 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.16e2 - qdot5 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot5 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot2 * I6z * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot2 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 + qdot2 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 + qdot2 * I6x * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot2 * I6x * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 + qdot2 * I6x * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot2 * I6y * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot2 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot2 * I6y * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * qdot2 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + qdot2 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 + qdot2 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot2 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot2 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 - qdot2 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot2 * I6y * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * qdot2 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + qdot2 * I6y * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 + qdot2 * I6y * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 + qdot2 * I4x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot2 * I4z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot2 * I5x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot2 * I5x * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot2 * I5x * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot2 * I2x * sin((2 * q2)) / 0.2e1 - qdot2 * I2y * sin((2 * q2)) / 0.2e1 + qdot2 * I3x * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 - qdot2 * I3y * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot2 * I5z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot2 * I5z * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot2 * I5z * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot2 * I6z * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + 0.3e1 / 0.16e2 * qdot2 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + 0.3e1 / 0.16e2 * qdot2 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + qdot2 * I6x * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot2 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 - qdot2 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 + qdot2 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot2 * I5y * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot2 * I6z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot2 * I6x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot2 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot3 * I6z * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot3 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 + qdot3 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 + qdot3 * I6x * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot3 * I6x * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 + qdot3 * I6x * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot3 * I6y * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot3 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot3 * I6y * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * qdot3 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + qdot3 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 + qdot3 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot3 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot3 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 - qdot3 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot3 * I6y * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * qdot3 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + qdot3 * I6y * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 + qdot3 * I6y * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 + qdot3 * I4x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot3 * I4z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot3 * I5x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot3 * I5x * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot3 * I5x * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot3 * I3x * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 - qdot3 * I3y * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot3 * I5z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot3 * I5z * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot3 * I5z * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot3 * I6z * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + 0.3e1 / 0.16e2 * qdot3 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + 0.3e1 / 0.16e2 * qdot3 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + qdot3 * I6x * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot3 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 - qdot3 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 + qdot3 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot3 * I5y * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot3 * I6z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot3 * I6x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot3 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot4 * I6z * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot4 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 + qdot4 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 + qdot4 * I6x * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot4 * I6x * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 + qdot4 * I6x * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot4 * I6y * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot4 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot4 * I6y * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * qdot4 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + qdot4 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 + qdot4 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot4 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot4 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 - qdot4 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot4 * I6y * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * qdot4 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + qdot4 * I6y * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 + qdot4 * I6y * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 + qdot4 * I4x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot4 * I4z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot4 * I5x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot4 * I5x * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot4 * I5x * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot4 * I5z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot4 * I5z * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot4 * I5z * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot4 * I6z * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + 0.3e1 / 0.16e2 * qdot4 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + 0.3e1 / 0.16e2 * qdot4 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + qdot4 * I6x * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot4 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 - qdot4 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 + qdot4 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot4 * I5y * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot4 * I6z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot4 * I6x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot4 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot5 * I6z * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot5 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.16e2 - qdot5 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.16e2 + qdot5 * I6x * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot5 * I6x * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 + qdot5 * I6x * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot5 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot5 * I6y * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot5 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.16e2 - qdot5 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.16e2 + qdot5 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot5 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.16e2 + qdot5 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.16e2 - qdot5 * I6y * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot5 * I6y * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 + qdot5 * I6y * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot5 * I5x * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot5 * I5x * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot5 * I5z * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot5 * I5z * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot6 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 - qdot6 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot6 * I6y * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * qdot6 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) - 0.3e1 / 0.16e2 * qdot6 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + 0.3e1 / 0.16e2 * qdot6 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + qdot6 * I6x * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot6 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 + qdot6 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot6 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot6 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot4 * m4 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot4 * m4 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 + qdot4 * m4 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot4 * m4 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 + qdot4 * m2 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot4 * m2 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot4 * m2 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 + qdot4 * m2 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot4 * m6 * d6 * a2 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot4 * m6 * d6 * a2 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot4 * m4 * a3 * d6 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot4 * m4 * a3 * d6 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot4 * m4 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) / 0.2e1 + qdot4 * m4 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot4 * m5 * d6 * a1 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot4 * m5 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot5 * m1 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot5 * m1 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot5 * m1 * a3 * d6 * cos(-q5 + q4) / 0.4e1 - qdot5 * m1 * a3 * d6 * cos(q5 + q4) / 0.4e1 - qdot5 * m1 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 - qdot5 * m1 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 - qdot5 * m1 * a4 * d6 * cos(q5) / 0.2e1 - qdot5 * m5 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot5 * m3 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot5 * m5 * d6 * a1 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot5 * m5 * d6 * a2 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot5 * m5 * d6 * a2 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot5 * m6 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot5 * m6 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot5 * m6 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.4e1 - qdot5 * m6 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.4e1 - qdot5 * m6 * d6 * a1 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot5 * m6 * d6 * a1 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot5 * m3 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot5 * m3 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot5 * m4 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot5 * m4 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot5 * m3 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot5 * m3 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot5 * m3 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot5 * m5 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.4e1 - qdot5 * m5 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.4e1 - qdot5 * m2 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.4e1 - qdot5 * m2 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot5 * m2 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot5 * m3 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.4e1 - qdot5 * m3 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.4e1 - qdot5 * m1 * a3 * d6 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot5 * m1 * a3 * d6 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot5 * m1 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot5 * m1 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot5 * m1 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.4e1 - qdot5 * m1 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.4e1 - qdot5 * m2 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot5 * m2 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot5 * m4 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot5 * m4 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.4e1 - qdot5 * m4 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.4e1 - qdot5 * m2 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot5 * m2 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot5 * m2 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.4e1 - qdot5 * m6 * d6 * a2 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot5 * m6 * d6 * a2 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot5 * m4 * a3 * d6 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot5 * m4 * a3 * d6 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot5 * m4 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot5 * m5 * d6 * a1 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot5 * m5 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot2 * m5 * a2 * a4 * sin((2 * q2) + q3 + q4) - qdot2 * m4 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.2e1 - qdot2 * m2 * a1 * a2 * sin(q2) - qdot2 * m2 * a1 * a4 * sin(q2 + q3 + q4) + qdot2 * m2 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot2 * m2 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot2 * m1 * a1 * a2 * sin(q2) - qdot2 * m1 * a1 * a4 * sin(q2 + q3 + q4) + qdot2 * m1 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot2 * m1 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot2 * m1 * a3 * a2 * sin((2 * q2) + q3) - qdot2 * m1 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot2 * m5 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot2 * m6 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) - qdot2 * m3 * a4 * a3 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot2 * m3 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot2 * m5 * d6 * a1 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot2 * m6 * a1 * a3 * sin(q2 + q3) - qdot2 * m6 * a1 * a2 * sin(q2) - qdot2 * m6 * a1 * a4 * sin(q2 + q3 + q4) - qdot2 * m5 * d6 * a2 * cos(q5 + q4 + q3 + (2 * q2)) / 0.2e1 + qdot2 * m5 * d6 * a2 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.2e1 - qdot2 * m6 * a2 * a4 * sin((2 * q2) + q3 + q4) - qdot2 * m6 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot2 * m6 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot2 * m6 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 + qdot2 * m6 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 - qdot2 * m6 * d6 * a1 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot2 * m6 * d6 * a1 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot2 * m3 * a1 * a3 * sin(q2 + q3) - qdot2 * m3 * a1 * a2 * sin(q2) - qdot5 * m6 * d6 * a4 * cos(q5) / 0.2e1 + qdot4 * m3 * a3 * d6 * cos(-q5 + q4) / 0.4e1 - qdot4 * m3 * a3 * d6 * cos(q5 + q4) / 0.4e1 - qdot4 * m3 * a3 * a4 * sin(q4) / 0.2e1 - qdot5 * m3 * a3 * d6 * cos(-q5 + q4) / 0.4e1 - qdot5 * m3 * a3 * d6 * cos(q5 + q4) / 0.4e1 - qdot5 * m3 * d6 * a4 * cos(q5) / 0.2e1 + qdot5 * I5z * sin(0.2e1 * q5) / 0.4e1 - qdot5 * I5x * sin(0.2e1 * q5) / 0.4e1 + qdot5 * I6y * sin((2 * q6) + 0.2e1 * q5) / 0.16e2 - qdot5 * I6x * sin(-(2 * q6) + 0.2e1 * q5) / 0.16e2 - qdot5 * I6x * sin((2 * q6) + 0.2e1 * q5) / 0.16e2 - qdot5 * I6y * sin(0.2e1 * q5) / 0.8e1 - qdot5 * I6x * sin(0.2e1 * q5) / 0.8e1 + qdot5 * I6z * sin(0.2e1 * q5) / 0.4e1 + qdot5 * I6y * sin(-(2 * q6) + 0.2e1 * q5) / 0.16e2 + qdot6 * I6y * sin((2 * q6) + 0.2e1 * q5) / 0.16e2 + qdot6 * I6x * sin(-(2 * q6) + 0.2e1 * q5) / 0.16e2 - qdot6 * I6x * sin((2 * q6) + 0.2e1 * q5) / 0.16e2 - qdot6 * I6y * sin(-(2 * q6) + 0.2e1 * q5) / 0.16e2 - qdot4 * m5 * d6 * a3 * cos(q5 + q4) / 0.4e1 + qdot4 * m5 * d6 * a3 * cos(-q5 + q4) / 0.4e1 - qdot4 * m6 * d6 * a3 * cos(q5 + q4) / 0.4e1 + qdot4 * m6 * d6 * a3 * cos(-q5 + q4) / 0.4e1 + qdot4 * m4 * a3 * d6 * cos(-q5 + q4) / 0.4e1 - qdot4 * m4 * a3 * d6 * cos(q5 + q4) / 0.4e1 - qdot5 * m5 * d6 * a3 * cos(q5 + q4) / 0.4e1 - qdot5 * m5 * d6 * a3 * cos(-q5 + q4) / 0.4e1 - qdot5 * m6 * d6 * a3 * cos(q5 + q4) / 0.4e1 - qdot5 * m6 * d6 * a3 * cos(-q5 + q4) / 0.4e1 - qdot5 * m5 * d6 * a4 * cos(q5) / 0.2e1 - qdot5 * m4 * d6 * a4 * cos(q5) / 0.2e1 - qdot3 * m3 * a2 * a3 * sin(q3) / 0.2e1 - qdot3 * m4 * a2 * a3 * sin(q3) / 0.2e1 - qdot3 * m6 * a2 * a3 * sin(q3) / 0.2e1 - qdot3 * m5 * a2 * a3 * sin(q3) / 0.2e1 + qdot4 * m3 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 - qdot4 * m3 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 - qdot4 * m3 * a2 * a4 * sin(q3 + q4) / 0.2e1 - qdot5 * m3 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 - qdot5 * m3 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 + sin((2 * q6)) * qdot6 * I6x / 0.8e1 - sin((2 * q6)) * qdot6 * I6y / 0.8e1 - qdot3 * m6 * a2 * a4 * sin(q3 + q4) / 0.2e1 - qdot3 * m4 * a2 * a4 * sin(q3 + q4) / 0.2e1 - qdot3 * m5 * a2 * a4 * sin(q3 + q4) / 0.2e1 - qdot3 * m3 * a2 * a4 * sin(q3 + q4) / 0.2e1 - qdot4 * m6 * a2 * a4 * sin(q3 + q4) / 0.2e1 - qdot4 * m4 * a2 * a4 * sin(q3 + q4) / 0.2e1 - qdot4 * m5 * a2 * a4 * sin(q3 + q4) / 0.2e1 - qdot5 * m4 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 - qdot5 * m4 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 - qdot5 * m3 * d6 ^ 2 * sin(0.2e1 * q5) / 0.4e1 qdot1 * m4 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 - qdot3 * m2 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot3 * m2 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot4 * m2 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot4 * m2 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot5 * m2 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * m2 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot1 * I4x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * I4z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * I5x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot1 * I5z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * I5y * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * I6z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * I6x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot5 * I6y * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot5 * I6y * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot5 * I6x * sin(q2 + q3 + q4) / 0.4e1 - qdot5 * I6y * sin(q2 + q3 + q4) / 0.4e1 - qdot5 * sin(q2 + q3 + q4) * I5y / 0.2e1 + qdot5 * I5x * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * I5x * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot5 * I5z * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot5 * I5z * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * I6x * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot5 * I6x * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot5 * I6z * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot5 * I6z * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot5 * I6x * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot5 * I6y * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot5 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot5 * I6y * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot5 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot5 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot5 * I6x * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot6 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot6 * I6x * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot6 * I6y * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot6 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot6 * I6y * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot6 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot6 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot6 * I6x * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot1 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 - qdot1 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot1 * I6x * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6y * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + 0.3e1 / 0.16e2 * qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) - qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 - qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 + qdot1 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 + qdot1 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 + qdot1 * I6y * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + 0.3e1 / 0.16e2 * qdot1 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) - 0.3e1 / 0.16e2 * qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + qdot5 * m6 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * m4 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * m5 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * m6 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot5 * m5 * d6 ^ 2 * sin(q2 + q3 + q4) / 0.2e1 - qdot5 * m6 * d6 ^ 2 * sin(q2 + q3 + q4) / 0.2e1 + qdot1 * I6y * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - 0.3e1 / 0.16e2 * qdot1 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) - qdot1 * I6x * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 + qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot1 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot5 * I6x * sin(-(2 * q6) + q4 + q3 + q2) / 0.8e1 + qdot5 * I6y * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot5 * I6y * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot5 * I6x * sin((2 * q6) + q4 + q3 + q2) / 0.8e1 + qdot5 * I6x * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot5 * I6x * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot5 * I6y * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot5 * I6y * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot5 * I6x * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot5 * I6x * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot5 * I6y * sin((2 * q6) + q4 + q3 + q2) / 0.8e1 - qdot5 * I6y * sin(-(2 * q6) + q4 + q3 + q2) / 0.8e1 - qdot1 * m4 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m4 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m1 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m1 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m2 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m2 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m5 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m5 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m3 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m3 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m6 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m6 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * m1 * a1 * a2 * sin(q2) + qdot1 * m6 * a1 * a2 * sin(q2) - qdot3 * m2 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 - qdot3 * m2 * a3 * d6 * cos(q5 + q3 + q2) / 0.4e1 - qdot3 * m2 * a3 * d6 * cos(-q5 + q3 + q2) / 0.4e1 - qdot4 * m2 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 - qdot4 * m2 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 - qdot5 * m2 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 + qdot5 * m2 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 - qdot5 * m2 * a3 * d6 * cos(q5 + q3 + q2) / 0.4e1 + qdot5 * m2 * a3 * d6 * cos(-q5 + q3 + q2) / 0.4e1 - qdot5 * m2 * a2 * d6 * cos(q5 + q2) / 0.4e1 + qdot5 * m2 * a2 * d6 * cos(-q5 + q2) / 0.4e1 - qdot5 * m3 * a2 * d6 * cos(q5 + q2) / 0.4e1 + qdot5 * m3 * a2 * d6 * cos(-q5 + q2) / 0.4e1 - qdot5 * m4 * a2 * d6 * cos(q5 + q2) / 0.4e1 + qdot5 * m4 * a2 * d6 * cos(-q5 + q2) / 0.4e1 - qdot1 * I6x * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot1 * I6x * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot1 * I6y * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot1 * I6y * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot1 * I5x * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * I5x * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * I5z * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * I5z * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * I6z * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * I6z * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot6 * I6y * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot6 * I6y * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot6 * I6x * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot6 * I6x * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot6 * I6y * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot6 * I6y * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot6 * I6x * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot6 * I6x * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot6 * I6z * sin(q2 + q3 + q4 - q5) / 0.4e1 + qdot6 * I6z * sin(q2 + q3 + q4 + q5) / 0.4e1 + qdot1 * m3 * a1 * a2 * sin(q2) + qdot1 * m4 * a1 * a2 * sin(q2) + qdot1 * m5 * a1 * a2 * sin(q2) + qdot1 * m2 * a1 * a2 * sin(q2) - qdot5 * m4 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 + qdot5 * m4 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 + qdot1 * m1 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m1 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot1 * m1 * a2 * a4 * sin((2 * q2) + q3 + q4) + qdot1 * m2 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m5 * a2 * a4 * sin((2 * q2) + q3 + q4) + qdot1 * m4 * a2 * a4 * sin((2 * q2) + q3 + q4) + qdot1 * m2 * a2 * a4 * sin((2 * q2) + q3 + q4) + qdot1 * m4 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot1 * m6 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot1 * m3 * a4 * a3 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot1 * m6 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m6 * a2 * a4 * sin((2 * q2) + q3 + q4) + qdot1 * m3 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m4 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m3 * a2 * a4 * sin((2 * q2) + q3 + q4) + qdot1 * m5 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot1 * m5 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m2 * a4 * a3 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot1 * m6 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 + qdot1 * m1 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 + qdot1 * m3 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 + qdot1 * m2 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 + qdot1 * m5 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 + qdot1 * m4 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m1 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m1 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m2 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m2 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m5 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m4 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m6 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m3 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m5 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m6 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m3 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot5 * m5 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * m4 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot1 * m1 * a3 * a2 * sin((2 * q2) + q3) + qdot1 * m2 * a1 * a3 * sin(q2 + q3) + qdot1 * m5 * a2 * a3 * sin((2 * q2) + q3) + qdot1 * m6 * a2 * a3 * sin((2 * q2) + q3) + qdot1 * m4 * a2 * a3 * sin((2 * q2) + q3) + qdot1 * m6 * a1 * a3 * sin(q2 + q3) + qdot1 * m3 * a1 * a3 * sin(q2 + q3) + qdot1 * m4 * a1 * a3 * sin(q2 + q3) + qdot1 * m3 * a2 * a3 * sin((2 * q2) + q3) + qdot1 * m5 * a1 * a3 * sin(q2 + q3) + qdot1 * m2 * a2 * a3 * sin((2 * q2) + q3) + qdot1 * m1 * a1 * a3 * sin(q2 + q3) - qdot4 * m3 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 - qdot4 * m3 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 - qdot5 * m3 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 + qdot5 * m3 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 - qdot5 * m3 * d6 * a3 * cos(q5 + q3 + q2) / 0.4e1 + qdot5 * m3 * d6 * a3 * cos(-q5 + q3 + q2) / 0.4e1 - qdot5 * m4 * d6 * a3 * cos(q5 + q3 + q2) / 0.4e1 + qdot5 * m4 * d6 * a3 * cos(-q5 + q3 + q2) / 0.4e1 - qdot1 * I3x * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot1 * I3y * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 - qdot1 * I2x * sin((2 * q2)) / 0.2e1 + qdot1 * I2y * sin((2 * q2)) / 0.2e1 - qdot3 * m2 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 - qdot1 * m1 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m1 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m1 * a3 * d6 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * m1 * a3 * d6 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m1 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.2e1 - qdot1 * m1 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.2e1 - qdot1 * m1 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m1 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot1 * m2 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m2 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m4 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.2e1 - qdot1 * m4 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m4 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot1 * m2 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.2e1 + qdot1 * m2 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.2e1 - qdot1 * m2 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m6 * d6 * a2 * cos(q5 + q4 + q3 + (2 * q2)) / 0.2e1 - qdot1 * m6 * d6 * a2 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.2e1 - qdot1 * m4 * a3 * d6 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m4 * a3 * d6 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * m4 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.2e1 - qdot1 * m5 * d6 * a1 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m5 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * m5 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * m3 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m5 * d6 * a1 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m5 * d6 * a2 * cos(q5 + q4 + q3 + (2 * q2)) / 0.2e1 - qdot1 * m5 * d6 * a2 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.2e1 + qdot1 * m6 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * m6 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m6 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot1 * m6 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m6 * d6 * a1 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot1 * m6 * d6 * a1 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot1 * m3 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m3 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot1 * m4 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m4 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m3 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * m3 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.2e1 + qdot1 * m3 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.2e1 - qdot1 * m5 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m5 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 + qdot1 * m2 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot1 * m2 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m2 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * m3 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m3 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 + qdot5 * m5 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot5 * m5 * d6 * a2 * cos(q5 + q2) / 0.2e1 + qdot5 * m6 * d6 * a3 * cos(-q5 + q3 + q2) / 0.2e1 - qdot5 * m6 * d6 * a3 * cos(q5 + q3 + q2) / 0.2e1 + qdot5 * m6 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot5 * m6 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot5 * m6 * d6 * a2 * cos(q5 + q2) / 0.2e1 + qdot5 * m5 * d6 * a3 * cos(-q5 + q3 + q2) / 0.2e1 - qdot5 * m5 * d6 * a3 * cos(q5 + q3 + q2) / 0.2e1 + qdot5 * m5 * d6 * a2 * cos(-q5 + q2) / 0.2e1 - qdot5 * m5 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot5 * m6 * d6 * a2 * cos(-q5 + q2) / 0.2e1 + qdot1 * m4 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot1 * m2 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot1 * m1 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot1 * m6 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot1 * m3 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot1 * m5 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 - qdot4 * m3 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot4 * m3 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot5 * m3 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * m3 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 -qdot1 * I4x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * I4z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * I5x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot1 * I5z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * I5y * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * I6z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * I6x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot5 * I6y * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot5 * I6y * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot5 * I6x * sin(q2 + q3 + q4) / 0.4e1 - qdot5 * I6y * sin(q2 + q3 + q4) / 0.4e1 - qdot5 * sin(q2 + q3 + q4) * I5y / 0.2e1 + qdot5 * I5x * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * I5x * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot5 * I5z * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot5 * I5z * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * I6x * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot5 * I6x * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot5 * I6z * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot5 * I6z * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot5 * I6x * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot5 * I6y * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot5 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot5 * I6y * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot5 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot5 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot5 * I6x * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot6 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot6 * I6x * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot6 * I6y * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot6 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot6 * I6y * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot6 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot6 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot6 * I6x * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot1 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 - qdot1 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot1 * I6x * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6y * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + 0.3e1 / 0.16e2 * qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) - qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 - qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 + qdot1 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 + qdot1 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 + qdot1 * I6y * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + 0.3e1 / 0.16e2 * qdot1 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) - 0.3e1 / 0.16e2 * qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + qdot5 * m6 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * m4 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * m5 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * m6 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot5 * m5 * d6 ^ 2 * sin(q2 + q3 + q4) / 0.2e1 - qdot5 * m6 * d6 ^ 2 * sin(q2 + q3 + q4) / 0.2e1 + qdot1 * I6y * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - 0.3e1 / 0.16e2 * qdot1 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) - qdot1 * I6x * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 + qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot1 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot5 * I6x * sin(-(2 * q6) + q4 + q3 + q2) / 0.8e1 + qdot5 * I6y * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot5 * I6y * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot5 * I6x * sin((2 * q6) + q4 + q3 + q2) / 0.8e1 + qdot5 * I6x * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot5 * I6x * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot5 * I6y * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot5 * I6y * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot5 * I6x * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot5 * I6x * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot5 * I6y * sin((2 * q6) + q4 + q3 + q2) / 0.8e1 - qdot5 * I6y * sin(-(2 * q6) + q4 + q3 + q2) / 0.8e1 - qdot1 * m4 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m4 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m1 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m1 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m2 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m2 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m5 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m5 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m3 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m3 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m6 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m6 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot2 * m2 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot2 * m2 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot1 * I6x * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot1 * I6x * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot1 * I6y * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot1 * I6y * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot1 * I5x * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * I5x * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * I5z * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * I5z * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * I6z * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * I6z * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot6 * I6y * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot6 * I6y * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot6 * I6x * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot6 * I6x * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot6 * I6y * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot6 * I6y * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot6 * I6x * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot6 * I6x * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot6 * I6z * sin(q2 + q3 + q4 - q5) / 0.4e1 + qdot6 * I6z * sin(q2 + q3 + q4 + q5) / 0.4e1 + qdot1 * m3 * a2 * a4 * sin(q3 + q4) / 0.2e1 - qdot5 * m4 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 + qdot5 * m4 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 + qdot1 * m1 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m1 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot1 * m1 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 + qdot1 * m2 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m5 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 + qdot1 * m4 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 + qdot1 * m2 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 + qdot1 * m4 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot1 * m6 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot1 * m3 * a4 * a3 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot1 * m6 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m1 * a2 * a4 * sin(q3 + q4) / 0.2e1 + qdot1 * m6 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 + qdot1 * m3 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m4 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m3 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 + qdot1 * m5 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot1 * m5 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m2 * a4 * a3 * sin((2 * q2) + 0.2e1 * q3 + q4) + qdot1 * m5 * a2 * a4 * sin(q3 + q4) / 0.2e1 + qdot1 * m4 * a2 * a4 * sin(q3 + q4) / 0.2e1 + qdot1 * m6 * a2 * a4 * sin(q3 + q4) / 0.2e1 + qdot1 * m2 * a2 * a4 * sin(q3 + q4) / 0.2e1 + qdot1 * m4 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m1 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m1 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m2 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m2 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m5 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m4 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m6 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m3 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m5 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m6 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m3 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot5 * m5 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * m4 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot1 * m1 * a3 * a2 * sin((2 * q2) + q3) / 0.2e1 + qdot1 * m2 * a1 * a3 * sin(q2 + q3) + qdot1 * m5 * a2 * a3 * sin((2 * q2) + q3) / 0.2e1 + qdot1 * m6 * a2 * a3 * sin((2 * q2) + q3) / 0.2e1 + qdot1 * m4 * a2 * a3 * sin((2 * q2) + q3) / 0.2e1 + qdot1 * m6 * a1 * a3 * sin(q2 + q3) + qdot1 * m1 * a3 * a2 * sin(q3) / 0.2e1 + qdot1 * m3 * a1 * a3 * sin(q2 + q3) + qdot1 * m4 * a1 * a3 * sin(q2 + q3) + qdot1 * m3 * a2 * a3 * sin((2 * q2) + q3) / 0.2e1 + qdot1 * m5 * a1 * a3 * sin(q2 + q3) + qdot1 * m2 * a2 * a3 * sin((2 * q2) + q3) / 0.2e1 + qdot1 * m1 * a1 * a3 * sin(q2 + q3) + qdot1 * m2 * a2 * a3 * sin(q3) / 0.2e1 + qdot1 * m3 * a2 * a3 * sin(q3) / 0.2e1 + qdot1 * m4 * a2 * a3 * sin(q3) / 0.2e1 + qdot1 * m6 * a2 * a3 * sin(q3) / 0.2e1 + qdot1 * m5 * a2 * a3 * sin(q3) / 0.2e1 - qdot4 * m3 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 - qdot4 * m3 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 - qdot5 * m3 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 + qdot5 * m3 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 - qdot5 * m3 * d6 * a3 * cos(q5 + q3 + q2) / 0.4e1 + qdot5 * m3 * d6 * a3 * cos(-q5 + q3 + q2) / 0.4e1 - qdot5 * m4 * d6 * a3 * cos(q5 + q3 + q2) / 0.4e1 + qdot5 * m4 * d6 * a3 * cos(-q5 + q3 + q2) / 0.4e1 - qdot1 * I3x * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot1 * I3y * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot1 * m6 * d6 * a2 * cos(q5 + q4 + q3) / 0.4e1 + qdot1 * m5 * d6 * a2 * cos(q5 + q4 + q3) / 0.4e1 - qdot1 * m5 * d6 * a2 * cos(-q5 + q4 + q3) / 0.4e1 - qdot1 * m6 * d6 * a2 * cos(-q5 + q4 + q3) / 0.4e1 - qdot1 * m2 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 + qdot1 * m2 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 + qdot1 * m4 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 - qdot1 * m4 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 - qdot1 * m1 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m1 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m1 * a3 * d6 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * m1 * a3 * d6 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m1 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m1 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m1 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m1 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot1 * m2 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m2 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m4 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m4 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m4 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot1 * m2 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m2 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m2 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m6 * d6 * a2 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m6 * d6 * a2 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m4 * a3 * d6 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m4 * a3 * d6 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * m4 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m5 * d6 * a1 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m5 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * m5 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * m3 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m5 * d6 * a1 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot1 * m1 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 + qdot1 * m1 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 + qdot1 * m5 * d6 * a2 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m5 * d6 * a2 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m6 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * m6 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m6 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot1 * m6 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m6 * d6 * a1 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot1 * m6 * d6 * a1 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot1 * m3 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m3 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot1 * m4 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m4 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m3 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * m3 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m3 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m5 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m5 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 + qdot1 * m2 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot1 * m2 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m2 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * m3 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m3 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot1 * m3 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 + qdot1 * m3 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 + qdot2 * m2 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 + qdot2 * m2 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 + qdot2 * m2 * a3 * d6 * cos(q5 + q3 + q2) / 0.4e1 + qdot2 * m2 * a3 * d6 * cos(-q5 + q3 + q2) / 0.4e1 + qdot5 * m5 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot5 * m6 * d6 * a3 * cos(-q5 + q3 + q2) / 0.2e1 - qdot5 * m6 * d6 * a3 * cos(q5 + q3 + q2) / 0.2e1 + qdot5 * m6 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot5 * m6 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot5 * m5 * d6 * a3 * cos(-q5 + q3 + q2) / 0.2e1 - qdot5 * m5 * d6 * a3 * cos(q5 + q3 + q2) / 0.2e1 - qdot5 * m5 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m4 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot1 * m2 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot1 * m1 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot1 * m6 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot1 * m3 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 + qdot1 * m5 * a3 ^ 2 * sin((2 * q2) + 0.2e1 * q3) / 0.2e1 - qdot4 * m3 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot4 * m3 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot5 * m3 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * m3 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 -qdot1 * I4x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * I4z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * I5x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot1 * I5z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * I5y * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 - qdot1 * I6z * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * I6x * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot5 * I6y * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot5 * I6y * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot5 * I6x * sin(q2 + q3 + q4) / 0.4e1 - qdot5 * I6y * sin(q2 + q3 + q4) / 0.4e1 - qdot5 * sin(q2 + q3 + q4) * I5y / 0.2e1 + qdot5 * I5x * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * I5x * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot5 * I5z * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot5 * I5z * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * I6x * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot5 * I6x * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot5 * I6z * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot5 * I6z * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot5 * I6x * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot5 * I6y * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot5 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot5 * I6y * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot5 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot5 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot5 * I6x * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot6 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot6 * I6x * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot6 * I6y * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot6 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot6 * I6y * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot6 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot6 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot6 * I6x * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot1 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 - qdot1 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot1 * I6x * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6y * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + 0.3e1 / 0.16e2 * qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) - qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 - qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 + qdot1 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 + qdot1 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 + qdot1 * I6y * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + 0.3e1 / 0.16e2 * qdot1 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) - 0.3e1 / 0.16e2 * qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + qdot5 * m6 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * m4 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * m5 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * m6 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot5 * m5 * d6 ^ 2 * sin(q2 + q3 + q4) / 0.2e1 - qdot5 * m6 * d6 ^ 2 * sin(q2 + q3 + q4) / 0.2e1 + qdot1 * I6y * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - 0.3e1 / 0.16e2 * qdot1 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) - qdot1 * I6x * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 + qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot1 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot5 * I6x * sin(-(2 * q6) + q4 + q3 + q2) / 0.8e1 + qdot5 * I6y * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot5 * I6y * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot5 * I6x * sin((2 * q6) + q4 + q3 + q2) / 0.8e1 + qdot5 * I6x * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot5 * I6x * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot5 * I6y * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot5 * I6y * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot5 * I6x * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot5 * I6x * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot5 * I6y * sin((2 * q6) + q4 + q3 + q2) / 0.8e1 - qdot5 * I6y * sin(-(2 * q6) + q4 + q3 + q2) / 0.8e1 - qdot1 * m4 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m4 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m1 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m1 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m2 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m2 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m5 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m5 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m3 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m3 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m6 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m6 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot2 * m3 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot2 * m3 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot2 * m2 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot2 * m2 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot3 * m3 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot3 * m3 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot1 * I6x * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot1 * I6x * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot1 * I6y * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot1 * I6y * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot1 * I5x * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * I5x * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * I5z * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * I5z * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * I6z * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * I6z * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot6 * I6y * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot6 * I6y * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot6 * I6x * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot6 * I6x * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot6 * I6y * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot6 * I6y * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot6 * I6x * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot6 * I6x * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot6 * I6z * sin(q2 + q3 + q4 - q5) / 0.4e1 + qdot6 * I6z * sin(q2 + q3 + q4 + q5) / 0.4e1 + qdot1 * m3 * a2 * a4 * sin(q3 + q4) / 0.2e1 + qdot1 * m4 * a3 * a4 * sin(q4) / 0.2e1 + qdot1 * m6 * a3 * a4 * sin(q4) / 0.2e1 + qdot1 * m5 * a3 * a4 * sin(q4) / 0.2e1 + qdot1 * m3 * a3 * a4 * sin(q4) / 0.2e1 + qdot1 * m2 * a3 * a4 * sin(q4) / 0.2e1 - qdot5 * m4 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 + qdot5 * m4 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 + qdot1 * m1 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m1 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) / 0.2e1 + qdot1 * m1 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 + qdot1 * m2 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m5 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 + qdot1 * m4 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 + qdot1 * m2 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 + qdot1 * m4 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) / 0.2e1 + qdot1 * m6 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) / 0.2e1 + qdot1 * m3 * a4 * a3 * sin((2 * q2) + 0.2e1 * q3 + q4) / 0.2e1 + qdot1 * m6 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m1 * a2 * a4 * sin(q3 + q4) / 0.2e1 + qdot1 * m1 * a3 * a4 * sin(q4) / 0.2e1 + qdot1 * m6 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 + qdot1 * m3 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m4 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m3 * a2 * a4 * sin((2 * q2) + q3 + q4) / 0.2e1 + qdot1 * m5 * a3 * a4 * sin((2 * q2) + 0.2e1 * q3 + q4) / 0.2e1 + qdot1 * m5 * a1 * a4 * sin(q2 + q3 + q4) + qdot1 * m2 * a4 * a3 * sin((2 * q2) + 0.2e1 * q3 + q4) / 0.2e1 + qdot1 * m5 * a2 * a4 * sin(q3 + q4) / 0.2e1 + qdot1 * m4 * a2 * a4 * sin(q3 + q4) / 0.2e1 + qdot1 * m6 * a2 * a4 * sin(q3 + q4) / 0.2e1 + qdot1 * m2 * a2 * a4 * sin(q3 + q4) / 0.2e1 + qdot1 * m4 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m1 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m1 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m2 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m2 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m5 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m4 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m6 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m3 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m5 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m6 * a4 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.2e1 + qdot1 * m3 * d6 ^ 2 * sin(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot5 * m5 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot5 * m4 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot1 * m6 * d6 * a2 * cos(q5 + q4 + q3) / 0.4e1 + qdot1 * m5 * d6 * a2 * cos(q5 + q4 + q3) / 0.4e1 - qdot1 * m5 * d6 * a2 * cos(-q5 + q4 + q3) / 0.4e1 - qdot1 * m6 * d6 * a2 * cos(-q5 + q4 + q3) / 0.4e1 - qdot1 * m2 * a3 * d6 * cos(-q5 + q4) / 0.4e1 + qdot1 * m2 * a3 * d6 * cos(q5 + q4) / 0.4e1 - qdot1 * m2 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 + qdot1 * m2 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 + qdot1 * m4 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 - qdot1 * m4 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 - qdot1 * m4 * a3 * d6 * cos(-q5 + q4) / 0.4e1 + qdot1 * m4 * a3 * d6 * cos(q5 + q4) / 0.4e1 - qdot1 * m1 * a3 * d6 * cos(-q5 + q4) / 0.4e1 + qdot1 * m1 * a3 * d6 * cos(q5 + q4) / 0.4e1 - qdot1 * m1 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m1 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m1 * a3 * d6 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot1 * m1 * a3 * d6 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m1 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m1 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m1 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m1 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot1 * m2 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m2 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m4 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m4 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m4 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot1 * m2 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m2 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m2 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m6 * d6 * a2 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m6 * d6 * a2 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m4 * a3 * d6 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m4 * a3 * d6 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot1 * m4 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m5 * d6 * a1 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m5 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot1 * m5 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot1 * m3 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m5 * d6 * a1 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot1 * m1 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 + qdot1 * m1 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 + qdot1 * m5 * d6 * a2 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m5 * d6 * a2 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m6 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot1 * m6 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m6 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot1 * m6 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m6 * d6 * a1 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot1 * m6 * d6 * a1 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot1 * m3 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m3 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot1 * m4 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m4 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m3 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot1 * m3 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m3 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 - qdot1 * m5 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m5 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 + qdot1 * m2 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot1 * m2 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m2 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 - qdot1 * m3 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.2e1 + qdot1 * m3 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.2e1 - qdot1 * m3 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 + qdot1 * m3 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 + qdot1 * m5 * d6 * a3 * cos(q5 + q4) / 0.4e1 - qdot1 * m5 * d6 * a3 * cos(-q5 + q4) / 0.4e1 + qdot1 * m6 * d6 * a3 * cos(q5 + q4) / 0.4e1 - qdot1 * m6 * d6 * a3 * cos(-q5 + q4) / 0.4e1 - qdot1 * m3 * a3 * d6 * cos(-q5 + q4) / 0.4e1 + qdot1 * m3 * a3 * d6 * cos(q5 + q4) / 0.4e1 + qdot2 * m2 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 + qdot2 * m2 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 + qdot2 * m3 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 + qdot2 * m3 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 + qdot3 * m3 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 + qdot3 * m3 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 + qdot5 * m5 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot5 * m6 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot5 * m6 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot5 * m5 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.2e1 -qdot1 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.16e2 + qdot1 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.16e2 - qdot1 * I6x * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot1 * I6y * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.16e2 + qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.16e2 - qdot1 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.16e2 - qdot1 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.16e2 + qdot1 * I6y * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6x * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.16e2 - qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.16e2 + qdot1 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot1 * I6y * sin((2 * q6) + 0.2e1 * q5) / 0.16e2 + qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q5) / 0.16e2 + qdot1 * I6x * sin((2 * q6) + 0.2e1 * q5) / 0.16e2 - qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q5) / 0.16e2 - qdot2 * I6y * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot2 * I6y * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot2 * I6x * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot2 * I6x * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot2 * I6y * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot2 * I6y * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot2 * I6x * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot2 * I6x * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot2 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot2 * I6x * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot2 * I6y * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot2 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot2 * I6y * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot2 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot2 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot2 * I6x * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot3 * I6y * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot3 * I6y * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot3 * I6x * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot3 * I6x * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot3 * I6y * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot3 * I6y * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot3 * I6x * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot3 * I6x * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot3 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot3 * I6x * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot3 * I6y * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot3 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot3 * I6y * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot3 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot3 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot3 * I6x * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot4 * I6y * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot4 * I6y * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot4 * I6x * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot4 * I6x * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot4 * I6y * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot4 * I6y * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot4 * I6x * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot4 * I6x * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot4 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot4 * I6x * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot4 * I6y * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot4 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot4 * I6y * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot4 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot4 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot4 * I6x * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot1 * m3 * d6 ^ 2 * sin(0.2e1 * q5) / 0.4e1 - qdot1 * m4 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * m4 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * m1 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m1 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * m2 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m2 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * m5 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m5 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m3 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * m3 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * m6 * d6 ^ 2 * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * m6 * d6 ^ 2 * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * m1 * d6 ^ 2 * sin(0.2e1 * q5) / 0.4e1 + qdot1 * m4 * d6 ^ 2 * sin(0.2e1 * q5) / 0.4e1 + qdot1 * m5 * d6 ^ 2 * sin(0.2e1 * q5) / 0.4e1 + qdot1 * m6 * d6 ^ 2 * sin(0.2e1 * q5) / 0.4e1 + qdot1 * m2 * d6 ^ 2 * sin(0.2e1 * q5) / 0.4e1 - qdot2 * m3 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot2 * m3 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot2 * m5 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot2 * m4 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot2 * m6 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot2 * m4 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot2 * m5 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot2 * m6 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot2 * m5 * d6 ^ 2 * sin(q2 + q3 + q4) / 0.2e1 + qdot2 * m6 * d6 ^ 2 * sin(q2 + q3 + q4) / 0.2e1 - qdot2 * m2 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot2 * m2 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot3 * m3 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot3 * m3 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot3 * m5 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot3 * m4 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot3 * m6 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot3 * m4 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot3 * m5 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot3 * m6 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot3 * m5 * d6 ^ 2 * sin(q2 + q3 + q4) / 0.2e1 + qdot3 * m6 * d6 ^ 2 * sin(q2 + q3 + q4) / 0.2e1 - qdot4 * m5 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot4 * m4 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot4 * m6 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot4 * m4 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot4 * m5 * d6 ^ 2 * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot4 * m6 * d6 ^ 2 * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot4 * m5 * d6 ^ 2 * sin(q2 + q3 + q4) / 0.2e1 + qdot4 * m6 * d6 ^ 2 * sin(q2 + q3 + q4) / 0.2e1 - qdot1 * I6z * sin(0.2e1 * q5) / 0.4e1 + qdot1 * I6x * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot1 * I6x * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 + qdot1 * I6y * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 - qdot1 * I6y * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.16e2 + qdot1 * I5x * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * I5x * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * I5z * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * I5z * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 - qdot1 * I6z * sin(-0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * I6z * sin(0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.8e1 + qdot1 * I5x * sin(0.2e1 * q5) / 0.4e1 - qdot1 * I5z * sin(0.2e1 * q5) / 0.4e1 - qdot2 * I6x * sin(-(2 * q6) + q4 + q3 + q2) / 0.8e1 - qdot2 * I6x * sin((2 * q6) + q4 + q3 + q2) / 0.8e1 + qdot2 * I6y * sin((2 * q6) + q4 + q3 + q2) / 0.8e1 + qdot2 * I6y * sin(-(2 * q6) + q4 + q3 + q2) / 0.8e1 - qdot2 * I6y * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot2 * I6y * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot2 * I6x * sin(q2 + q3 + q4) / 0.4e1 + qdot2 * I6y * sin(q2 + q3 + q4) / 0.4e1 + qdot2 * sin(q2 + q3 + q4) * I5y / 0.2e1 - qdot2 * I5x * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot2 * I5x * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot2 * I5z * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot2 * I5z * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot2 * I6x * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot2 * I6x * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot2 * I6z * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot2 * I6z * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot3 * I6x * sin(-(2 * q6) + q4 + q3 + q2) / 0.8e1 - qdot3 * I6x * sin((2 * q6) + q4 + q3 + q2) / 0.8e1 + qdot3 * I6y * sin((2 * q6) + q4 + q3 + q2) / 0.8e1 + qdot3 * I6y * sin(-(2 * q6) + q4 + q3 + q2) / 0.8e1 - qdot3 * I6y * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot3 * I6y * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot3 * I6x * sin(q2 + q3 + q4) / 0.4e1 + qdot3 * I6y * sin(q2 + q3 + q4) / 0.4e1 + qdot3 * sin(q2 + q3 + q4) * I5y / 0.2e1 - qdot3 * I5x * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot3 * I5x * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot3 * I5z * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot3 * I5z * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot3 * I6x * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot3 * I6x * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot3 * I6z * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot3 * I6z * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot4 * I6x * sin(-(2 * q6) + q4 + q3 + q2) / 0.8e1 - qdot4 * I6x * sin((2 * q6) + q4 + q3 + q2) / 0.8e1 + qdot4 * I6y * sin((2 * q6) + q4 + q3 + q2) / 0.8e1 + qdot4 * I6y * sin(-(2 * q6) + q4 + q3 + q2) / 0.8e1 - qdot4 * I6y * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot4 * I6y * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot4 * I6x * sin(q2 + q3 + q4) / 0.4e1 + qdot4 * I6y * sin(q2 + q3 + q4) / 0.4e1 + qdot4 * sin(q2 + q3 + q4) * I5y / 0.2e1 - qdot4 * I5x * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot4 * I5x * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot4 * I5z * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot4 * I5z * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 - qdot4 * I6x * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 - qdot4 * I6x * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.8e1 + qdot4 * I6z * sin(-0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot4 * I6z * sin(0.2e1 * q5 + q4 + q3 + q2) / 0.4e1 + qdot6 * I6x * sin(-(2 * q6) + q4 + q3 + q2) / 0.4e1 + qdot6 * I6y * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot6 * I6y * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot6 * I6x * sin((2 * q6) + q4 + q3 + q2) / 0.4e1 - qdot6 * I6x * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot6 * I6x * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot6 * I6y * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot6 * I6y * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot6 * I6x * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot6 * I6x * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot6 * I6y * sin((2 * q6) + q4 + q3 + q2) / 0.4e1 - qdot6 * I6y * sin(-(2 * q6) + q4 + q3 + q2) / 0.4e1 + qdot6 * I6z * sin(q2 + q3 + q4 - q5) / 0.4e1 + qdot6 * I6z * sin(q2 + q3 + q4 + q5) / 0.4e1 + qdot1 * I6y * sin(0.2e1 * q5) / 0.8e1 + qdot1 * I6x * sin(0.2e1 * q5) / 0.8e1 - qdot2 * m6 * d6 * a2 * cos(-q5 + q2) / 0.2e1 - qdot2 * m5 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot2 * m6 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot2 * m6 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot2 * m5 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot3 * m5 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot3 * m6 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot3 * m6 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot3 * m5 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot4 * m5 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.2e1 - qdot4 * m6 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot4 * m6 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot4 * m5 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.2e1 - qdot2 * m6 * d6 * a3 * cos(-q5 + q3 + q2) / 0.2e1 + qdot2 * m6 * d6 * a3 * cos(q5 + q3 + q2) / 0.2e1 - qdot2 * m5 * d6 * a3 * cos(-q5 + q3 + q2) / 0.2e1 + qdot2 * m5 * d6 * a3 * cos(q5 + q3 + q2) / 0.2e1 - qdot3 * m6 * d6 * a3 * cos(-q5 + q3 + q2) / 0.2e1 + qdot3 * m6 * d6 * a3 * cos(q5 + q3 + q2) / 0.2e1 - qdot3 * m5 * d6 * a3 * cos(-q5 + q3 + q2) / 0.2e1 + qdot3 * m5 * d6 * a3 * cos(q5 + q3 + q2) / 0.2e1 + qdot2 * m5 * d6 * a2 * cos(q5 + q2) / 0.2e1 + qdot2 * m6 * d6 * a2 * cos(q5 + q2) / 0.2e1 - qdot2 * m5 * d6 * a2 * cos(-q5 + q2) / 0.2e1 + qdot1 * m6 * d6 * a2 * cos(q5 + q4 + q3) / 0.4e1 + qdot1 * m5 * d6 * a2 * cos(q5 + q4 + q3) / 0.4e1 + qdot1 * m5 * d6 * a2 * cos(-q5 + q4 + q3) / 0.4e1 + qdot1 * m6 * d6 * a2 * cos(-q5 + q4 + q3) / 0.4e1 + qdot1 * m2 * a3 * d6 * cos(-q5 + q4) / 0.4e1 + qdot1 * m2 * a3 * d6 * cos(q5 + q4) / 0.4e1 + qdot1 * m2 * d6 * a4 * cos(q5) / 0.2e1 + qdot1 * m2 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 + qdot1 * m2 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 + qdot1 * m4 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 + qdot1 * m4 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 + qdot1 * m4 * a3 * d6 * cos(-q5 + q4) / 0.4e1 + qdot1 * m4 * a3 * d6 * cos(q5 + q4) / 0.4e1 + qdot1 * m6 * d6 * a4 * cos(q5) / 0.2e1 + qdot1 * m5 * d6 * a4 * cos(q5) / 0.2e1 + qdot1 * m4 * d6 * a4 * cos(q5) / 0.2e1 + qdot1 * m1 * a3 * d6 * cos(-q5 + q4) / 0.4e1 + qdot1 * m1 * a3 * d6 * cos(q5 + q4) / 0.4e1 + qdot1 * m1 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m1 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m1 * a3 * d6 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m1 * a3 * d6 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m1 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m1 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m1 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.4e1 + qdot1 * m1 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.4e1 + qdot1 * m2 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m2 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m4 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m4 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.4e1 + qdot1 * m4 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.4e1 + qdot1 * m2 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m2 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m2 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.4e1 + qdot1 * m6 * d6 * a2 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m6 * d6 * a2 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m4 * a3 * d6 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m4 * a3 * d6 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m4 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m5 * d6 * a1 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m5 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m5 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m3 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m5 * d6 * a1 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m1 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 + qdot1 * m1 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 + qdot1 * m1 * a4 * d6 * cos(q5) / 0.2e1 + qdot1 * m5 * d6 * a2 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m5 * d6 * a2 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m6 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m6 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m6 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.4e1 + qdot1 * m6 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.4e1 + qdot1 * m6 * d6 * a1 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m6 * d6 * a1 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m3 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m3 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m4 * a1 * d6 * cos(q2 + q3 + q4 - q5) / 0.2e1 + qdot1 * m4 * a1 * d6 * cos(q2 + q3 + q4 + q5) / 0.2e1 + qdot1 * m3 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m3 * a2 * d6 * cos(-q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m3 * a2 * d6 * cos(q5 + q4 + q3 + (2 * q2)) / 0.4e1 + qdot1 * m5 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.4e1 + qdot1 * m5 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.4e1 + qdot1 * m2 * d6 * a4 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.4e1 + qdot1 * m2 * d6 * a3 * cos(-q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m2 * d6 * a3 * cos(q5 + q4 + 0.2e1 * q3 + (2 * q2)) / 0.4e1 + qdot1 * m3 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.4e1 + qdot1 * m3 * a4 * d6 * cos(0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.4e1 + qdot1 * m3 * a2 * d6 * cos(-q5 + q4 + q3) / 0.4e1 + qdot1 * m3 * a2 * d6 * cos(q5 + q4 + q3) / 0.4e1 + qdot1 * m5 * d6 * a3 * cos(q5 + q4) / 0.4e1 + qdot1 * m5 * d6 * a3 * cos(-q5 + q4) / 0.4e1 + qdot1 * m6 * d6 * a3 * cos(q5 + q4) / 0.4e1 + qdot1 * m6 * d6 * a3 * cos(-q5 + q4) / 0.4e1 + qdot1 * m3 * a3 * d6 * cos(-q5 + q4) / 0.4e1 + qdot1 * m3 * a3 * d6 * cos(q5 + q4) / 0.4e1 + qdot1 * m3 * d6 * a4 * cos(q5) / 0.2e1 + qdot2 * m2 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 - qdot2 * m2 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 + qdot2 * m2 * a3 * d6 * cos(q5 + q3 + q2) / 0.4e1 - qdot2 * m2 * a3 * d6 * cos(-q5 + q3 + q2) / 0.4e1 + qdot2 * m2 * a2 * d6 * cos(q5 + q2) / 0.4e1 - qdot2 * m2 * a2 * d6 * cos(-q5 + q2) / 0.4e1 + qdot2 * m3 * a2 * d6 * cos(q5 + q2) / 0.4e1 - qdot2 * m3 * a2 * d6 * cos(-q5 + q2) / 0.4e1 + qdot2 * m4 * a2 * d6 * cos(q5 + q2) / 0.4e1 - qdot2 * m4 * a2 * d6 * cos(-q5 + q2) / 0.4e1 + qdot2 * m4 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 - qdot2 * m4 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 + qdot2 * m3 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 - qdot2 * m3 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 + qdot2 * m3 * d6 * a3 * cos(q5 + q3 + q2) / 0.4e1 - qdot2 * m3 * d6 * a3 * cos(-q5 + q3 + q2) / 0.4e1 + qdot2 * m4 * d6 * a3 * cos(q5 + q3 + q2) / 0.4e1 - qdot2 * m4 * d6 * a3 * cos(-q5 + q3 + q2) / 0.4e1 + qdot3 * m4 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 - qdot3 * m4 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 + qdot3 * m3 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 - qdot3 * m3 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 + qdot3 * m3 * d6 * a3 * cos(q5 + q3 + q2) / 0.4e1 - qdot3 * m3 * d6 * a3 * cos(-q5 + q3 + q2) / 0.4e1 + qdot3 * m4 * d6 * a3 * cos(q5 + q3 + q2) / 0.4e1 - qdot3 * m4 * d6 * a3 * cos(-q5 + q3 + q2) / 0.4e1 + qdot4 * m4 * d6 * a4 * cos(q2 + q3 + q4 + q5) / 0.4e1 - qdot4 * m4 * d6 * a4 * cos(q2 + q3 + q4 - q5) / 0.4e1 -qdot1 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 - qdot1 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot1 * I6x * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6y * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 + qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 - qdot1 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 + qdot1 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 + qdot1 * I6y * sin((2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + 0.3e1 / 0.16e2 * qdot1 * I6y * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) + 0.3e1 / 0.16e2 * qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) - 0.3e1 / 0.16e2 * qdot1 * I6x * sin((2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) - qdot1 * I6x * sin((2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) + q5) / 0.8e1 - qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2) - q5) / 0.8e1 + qdot1 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 + qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + 0.2e1 * q4 + 0.2e1 * q3 + (2 * q2)) / 0.32e2 - qdot1 * I6x * sin((2 * q6)) / 0.8e1 + qdot1 * I6y * sin((2 * q6)) / 0.8e1 - qdot1 * I6y * sin((2 * q6) + 0.2e1 * q5) / 0.16e2 - qdot1 * I6x * sin(-(2 * q6) + 0.2e1 * q5) / 0.16e2 + qdot1 * I6x * sin((2 * q6) + 0.2e1 * q5) / 0.16e2 + qdot1 * I6y * sin(-(2 * q6) + 0.2e1 * q5) / 0.16e2 - qdot2 * I6y * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot2 * I6y * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot2 * I6x * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot2 * I6x * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot2 * I6y * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot2 * I6y * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot2 * I6x * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot2 * I6x * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot2 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot2 * I6x * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot2 * I6y * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot2 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot2 * I6y * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot2 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot2 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot2 * I6x * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot2 * I6z * sin(q2 + q3 + q4 - q5) / 0.4e1 - qdot2 * I6z * sin(q2 + q3 + q4 + q5) / 0.4e1 - qdot3 * I6y * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot3 * I6y * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot3 * I6x * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot3 * I6x * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot3 * I6y * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot3 * I6y * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot3 * I6x * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot3 * I6x * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot3 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot3 * I6x * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot3 * I6y * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot3 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot3 * I6y * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot3 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot3 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot3 * I6x * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot3 * I6z * sin(q2 + q3 + q4 - q5) / 0.4e1 - qdot3 * I6z * sin(q2 + q3 + q4 + q5) / 0.4e1 - qdot4 * I6y * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot4 * I6y * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot4 * I6x * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot4 * I6x * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot4 * I6y * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot4 * I6y * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot4 * I6x * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot4 * I6x * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot4 * I6x * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot4 * I6x * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot4 * I6y * sin((2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot4 * I6y * sin(-(2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot4 * I6y * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot4 * I6y * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot4 * I6x * sin(-(2 * q6) - 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 - qdot4 * I6x * sin((2 * q6) + 0.2e1 * q5 + q4 + q3 + q2) / 0.16e2 + qdot4 * I6z * sin(q2 + q3 + q4 - q5) / 0.4e1 - qdot4 * I6z * sin(q2 + q3 + q4 + q5) / 0.4e1 - qdot5 * I6x * sin(-(2 * q6) + q4 + q3 + q2) / 0.4e1 - qdot5 * I6y * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 - qdot5 * I6y * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 + qdot5 * I6x * sin((2 * q6) + q4 + q3 + q2) / 0.4e1 + qdot5 * I6x * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot5 * I6x * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot5 * I6y * sin(-(2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot5 * I6y * sin((2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot5 * I6x * sin(-(2 * q6) + q4 + q3 + q2 - q5) / 0.8e1 + qdot5 * I6x * sin((2 * q6) + q4 + q3 + q2 + q5) / 0.8e1 - qdot5 * I6y * sin((2 * q6) + q4 + q3 + q2) / 0.4e1 + qdot5 * I6y * sin(-(2 * q6) + q4 + q3 + q2) / 0.4e1 - qdot5 * I6z * sin(q2 + q3 + q4 - q5) / 0.4e1 - qdot5 * I6z * sin(q2 + q3 + q4 + q5) / 0.4e1]';

    C2 = [-qdot1 * m4 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 - qdot3 * m2 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * m2 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot4 * m2 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * m2 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot5 * m2 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m2 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I4x * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * I4z * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * I5x * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 + qdot1 * I5z * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * I5y * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * I6z * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * I6x * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot5 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot5 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot5 * I6x * sin((q2 + q3 + q4)) / 0.4e1 + qdot5 * I6y * sin((q2 + q3 + q4)) / 0.4e1 + qdot5 * sin((q2 + q3 + q4)) * I5y / 0.2e1 + qdot5 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot5 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot5 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot5 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot5 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot5 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot5 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot5 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot5 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot5 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot5 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot5 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot5 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot6 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot6 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot6 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot6 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot6 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot6 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot6 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot6 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6y * sin((-2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6y * sin((2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * qdot1 * I6y * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) + qdot1 * I6y * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 + qdot1 * I6y * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((-2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6y * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * qdot1 * I6y * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) + 0.3e1 / 0.16e2 * qdot1 * I6x * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) + qdot5 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m5 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 + qdot5 * m6 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 - qdot1 * I6y * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + 0.3e1 / 0.16e2 * qdot1 * I6x * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) + qdot1 * I6x * sin((2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6x * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 + qdot1 * I6x * sin((-2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot2 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot2 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot2 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot2 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot2 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot2 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot2 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot2 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot2 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot3 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot3 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot3 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot3 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot3 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot3 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot3 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot3 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot4 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot4 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot4 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot4 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot4 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot4 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot4 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot4 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot5 * I6x * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot5 * I6x * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot5 * I6y * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot5 * I6y * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot1 * m4 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m4 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m1 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m1 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m2 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m2 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m5 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m5 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m3 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m3 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m6 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m6 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot2 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * m2 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m2 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m1 * a1 * a2 * sin(q2) - qdot1 * m6 * a1 * a2 * sin(q2) - qdot3 * m2 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot3 * m2 * a3 * d6 * cos((q5 + q3 + q2)) / 0.4e1 - qdot3 * m2 * a3 * d6 * cos((-q5 + q3 + q2)) / 0.4e1 - qdot4 * m2 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot4 * m2 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot5 * m2 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot5 * m2 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot5 * m2 * a3 * d6 * cos((q5 + q3 + q2)) / 0.4e1 + qdot5 * m2 * a3 * d6 * cos((-q5 + q3 + q2)) / 0.4e1 - qdot5 * m2 * a2 * d6 * cos((q5 + q2)) / 0.4e1 + qdot5 * m2 * a2 * d6 * cos((-q5 + q2)) / 0.4e1 - qdot5 * m3 * a2 * d6 * cos((q5 + q2)) / 0.4e1 + qdot5 * m3 * a2 * d6 * cos((-q5 + q2)) / 0.4e1 - qdot5 * m4 * a2 * d6 * cos((q5 + q2)) / 0.4e1 + qdot5 * m4 * a2 * d6 * cos((-q5 + q2)) / 0.4e1 + qdot1 * I6x * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 + qdot1 * I6y * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 + qdot1 * I6y * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 + qdot1 * I5x * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * I5x * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * I5z * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * I5z * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * I6z * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * I6z * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot2 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot6 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot6 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot6 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot6 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot6 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot6 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot6 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot6 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot6 * I6z * sin((q2 + q3 + q4 - q5)) / 0.4e1 - qdot6 * I6z * sin((q2 + q3 + q4 + q5)) / 0.4e1 - qdot2 * m6 * d6 * a2 * cos((-q5 + q2)) / 0.2e1 - qdot1 * m3 * a1 * a2 * sin(q2) - qdot1 * m4 * a1 * a2 * sin(q2) - qdot1 * m5 * a1 * a2 * sin(q2) - qdot1 * m2 * a1 * a2 * sin(q2) - qdot2 * m5 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot2 * m6 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot2 * m6 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot2 * m5 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot3 * m5 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot3 * m6 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot3 * m6 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot3 * m5 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot4 * m5 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot4 * m6 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot4 * m6 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot4 * m5 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot5 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot5 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot1 * m1 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m1 * a3 * a4 * sin((2 * q2 + 2 * q3 + q4)) - qdot1 * m1 * a2 * a4 * sin((2 * q2 + q3 + q4)) - qdot1 * m2 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m5 * a2 * a4 * sin((2 * q2 + q3 + q4)) - qdot1 * m4 * a2 * a4 * sin((2 * q2 + q3 + q4)) - qdot1 * m2 * a2 * a4 * sin((2 * q2 + q3 + q4)) - qdot1 * m4 * a3 * a4 * sin((2 * q2 + 2 * q3 + q4)) - qdot1 * m6 * a3 * a4 * sin((2 * q2 + 2 * q3 + q4)) - qdot1 * m3 * a4 * a3 * sin((2 * q2 + 2 * q3 + q4)) - qdot1 * m6 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m6 * a2 * a4 * sin((2 * q2 + q3 + q4)) - qdot1 * m3 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m4 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m3 * a2 * a4 * sin((2 * q2 + q3 + q4)) - qdot1 * m5 * a3 * a4 * sin((2 * q2 + 2 * q3 + q4)) - qdot1 * m5 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m2 * a4 * a3 * sin((2 * q2 + 2 * q3 + q4)) - qdot1 * m6 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 - qdot1 * m1 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 - qdot1 * m3 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 - qdot1 * m2 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 - qdot1 * m5 * a2 ^ 2 * sin((2 * q2)) / 0.2e1 - qdot1 * m4 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m1 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m1 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m2 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m2 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m5 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m4 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m6 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m3 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m5 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m6 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m3 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 + qdot5 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m1 * a3 * a2 * sin((2 * q2 + q3)) - qdot1 * m2 * a1 * a3 * sin((q2 + q3)) - qdot1 * m5 * a2 * a3 * sin((2 * q2 + q3)) - qdot1 * m6 * a2 * a3 * sin((2 * q2 + q3)) - qdot1 * m4 * a2 * a3 * sin((2 * q2 + q3)) - qdot1 * m6 * a1 * a3 * sin((q2 + q3)) - qdot1 * m3 * a1 * a3 * sin((q2 + q3)) - qdot1 * m4 * a1 * a3 * sin((q2 + q3)) - qdot1 * m3 * a2 * a3 * sin((2 * q2 + q3)) - qdot1 * m5 * a1 * a3 * sin((q2 + q3)) - qdot1 * m2 * a2 * a3 * sin((2 * q2 + q3)) - qdot1 * m1 * a1 * a3 * sin((q2 + q3)) - qdot2 * m6 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot2 * m6 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot2 * m5 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot2 * m5 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot3 * m6 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot3 * m6 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot3 * m5 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot3 * m5 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot4 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot4 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot5 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot5 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot5 * m3 * d6 * a3 * cos((q5 + q3 + q2)) / 0.4e1 + qdot5 * m3 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.4e1 - qdot5 * m4 * d6 * a3 * cos((q5 + q3 + q2)) / 0.4e1 + qdot5 * m4 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.4e1 + qdot1 * I3x * sin((2 * q2 + 2 * q3)) / 0.2e1 - qdot1 * I3y * sin((2 * q2 + 2 * q3)) / 0.2e1 + qdot1 * I2x * sin((2 * q2)) / 0.2e1 - qdot1 * I2y * sin((2 * q2)) / 0.2e1 - qdot3 * m2 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot2 * m5 * d6 * a2 * cos((q5 + q2)) / 0.2e1 - qdot2 * m6 * d6 * a2 * cos((q5 + q2)) / 0.2e1 - qdot2 * m5 * d6 * a2 * cos((-q5 + q2)) / 0.2e1 + qdot1 * m1 * a1 * d6 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m1 * a1 * d6 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m1 * a3 * d6 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * m1 * a3 * d6 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m1 * a2 * d6 * cos((q5 + q4 + q3 + 2 * q2)) / 0.2e1 + qdot1 * m1 * a2 * d6 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.2e1 + qdot1 * m1 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m1 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + qdot1 * m2 * a1 * d6 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m2 * a1 * d6 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m4 * a2 * d6 * cos((q5 + q4 + q3 + 2 * q2)) / 0.2e1 + qdot1 * m4 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m4 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + qdot1 * m2 * a2 * d6 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.2e1 - qdot1 * m2 * a2 * d6 * cos((q5 + q4 + q3 + 2 * q2)) / 0.2e1 + qdot1 * m2 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m6 * d6 * a2 * cos((q5 + q4 + q3 + 2 * q2)) / 0.2e1 + qdot1 * m6 * d6 * a2 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.2e1 + qdot1 * m4 * a3 * d6 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m4 * a3 * d6 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * m4 * a2 * d6 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.2e1 + qdot1 * m5 * d6 * a1 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m5 * d6 * a3 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * m5 * d6 * a3 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * m3 * d6 * a3 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m5 * d6 * a1 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m5 * d6 * a2 * cos((q5 + q4 + q3 + 2 * q2)) / 0.2e1 + qdot1 * m5 * d6 * a2 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.2e1 - qdot1 * m6 * d6 * a3 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * m6 * d6 * a3 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m6 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + qdot1 * m6 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m6 * d6 * a1 * cos((q2 + q3 + q4 + q5)) / 0.2e1 + qdot1 * m6 * d6 * a1 * cos((q2 + q3 + q4 - q5)) / 0.2e1 + qdot1 * m3 * a1 * d6 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m3 * a1 * d6 * cos((q2 + q3 + q4 + q5)) / 0.2e1 + qdot1 * m4 * a1 * d6 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m4 * a1 * d6 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m3 * d6 * a3 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * m3 * a2 * d6 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.2e1 - qdot1 * m3 * a2 * d6 * cos((q5 + q4 + q3 + 2 * q2)) / 0.2e1 + qdot1 * m5 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m5 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 - qdot1 * m2 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + qdot1 * m2 * d6 * a3 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m2 * d6 * a3 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * m3 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m3 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 - qdot2 * m2 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot2 * m2 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot2 * m2 * a3 * d6 * cos((q5 + q3 + q2)) / 0.2e1 - qdot2 * m2 * a3 * d6 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot2 * m2 * a2 * d6 * cos((q5 + q2)) / 0.2e1 - qdot2 * m2 * a2 * d6 * cos((-q5 + q2)) / 0.2e1 - qdot2 * m3 * a2 * d6 * cos((q5 + q2)) / 0.2e1 - qdot2 * m3 * a2 * d6 * cos((-q5 + q2)) / 0.2e1 - qdot2 * m4 * a2 * d6 * cos((q5 + q2)) / 0.2e1 - qdot2 * m4 * a2 * d6 * cos((-q5 + q2)) / 0.2e1 - qdot2 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot2 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot2 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot2 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot2 * m3 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot2 * m3 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot2 * m4 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot2 * m4 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot3 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot3 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot3 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot3 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot3 * m3 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot3 * m3 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot3 * m4 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot3 * m4 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot4 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot4 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m4 * a3 ^ 2 * sin((2 * q2 + 2 * q3)) / 0.2e1 - qdot1 * m2 * a3 ^ 2 * sin((2 * q2 + 2 * q3)) / 0.2e1 - qdot1 * m1 * a3 ^ 2 * sin((2 * q2 + 2 * q3)) / 0.2e1 - qdot1 * m6 * a3 ^ 2 * sin((2 * q2 + 2 * q3)) / 0.2e1 - qdot1 * m3 * a3 ^ 2 * sin((2 * q2 + 2 * q3)) / 0.2e1 - qdot1 * m5 * a3 ^ 2 * sin((2 * q2 + 2 * q3)) / 0.2e1 - qdot4 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot5 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 qdot4 * m2 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m2 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot4 * m2 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot4 * m2 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot4 * m2 * a3 * a4 * sin(q4) - qdot4 * m2 * a2 * a4 * sin((q3 + q4)) - qdot5 * m2 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m2 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot5 * m2 * d6 * a4 * cos(q5) - qdot5 * m2 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot5 * m2 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot3 * m2 * a2 * a3 * sin(q3) + qdot3 * m2 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot3 * m2 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot3 * m2 * a2 * a4 * sin((q3 + q4)) - qdot4 * m4 * a3 * a4 * sin(q4) - qdot4 * m6 * a3 * a4 * sin(q4) - qdot4 * m5 * a3 * a4 * sin(q4) - qdot5 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot3 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot3 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 + qdot3 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot3 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot3 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 + qdot3 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot3 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot3 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot4 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot4 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 + qdot4 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot4 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot4 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 + qdot4 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot5 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot5 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot5 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot5 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot5 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m2 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot5 * m6 * d6 * a4 * cos(q5) + qdot4 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot4 * m3 * a3 * a4 * sin(q4) - qdot5 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot5 * m3 * d6 * a4 * cos(q5) - qdot5 * I5z * sin((2 * q5)) / 0.2e1 + qdot5 * I5x * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6y * sin((2 * q5)) / 0.4e1 + qdot5 * I6x * sin((2 * q5)) / 0.4e1 - qdot5 * I6z * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot4 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot4 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot4 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot5 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot5 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot5 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m5 * d6 * a4 * cos(q5) - qdot5 * m4 * d6 * a4 * cos(q5) - qdot3 * m3 * a2 * a3 * sin(q3) - qdot3 * m4 * a2 * a3 * sin(q3) - qdot3 * m6 * a2 * a3 * sin(q3) - qdot3 * m5 * a2 * a3 * sin(q3) + qdot4 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot4 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot4 * m3 * a2 * a4 * sin((q3 + q4)) - qdot5 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot5 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - sin((2 * q6)) * qdot6 * I6x / 0.4e1 + sin((2 * q6)) * qdot6 * I6y / 0.4e1 - qdot3 * m6 * a2 * a4 * sin((q3 + q4)) - qdot3 * m4 * a2 * a4 * sin((q3 + q4)) - qdot3 * m5 * a2 * a4 * sin((q3 + q4)) - qdot3 * m3 * a2 * a4 * sin((q3 + q4)) - qdot4 * m6 * a2 * a4 * sin((q3 + q4)) - qdot4 * m4 * a2 * a4 * sin((q3 + q4)) - qdot4 * m5 * a2 * a4 * sin((q3 + q4)) - qdot5 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot5 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot5 * m3 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 -qdot4 * m4 * a3 * a4 * sin(q4) - qdot4 * m6 * a3 * a4 * sin(q4) - qdot4 * m5 * a3 * a4 * sin(q4) - qdot5 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot2 * m2 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 + qdot2 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot2 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot5 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot5 * m6 * d6 * a4 * cos(q5) + qdot1 * m2 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot1 * m2 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 + qdot1 * m2 * a3 * d6 * cos((q5 + q3 + q2)) / 0.4e1 + qdot1 * m2 * a3 * d6 * cos((-q5 + q3 + q2)) / 0.4e1 + qdot2 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 + qdot2 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot2 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot2 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot2 * m2 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot4 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot4 * m3 * a3 * a4 * sin(q4) - qdot5 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot5 * m3 * d6 * a4 * cos(q5) - qdot5 * I5z * sin((2 * q5)) / 0.2e1 + qdot5 * I5x * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6y * sin((2 * q5)) / 0.4e1 + qdot5 * I6x * sin((2 * q5)) / 0.4e1 - qdot5 * I6z * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot1 * m2 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot1 * m2 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot2 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot2 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot4 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot4 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot4 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot4 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot5 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot5 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot5 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m5 * d6 * a4 * cos(q5) - qdot5 * m4 * d6 * a4 * cos(q5) + qdot2 * m2 * a2 * a3 * sin(q3) + qdot2 * m3 * a2 * a3 * sin(q3) + qdot2 * m4 * a2 * a3 * sin(q3) + qdot2 * m6 * a2 * a3 * sin(q3) + qdot2 * m5 * a2 * a3 * sin(q3) + qdot4 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot4 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot4 * m3 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot5 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot5 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - sin((2 * q6)) * qdot6 * I6x / 0.4e1 + sin((2 * q6)) * qdot6 * I6y / 0.4e1 + qdot2 * m3 * a2 * a4 * sin((q3 + q4)) + qdot2 * m5 * a2 * a4 * sin((q3 + q4)) + qdot2 * m4 * a2 * a4 * sin((q3 + q4)) + qdot2 * m6 * a2 * a4 * sin((q3 + q4)) + qdot2 * m2 * a2 * a4 * sin((q3 + q4)) - qdot5 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot5 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 + qdot5 * m3 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 qdot2 * m4 * a3 * a4 * sin(q4) + qdot2 * m6 * a3 * a4 * sin(q4) + qdot2 * m5 * a3 * a4 * sin(q4) + qdot2 * m3 * a3 * a4 * sin(q4) + qdot3 * m4 * a3 * a4 * sin(q4) + qdot3 * m6 * a3 * a4 * sin(q4) + qdot3 * m5 * a3 * a4 * sin(q4) + qdot3 * m3 * a3 * a4 * sin(q4) - qdot5 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 - qdot5 * m4 * a3 * d6 * cos((q5 + q4)) / 0.4e1 + qdot2 * m2 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot3 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 + qdot3 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 + qdot2 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot2 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot2 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot3 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot3 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot5 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot5 * m6 * d6 * a4 * cos(q5) + qdot1 * m2 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot1 * m2 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 + qdot2 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 + qdot2 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot2 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot2 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot2 * m2 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m2 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot2 * m2 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot5 * I5z * sin((2 * q5)) / 0.2e1 + qdot5 * I5x * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6y * sin((2 * q5)) / 0.4e1 + qdot5 * I6x * sin((2 * q5)) / 0.4e1 - qdot5 * I6z * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot1 * m2 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot1 * m2 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot2 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot2 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 + qdot2 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot2 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot2 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot3 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot3 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot3 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot3 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot3 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot3 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot1 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot1 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot5 * m5 * d6 * a4 * cos(q5) - qdot5 * m4 * d6 * a4 * cos(q5) - sin((2 * q6)) * qdot6 * I6x / 0.4e1 + sin((2 * q6)) * qdot6 * I6y / 0.4e1 + qdot2 * m3 * a2 * a4 * sin((q3 + q4)) + qdot1 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot1 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * m5 * a2 * a4 * sin((q3 + q4)) + qdot2 * m4 * a2 * a4 * sin((q3 + q4)) + qdot2 * m6 * a2 * a4 * sin((q3 + q4)) + qdot2 * m2 * a2 * a4 * sin((q3 + q4)) + qdot2 * m2 * a3 * a4 * sin(q4) + qdot3 * m3 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot5 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot5 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 -qdot1 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m5 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 + qdot1 * m6 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 - qdot2 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot2 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot2 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot3 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot3 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot3 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot4 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot4 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot4 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot2 * m2 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 + qdot3 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 + qdot3 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 + qdot3 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 + qdot3 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 + qdot4 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 + qdot4 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot1 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6x * sin((q2 + q3 + q4)) / 0.4e1 + qdot1 * I6y * sin((q2 + q3 + q4)) / 0.4e1 + qdot1 * sin((q2 + q3 + q4)) * I5y / 0.2e1 - qdot1 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I5x * sin((2 * q5)) / 0.2e1 + qdot2 * I5z * sin((2 * q5)) / 0.2e1 - qdot2 * I6y * sin((2 * q5)) / 0.4e1 - qdot2 * I6x * sin((2 * q5)) / 0.4e1 + qdot2 * I6z * sin((2 * q5)) / 0.2e1 - qdot3 * I5x * sin((2 * q5)) / 0.2e1 + qdot3 * I5z * sin((2 * q5)) / 0.2e1 - qdot3 * I6y * sin((2 * q5)) / 0.4e1 - qdot3 * I6x * sin((2 * q5)) / 0.4e1 + qdot3 * I6z * sin((2 * q5)) / 0.2e1 + qdot4 * I5z * sin((2 * q5)) / 0.2e1 - qdot4 * I5x * sin((2 * q5)) / 0.2e1 - qdot4 * I6y * sin((2 * q5)) / 0.4e1 - qdot4 * I6x * sin((2 * q5)) / 0.4e1 + qdot4 * I6z * sin((2 * q5)) / 0.2e1 + qdot6 * I6y * sin((-2 * q6 + q5)) / 0.4e1 + qdot6 * I6y * sin((2 * q6 + q5)) / 0.4e1 - qdot6 * I6x * sin((2 * q6 + q5)) / 0.4e1 - qdot6 * I6x * sin((-2 * q6 + q5)) / 0.4e1 + qdot6 * sin(q5) * I6z / 0.2e1 - qdot1 * m5 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m6 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 + qdot1 * m6 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 + qdot1 * m5 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 + qdot1 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot1 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 + qdot2 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 + qdot2 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot2 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot2 * m6 * d6 * a4 * cos(q5) + qdot2 * m5 * d6 * a4 * cos(q5) + qdot2 * m4 * d6 * a4 * cos(q5) + qdot3 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot3 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot3 * m6 * d6 * a4 * cos(q5) + qdot3 * m5 * d6 * a4 * cos(q5) + qdot3 * m4 * d6 * a4 * cos(q5) + qdot4 * m6 * d6 * a4 * cos(q5) + qdot4 * m5 * d6 * a4 * cos(q5) + qdot4 * m4 * d6 * a4 * cos(q5) + qdot1 * m2 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot1 * m2 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 + qdot1 * m2 * a3 * d6 * cos((q5 + q3 + q2)) / 0.4e1 - qdot1 * m2 * a3 * d6 * cos((-q5 + q3 + q2)) / 0.4e1 + qdot1 * m2 * a2 * d6 * cos((q5 + q2)) / 0.4e1 - qdot1 * m2 * a2 * d6 * cos((-q5 + q2)) / 0.4e1 + qdot1 * m3 * a2 * d6 * cos((q5 + q2)) / 0.4e1 - qdot1 * m3 * a2 * d6 * cos((-q5 + q2)) / 0.4e1 + qdot1 * m4 * a2 * d6 * cos((q5 + q2)) / 0.4e1 - qdot1 * m4 * a2 * d6 * cos((-q5 + q2)) / 0.4e1 + qdot1 * m5 * d6 * a2 * cos((q5 + q2)) / 0.2e1 + qdot1 * m6 * d6 * a2 * cos((q5 + q2)) / 0.2e1 - qdot1 * m5 * d6 * a2 * cos((-q5 + q2)) / 0.2e1 - qdot1 * m6 * d6 * a2 * cos((-q5 + q2)) / 0.2e1 + qdot2 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 + qdot2 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 + qdot2 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot2 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot2 * m2 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m2 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot2 * m2 * d6 * a4 * cos(q5) + qdot2 * m2 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot1 * m2 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m2 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * m2 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot1 * m4 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.4e1 + qdot2 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot2 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 + qdot2 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot2 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot2 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot2 * m3 * d6 * a4 * cos(q5) + qdot3 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot3 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot3 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot3 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot3 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot3 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot3 * m3 * d6 * a4 * cos(q5) + qdot4 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 + qdot4 * m4 * a3 * d6 * cos((q5 + q4)) / 0.4e1 + qdot1 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot1 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 + qdot1 * m3 * d6 * a3 * cos((q5 + q3 + q2)) / 0.4e1 - qdot1 * m3 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.4e1 - qdot1 * m6 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 + qdot1 * m6 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot1 * m5 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 + qdot1 * m5 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 + qdot1 * m4 * d6 * a3 * cos((q5 + q3 + q2)) / 0.4e1 - qdot1 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * m3 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot3 * m3 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot1 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 qdot1 * I6z * sin((q2 + q3 + q4 - q5)) / 0.4e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6z * sin((q2 + q3 + q4 + q5)) / 0.4e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6x * sin((2 * q6)) / 0.4e1 - qdot2 * I6y * sin((2 * q6)) / 0.4e1 + qdot2 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6x * sin((2 * q6)) / 0.4e1 - qdot3 * I6y * sin((2 * q6)) / 0.4e1 + qdot3 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6x * sin((2 * q6)) / 0.4e1 - qdot4 * I6y * sin((2 * q6)) / 0.4e1 + qdot4 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot5 * I6y * sin((-2 * q6 + q5)) / 0.4e1 - qdot5 * I6y * sin((2 * q6 + q5)) / 0.4e1 + qdot5 * I6x * sin((2 * q6 + q5)) / 0.4e1 + qdot5 * I6x * sin((-2 * q6 + q5)) / 0.4e1 - qdot5 * sin(q5) * I6z / 0.2e1]';

    C3 = [qdot1 * I4x * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * I4z * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * I5x * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 + qdot1 * I5z * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * I5y * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * I6z * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * I6x * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot5 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot5 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot5 * I6x * sin((q2 + q3 + q4)) / 0.4e1 + qdot5 * I6y * sin((q2 + q3 + q4)) / 0.4e1 + qdot5 * sin((q2 + q3 + q4)) * I5y / 0.2e1 + qdot5 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot5 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot5 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot5 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot5 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot5 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot5 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot5 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot5 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot5 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot5 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot5 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot5 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot6 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot6 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot6 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot6 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot6 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot6 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot6 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot6 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6y * sin((-2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6y * sin((2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * qdot1 * I6y * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) + qdot1 * I6y * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 + qdot1 * I6y * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((-2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6y * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * qdot1 * I6y * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) + 0.3e1 / 0.16e2 * qdot1 * I6x * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) + qdot5 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m5 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 + qdot5 * m6 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 - qdot1 * I6y * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + 0.3e1 / 0.16e2 * qdot1 * I6x * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) + qdot1 * I6x * sin((2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6x * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 + qdot1 * I6x * sin((-2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot2 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot2 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot2 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot2 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot2 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot2 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot2 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot2 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot2 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot3 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot3 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot3 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot3 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot3 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot3 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot3 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot3 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot4 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot4 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot4 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot4 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot4 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot4 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot4 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot4 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot5 * I6x * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot5 * I6x * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot5 * I6y * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot5 * I6y * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot1 * m4 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m4 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m1 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m1 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m2 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m2 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m5 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m5 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m3 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m3 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m6 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m6 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot2 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * m2 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * m2 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot3 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I6x * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 + qdot1 * I6y * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 + qdot1 * I6y * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 + qdot1 * I5x * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * I5x * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * I5z * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * I5z * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * I6z * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * I6z * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot2 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot6 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot6 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot6 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot6 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot6 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot6 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot6 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot6 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot6 * I6z * sin((q2 + q3 + q4 - q5)) / 0.4e1 - qdot6 * I6z * sin((q2 + q3 + q4 + q5)) / 0.4e1 - qdot1 * m3 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot2 * m5 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot2 * m6 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot2 * m6 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot2 * m5 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot3 * m5 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot3 * m6 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot3 * m6 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot3 * m5 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot4 * m5 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot4 * m6 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot4 * m6 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot4 * m5 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot5 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot5 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot1 * m1 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m1 * a3 * a4 * sin((2 * q2 + 2 * q3 + q4)) - qdot1 * m1 * a2 * a4 * sin((2 * q2 + q3 + q4)) / 0.2e1 - qdot1 * m2 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m5 * a2 * a4 * sin((2 * q2 + q3 + q4)) / 0.2e1 - qdot1 * m4 * a2 * a4 * sin((2 * q2 + q3 + q4)) / 0.2e1 - qdot1 * m2 * a2 * a4 * sin((2 * q2 + q3 + q4)) / 0.2e1 - qdot1 * m4 * a3 * a4 * sin((2 * q2 + 2 * q3 + q4)) - qdot1 * m6 * a3 * a4 * sin((2 * q2 + 2 * q3 + q4)) - qdot1 * m3 * a4 * a3 * sin((2 * q2 + 2 * q3 + q4)) - qdot1 * m6 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m1 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot1 * m6 * a2 * a4 * sin((2 * q2 + q3 + q4)) / 0.2e1 - qdot1 * m3 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m4 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m3 * a2 * a4 * sin((2 * q2 + q3 + q4)) / 0.2e1 - qdot1 * m5 * a3 * a4 * sin((2 * q2 + 2 * q3 + q4)) - qdot1 * m5 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m2 * a4 * a3 * sin((2 * q2 + 2 * q3 + q4)) - qdot1 * m5 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot1 * m4 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot1 * m6 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot1 * m2 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot1 * m4 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m1 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m1 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m2 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m2 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m5 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m4 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m6 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m3 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m5 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m6 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m3 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 + qdot5 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m1 * a3 * a2 * sin((2 * q2 + q3)) / 0.2e1 - qdot1 * m2 * a1 * a3 * sin((q2 + q3)) - qdot1 * m5 * a2 * a3 * sin((2 * q2 + q3)) / 0.2e1 - qdot1 * m6 * a2 * a3 * sin((2 * q2 + q3)) / 0.2e1 - qdot1 * m4 * a2 * a3 * sin((2 * q2 + q3)) / 0.2e1 - qdot1 * m6 * a1 * a3 * sin((q2 + q3)) - qdot1 * m1 * a3 * a2 * sin(q3) / 0.2e1 - qdot1 * m3 * a1 * a3 * sin((q2 + q3)) - qdot1 * m4 * a1 * a3 * sin((q2 + q3)) - qdot1 * m3 * a2 * a3 * sin((2 * q2 + q3)) / 0.2e1 - qdot1 * m5 * a1 * a3 * sin((q2 + q3)) - qdot1 * m2 * a2 * a3 * sin((2 * q2 + q3)) / 0.2e1 - qdot1 * m1 * a1 * a3 * sin((q2 + q3)) - qdot1 * m2 * a2 * a3 * sin(q3) / 0.2e1 - qdot1 * m3 * a2 * a3 * sin(q3) / 0.2e1 - qdot1 * m4 * a2 * a3 * sin(q3) / 0.2e1 - qdot1 * m6 * a2 * a3 * sin(q3) / 0.2e1 - qdot1 * m5 * a2 * a3 * sin(q3) / 0.2e1 - qdot2 * m6 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot2 * m6 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot2 * m5 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot2 * m5 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot3 * m6 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot3 * m6 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot3 * m5 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot3 * m5 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot4 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot4 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot5 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot5 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot5 * m3 * d6 * a3 * cos((q5 + q3 + q2)) / 0.4e1 + qdot5 * m3 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.4e1 - qdot5 * m4 * d6 * a3 * cos((q5 + q3 + q2)) / 0.4e1 + qdot5 * m4 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.4e1 + qdot1 * I3x * sin((2 * q2 + 2 * q3)) / 0.2e1 - qdot1 * I3y * sin((2 * q2 + 2 * q3)) / 0.2e1 - qdot1 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.4e1 - qdot1 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.4e1 + qdot1 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.4e1 + qdot1 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.4e1 + qdot1 * m2 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot1 * m2 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot1 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 + qdot1 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 + qdot1 * m1 * a1 * d6 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m1 * a1 * d6 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m1 * a3 * d6 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * m1 * a3 * d6 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m1 * a2 * d6 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m1 * a2 * d6 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m1 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m1 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + qdot1 * m2 * a1 * d6 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m2 * a1 * d6 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m4 * a2 * d6 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m4 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m4 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + qdot1 * m2 * a2 * d6 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m2 * a2 * d6 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m2 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m6 * d6 * a2 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m6 * d6 * a2 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m4 * a3 * d6 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m4 * a3 * d6 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * m4 * a2 * d6 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m5 * d6 * a1 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m5 * d6 * a3 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * m5 * d6 * a3 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * m3 * d6 * a3 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m5 * d6 * a1 * cos((q2 + q3 + q4 + q5)) / 0.2e1 + qdot1 * m1 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot1 * m1 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot1 * m5 * d6 * a2 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m5 * d6 * a2 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m6 * d6 * a3 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * m6 * d6 * a3 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m6 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + qdot1 * m6 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m6 * d6 * a1 * cos((q2 + q3 + q4 + q5)) / 0.2e1 + qdot1 * m6 * d6 * a1 * cos((q2 + q3 + q4 - q5)) / 0.2e1 + qdot1 * m3 * a1 * d6 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m3 * a1 * d6 * cos((q2 + q3 + q4 + q5)) / 0.2e1 + qdot1 * m4 * a1 * d6 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m4 * a1 * d6 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m3 * d6 * a3 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * m3 * a2 * d6 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m3 * a2 * d6 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m5 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m5 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 - qdot1 * m2 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + qdot1 * m2 * d6 * a3 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m2 * d6 * a3 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * m3 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m3 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + qdot1 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot1 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot2 * m2 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot2 * m2 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot2 * m2 * a3 * d6 * cos((q5 + q3 + q2)) / 0.4e1 - qdot2 * m2 * a3 * d6 * cos((-q5 + q3 + q2)) / 0.4e1 - qdot2 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot2 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot2 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot2 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot2 * m3 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot2 * m3 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot2 * m4 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot2 * m4 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot3 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot3 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot3 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot3 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot3 * m3 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot3 * m3 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot3 * m4 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot3 * m4 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot4 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot4 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m4 * a3 ^ 2 * sin((2 * q2 + 2 * q3)) / 0.2e1 - qdot1 * m2 * a3 ^ 2 * sin((2 * q2 + 2 * q3)) / 0.2e1 - qdot1 * m1 * a3 ^ 2 * sin((2 * q2 + 2 * q3)) / 0.2e1 - qdot1 * m6 * a3 ^ 2 * sin((2 * q2 + 2 * q3)) / 0.2e1 - qdot1 * m3 * a3 ^ 2 * sin((2 * q2 + 2 * q3)) / 0.2e1 - qdot1 * m5 * a3 ^ 2 * sin((2 * q2 + 2 * q3)) / 0.2e1 - qdot4 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot5 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 -qdot4 * m4 * a3 * a4 * sin(q4) - qdot4 * m6 * a3 * a4 * sin(q4) - qdot4 * m5 * a3 * a4 * sin(q4) - qdot5 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot2 * m2 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot3 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot3 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 + qdot3 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot3 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot3 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 + qdot3 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot3 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot3 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot4 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot4 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 + qdot4 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot4 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot4 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 + qdot4 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot5 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot5 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot5 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot5 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot2 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 + qdot2 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot5 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot5 * m6 * d6 * a4 * cos(q5) - qdot1 * m2 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot1 * m2 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot1 * m2 * a3 * d6 * cos((q5 + q3 + q2)) / 0.4e1 - qdot1 * m2 * a3 * d6 * cos((-q5 + q3 + q2)) / 0.4e1 - qdot2 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot2 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 + qdot2 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot2 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot2 * m2 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot4 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot4 * m3 * a3 * a4 * sin(q4) - qdot5 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot5 * m3 * d6 * a4 * cos(q5) - qdot5 * I5z * sin((2 * q5)) / 0.2e1 + qdot5 * I5x * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6y * sin((2 * q5)) / 0.4e1 + qdot5 * I6x * sin((2 * q5)) / 0.4e1 - qdot5 * I6z * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot1 * m2 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot1 * m2 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot2 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot4 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot4 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot4 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot4 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot5 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot5 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot5 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m5 * d6 * a4 * cos(q5) - qdot5 * m4 * d6 * a4 * cos(q5) - qdot2 * m2 * a2 * a3 * sin(q3) - qdot2 * m3 * a2 * a3 * sin(q3) - qdot2 * m4 * a2 * a3 * sin(q3) - qdot2 * m6 * a2 * a3 * sin(q3) - qdot2 * m5 * a2 * a3 * sin(q3) - qdot3 * m3 * a2 * a3 * sin(q3) - qdot3 * m4 * a2 * a3 * sin(q3) - qdot3 * m6 * a2 * a3 * sin(q3) - qdot3 * m5 * a2 * a3 * sin(q3) + qdot4 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot4 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot4 * m3 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot5 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot5 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - sin((2 * q6)) * qdot6 * I6x / 0.4e1 + sin((2 * q6)) * qdot6 * I6y / 0.4e1 - qdot2 * m3 * a2 * a4 * sin((q3 + q4)) - qdot2 * m5 * a2 * a4 * sin((q3 + q4)) - qdot2 * m4 * a2 * a4 * sin((q3 + q4)) - qdot2 * m6 * a2 * a4 * sin((q3 + q4)) - qdot2 * m2 * a2 * a4 * sin((q3 + q4)) - qdot3 * m6 * a2 * a4 * sin((q3 + q4)) - qdot3 * m4 * a2 * a4 * sin((q3 + q4)) - qdot3 * m5 * a2 * a4 * sin((q3 + q4)) - qdot3 * m3 * a2 * a4 * sin((q3 + q4)) - qdot4 * m6 * a2 * a4 * sin((q3 + q4)) - qdot4 * m4 * a2 * a4 * sin((q3 + q4)) - qdot4 * m5 * a2 * a4 * sin((q3 + q4)) - qdot5 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot5 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 + qdot5 * m3 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 -qdot4 * m4 * a3 * a4 * sin(q4) - qdot4 * m6 * a3 * a4 * sin(q4) - qdot4 * m5 * a3 * a4 * sin(q4) - qdot5 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot5 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot5 * m6 * d6 * a4 * cos(q5) + qdot4 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot4 * m3 * a3 * a4 * sin(q4) - qdot5 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot5 * m3 * d6 * a4 * cos(q5) - qdot5 * I5z * sin((2 * q5)) / 0.2e1 + qdot5 * I5x * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6y * sin((2 * q5)) / 0.4e1 + qdot5 * I6x * sin((2 * q5)) / 0.4e1 - qdot5 * I6z * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot4 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot4 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot4 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot5 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot5 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot5 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m5 * d6 * a4 * cos(q5) - qdot5 * m4 * d6 * a4 * cos(q5) - sin((2 * q6)) * qdot6 * I6x / 0.4e1 + sin((2 * q6)) * qdot6 * I6y / 0.4e1 + qdot5 * m3 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 qdot2 * m4 * a3 * a4 * sin(q4) + qdot2 * m6 * a3 * a4 * sin(q4) + qdot2 * m5 * a3 * a4 * sin(q4) + qdot2 * m3 * a3 * a4 * sin(q4) + qdot3 * m4 * a3 * a4 * sin(q4) + qdot3 * m6 * a3 * a4 * sin(q4) + qdot3 * m5 * a3 * a4 * sin(q4) + qdot3 * m3 * a3 * a4 * sin(q4) - qdot5 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 - qdot5 * m4 * a3 * d6 * cos((q5 + q4)) / 0.4e1 - qdot2 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot3 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot3 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot5 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot5 * m6 * d6 * a4 * cos(q5) - qdot5 * I5z * sin((2 * q5)) / 0.2e1 + qdot5 * I5x * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6y * sin((2 * q5)) / 0.4e1 + qdot5 * I6x * sin((2 * q5)) / 0.4e1 - qdot5 * I6z * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 + qdot2 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 + qdot2 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot2 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot2 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot3 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot3 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot3 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot3 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot3 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot3 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot1 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot1 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot5 * m5 * d6 * a4 * cos(q5) - qdot5 * m4 * d6 * a4 * cos(q5) - sin((2 * q6)) * qdot6 * I6x / 0.4e1 + sin((2 * q6)) * qdot6 * I6y / 0.4e1 + qdot2 * m3 * a2 * a4 * sin((q3 + q4)) / 0.2e1 + qdot1 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot1 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 -qdot1 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m5 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 + qdot1 * m6 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 - qdot2 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot2 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot2 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot3 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot3 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot3 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot4 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot4 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot4 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6x * sin((q2 + q3 + q4)) / 0.4e1 + qdot1 * I6y * sin((q2 + q3 + q4)) / 0.4e1 + qdot1 * sin((q2 + q3 + q4)) * I5y / 0.2e1 - qdot1 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I5x * sin((2 * q5)) / 0.2e1 + qdot2 * I5z * sin((2 * q5)) / 0.2e1 - qdot2 * I6y * sin((2 * q5)) / 0.4e1 - qdot2 * I6x * sin((2 * q5)) / 0.4e1 + qdot2 * I6z * sin((2 * q5)) / 0.2e1 - qdot3 * I5x * sin((2 * q5)) / 0.2e1 + qdot3 * I5z * sin((2 * q5)) / 0.2e1 - qdot3 * I6y * sin((2 * q5)) / 0.4e1 - qdot3 * I6x * sin((2 * q5)) / 0.4e1 + qdot3 * I6z * sin((2 * q5)) / 0.2e1 + qdot4 * I5z * sin((2 * q5)) / 0.2e1 - qdot4 * I5x * sin((2 * q5)) / 0.2e1 - qdot4 * I6y * sin((2 * q5)) / 0.4e1 - qdot4 * I6x * sin((2 * q5)) / 0.4e1 + qdot4 * I6z * sin((2 * q5)) / 0.2e1 + qdot6 * I6y * sin((-2 * q6 + q5)) / 0.4e1 + qdot6 * I6y * sin((2 * q6 + q5)) / 0.4e1 - qdot6 * I6x * sin((2 * q6 + q5)) / 0.4e1 - qdot6 * I6x * sin((-2 * q6 + q5)) / 0.4e1 + qdot6 * sin(q5) * I6z / 0.2e1 - qdot1 * m5 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m6 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 + qdot1 * m6 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 + qdot1 * m5 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 + qdot1 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot1 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 + qdot2 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 + qdot2 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 + qdot2 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot2 * m6 * d6 * a4 * cos(q5) + qdot2 * m5 * d6 * a4 * cos(q5) + qdot2 * m4 * d6 * a4 * cos(q5) + qdot3 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot3 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot3 * m6 * d6 * a4 * cos(q5) + qdot3 * m5 * d6 * a4 * cos(q5) + qdot3 * m4 * d6 * a4 * cos(q5) + qdot4 * m6 * d6 * a4 * cos(q5) + qdot4 * m5 * d6 * a4 * cos(q5) + qdot4 * m4 * d6 * a4 * cos(q5) - qdot1 * m4 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.4e1 + qdot2 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 + qdot2 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 + qdot2 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot2 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot2 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot2 * m3 * d6 * a4 * cos(q5) + qdot3 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot3 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot3 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot3 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot3 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 + qdot3 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot3 * m3 * d6 * a4 * cos(q5) + qdot4 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 + qdot4 * m4 * a3 * d6 * cos((q5 + q4)) / 0.4e1 + qdot1 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot1 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 + qdot1 * m3 * d6 * a3 * cos((q5 + q3 + q2)) / 0.4e1 - qdot1 * m3 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.4e1 - qdot1 * m6 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 + qdot1 * m6 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot1 * m5 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 + qdot1 * m5 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 + qdot1 * m4 * d6 * a3 * cos((q5 + q3 + q2)) / 0.4e1 - qdot1 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * m3 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot3 * m3 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot1 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 qdot1 * I6z * sin((q2 + q3 + q4 - q5)) / 0.4e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6z * sin((q2 + q3 + q4 + q5)) / 0.4e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6x * sin((2 * q6)) / 0.4e1 - qdot2 * I6y * sin((2 * q6)) / 0.4e1 + qdot2 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6x * sin((2 * q6)) / 0.4e1 - qdot3 * I6y * sin((2 * q6)) / 0.4e1 + qdot3 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6x * sin((2 * q6)) / 0.4e1 - qdot4 * I6y * sin((2 * q6)) / 0.4e1 + qdot4 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot5 * I6y * sin((-2 * q6 + q5)) / 0.4e1 - qdot5 * I6y * sin((2 * q6 + q5)) / 0.4e1 + qdot5 * I6x * sin((2 * q6 + q5)) / 0.4e1 + qdot5 * I6x * sin((-2 * q6 + q5)) / 0.4e1 - qdot5 * sin(q5) * I6z / 0.2e1]';

    C4 = [qdot1 * I4x * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * I4z * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * I5x * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 + qdot1 * I5z * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * I5y * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 + qdot1 * I6z * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * I6x * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot5 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot5 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot5 * I6x * sin((q2 + q3 + q4)) / 0.4e1 + qdot5 * I6y * sin((q2 + q3 + q4)) / 0.4e1 + qdot5 * sin((q2 + q3 + q4)) * I5y / 0.2e1 + qdot5 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot5 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot5 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot5 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot5 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot5 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot5 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot5 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot5 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot5 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot5 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot5 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot5 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot6 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot6 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot6 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot6 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot6 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot6 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot6 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot6 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6y * sin((-2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6y * sin((2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * qdot1 * I6y * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) + qdot1 * I6y * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 + qdot1 * I6y * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((-2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6y * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * qdot1 * I6y * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) + 0.3e1 / 0.16e2 * qdot1 * I6x * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) + qdot5 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m5 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 + qdot5 * m6 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 - qdot1 * I6y * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + 0.3e1 / 0.16e2 * qdot1 * I6x * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) + qdot1 * I6x * sin((2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6x * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 + qdot1 * I6x * sin((-2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot2 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot2 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot2 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot2 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot2 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot2 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot2 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot2 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot2 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot3 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot3 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot3 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot3 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot3 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot3 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot3 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot3 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot4 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot4 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot4 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot4 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot4 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot4 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot4 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot4 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot5 * I6x * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot5 * I6x * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot5 * I6y * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot5 * I6y * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot1 * m4 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m4 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m1 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m1 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m2 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m2 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m5 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m5 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m3 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m3 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m6 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m6 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot2 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot2 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * m2 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * m2 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot3 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot3 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I6x * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 + qdot1 * I6y * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 + qdot1 * I6y * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 + qdot1 * I5x * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * I5x * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * I5z * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * I5z * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * I6z * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * I6z * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot2 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot6 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot6 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot6 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot6 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot6 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot6 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot6 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot6 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot6 * I6z * sin((q2 + q3 + q4 - q5)) / 0.4e1 - qdot6 * I6z * sin((q2 + q3 + q4 + q5)) / 0.4e1 - qdot1 * m3 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot1 * m4 * a3 * a4 * sin(q4) / 0.2e1 - qdot1 * m6 * a3 * a4 * sin(q4) / 0.2e1 - qdot1 * m5 * a3 * a4 * sin(q4) / 0.2e1 - qdot1 * m3 * a3 * a4 * sin(q4) / 0.2e1 - qdot1 * m2 * a3 * a4 * sin(q4) / 0.2e1 - qdot2 * m5 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot2 * m6 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot2 * m6 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot2 * m5 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot3 * m5 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot3 * m6 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot3 * m6 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot3 * m5 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot4 * m5 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot4 * m6 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot4 * m6 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot4 * m5 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot5 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot5 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot1 * m1 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m1 * a3 * a4 * sin((2 * q2 + 2 * q3 + q4)) / 0.2e1 - qdot1 * m1 * a2 * a4 * sin((2 * q2 + q3 + q4)) / 0.2e1 - qdot1 * m2 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m5 * a2 * a4 * sin((2 * q2 + q3 + q4)) / 0.2e1 - qdot1 * m4 * a2 * a4 * sin((2 * q2 + q3 + q4)) / 0.2e1 - qdot1 * m2 * a2 * a4 * sin((2 * q2 + q3 + q4)) / 0.2e1 - qdot1 * m4 * a3 * a4 * sin((2 * q2 + 2 * q3 + q4)) / 0.2e1 - qdot1 * m6 * a3 * a4 * sin((2 * q2 + 2 * q3 + q4)) / 0.2e1 - qdot1 * m3 * a4 * a3 * sin((2 * q2 + 2 * q3 + q4)) / 0.2e1 - qdot1 * m6 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m1 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot1 * m1 * a3 * a4 * sin(q4) / 0.2e1 - qdot1 * m6 * a2 * a4 * sin((2 * q2 + q3 + q4)) / 0.2e1 - qdot1 * m3 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m4 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m3 * a2 * a4 * sin((2 * q2 + q3 + q4)) / 0.2e1 - qdot1 * m5 * a3 * a4 * sin((2 * q2 + 2 * q3 + q4)) / 0.2e1 - qdot1 * m5 * a1 * a4 * sin((q2 + q3 + q4)) - qdot1 * m2 * a4 * a3 * sin((2 * q2 + 2 * q3 + q4)) / 0.2e1 - qdot1 * m5 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot1 * m4 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot1 * m6 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot1 * m2 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot1 * m4 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m1 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m1 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m2 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m2 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m5 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m4 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m6 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m3 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m5 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m6 * a4 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - qdot1 * m3 * d6 ^ 2 * sin((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 + qdot5 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot5 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.4e1 - qdot1 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.4e1 + qdot1 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.4e1 + qdot1 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.4e1 + qdot1 * m2 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 - qdot1 * m2 * a3 * d6 * cos((q5 + q4)) / 0.4e1 + qdot1 * m2 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot1 * m2 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot1 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 + qdot1 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 + qdot1 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 - qdot1 * m4 * a3 * d6 * cos((q5 + q4)) / 0.4e1 + qdot1 * m1 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 - qdot1 * m1 * a3 * d6 * cos((q5 + q4)) / 0.4e1 + qdot1 * m1 * a1 * d6 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m1 * a1 * d6 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m1 * a3 * d6 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 + qdot1 * m1 * a3 * d6 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m1 * a2 * d6 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m1 * a2 * d6 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m1 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m1 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + qdot1 * m2 * a1 * d6 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m2 * a1 * d6 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m4 * a2 * d6 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m4 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m4 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + qdot1 * m2 * a2 * d6 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m2 * a2 * d6 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m2 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m6 * d6 * a2 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m6 * d6 * a2 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m4 * a3 * d6 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m4 * a3 * d6 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 + qdot1 * m4 * a2 * d6 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m5 * d6 * a1 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m5 * d6 * a3 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 + qdot1 * m5 * d6 * a3 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 + qdot1 * m3 * d6 * a3 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m5 * d6 * a1 * cos((q2 + q3 + q4 + q5)) / 0.2e1 + qdot1 * m1 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot1 * m1 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot1 * m5 * d6 * a2 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m5 * d6 * a2 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m6 * d6 * a3 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 + qdot1 * m6 * d6 * a3 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m6 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + qdot1 * m6 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m6 * d6 * a1 * cos((q2 + q3 + q4 + q5)) / 0.2e1 + qdot1 * m6 * d6 * a1 * cos((q2 + q3 + q4 - q5)) / 0.2e1 + qdot1 * m3 * a1 * d6 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m3 * a1 * d6 * cos((q2 + q3 + q4 + q5)) / 0.2e1 + qdot1 * m4 * a1 * d6 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m4 * a1 * d6 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m3 * d6 * a3 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 + qdot1 * m3 * a2 * d6 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m3 * a2 * d6 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 + qdot1 * m5 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m5 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 - qdot1 * m2 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + qdot1 * m2 * d6 * a3 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m2 * d6 * a3 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 + qdot1 * m3 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - qdot1 * m3 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + qdot1 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot1 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot1 * m5 * d6 * a3 * cos((q5 + q4)) / 0.4e1 + qdot1 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.4e1 - qdot1 * m6 * d6 * a3 * cos((q5 + q4)) / 0.4e1 + qdot1 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.4e1 + qdot1 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 - qdot1 * m3 * a3 * d6 * cos((q5 + q4)) / 0.4e1 - qdot2 * m2 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot2 * m2 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot2 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot2 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot2 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot2 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot3 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot3 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot3 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot3 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot4 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot4 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 -qdot2 * m4 * a3 * a4 * sin(q4) - qdot2 * m6 * a3 * a4 * sin(q4) - qdot2 * m5 * a3 * a4 * sin(q4) - qdot2 * m3 * a3 * a4 * sin(q4) - qdot3 * m4 * a3 * a4 * sin(q4) - qdot3 * m6 * a3 * a4 * sin(q4) - qdot3 * m5 * a3 * a4 * sin(q4) - qdot3 * m3 * a3 * a4 * sin(q4) - qdot4 * m4 * a3 * a4 * sin(q4) - qdot4 * m6 * a3 * a4 * sin(q4) - qdot4 * m5 * a3 * a4 * sin(q4) - qdot5 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 - qdot5 * m4 * a3 * d6 * cos((q5 + q4)) / 0.4e1 - qdot2 * m2 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot3 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot3 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 + qdot3 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot3 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot3 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 + qdot3 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot3 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot3 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot4 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot4 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 + qdot4 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot4 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot4 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 + qdot4 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot5 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot5 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot5 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot5 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot2 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 + qdot2 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot2 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot3 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot3 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot5 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot5 * m6 * d6 * a4 * cos(q5) - qdot1 * m2 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot1 * m2 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot2 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot2 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 + qdot2 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot2 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot2 * m2 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m2 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot2 * m2 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot5 * I5z * sin((2 * q5)) / 0.2e1 + qdot5 * I5x * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6y * sin((2 * q5)) / 0.4e1 + qdot5 * I6x * sin((2 * q5)) / 0.4e1 - qdot5 * I6z * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot1 * m2 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot1 * m2 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot2 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot2 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot2 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot2 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot3 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot3 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot3 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot3 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot3 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot3 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot4 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot4 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot4 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot4 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot5 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot5 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot5 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot1 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot1 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot5 * m5 * d6 * a4 * cos(q5) - qdot5 * m4 * d6 * a4 * cos(q5) - sin((2 * q6)) * qdot6 * I6x / 0.4e1 + sin((2 * q6)) * qdot6 * I6y / 0.4e1 - qdot2 * m3 * a2 * a4 * sin((q3 + q4)) - qdot1 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot1 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot2 * m5 * a2 * a4 * sin((q3 + q4)) - qdot2 * m4 * a2 * a4 * sin((q3 + q4)) - qdot2 * m6 * a2 * a4 * sin((q3 + q4)) - qdot2 * m2 * a2 * a4 * sin((q3 + q4)) - qdot2 * m2 * a3 * a4 * sin(q4) - qdot3 * m6 * a2 * a4 * sin((q3 + q4)) - qdot3 * m4 * a2 * a4 * sin((q3 + q4)) - qdot3 * m5 * a2 * a4 * sin((q3 + q4)) - qdot3 * m3 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot4 * m6 * a2 * a4 * sin((q3 + q4)) - qdot4 * m4 * a2 * a4 * sin((q3 + q4)) - qdot4 * m5 * a2 * a4 * sin((q3 + q4)) - qdot5 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot5 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 -qdot2 * m4 * a3 * a4 * sin(q4) - qdot2 * m6 * a3 * a4 * sin(q4) - qdot2 * m5 * a3 * a4 * sin(q4) - qdot2 * m3 * a3 * a4 * sin(q4) - qdot3 * m4 * a3 * a4 * sin(q4) - qdot3 * m6 * a3 * a4 * sin(q4) - qdot3 * m5 * a3 * a4 * sin(q4) - qdot3 * m3 * a3 * a4 * sin(q4) - qdot4 * m4 * a3 * a4 * sin(q4) - qdot4 * m6 * a3 * a4 * sin(q4) - qdot4 * m5 * a3 * a4 * sin(q4) - qdot5 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 - qdot5 * m4 * a3 * d6 * cos((q5 + q4)) / 0.4e1 + qdot2 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot3 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot3 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 + qdot5 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot5 * m6 * d6 * a4 * cos(q5) - qdot5 * I5z * sin((2 * q5)) / 0.2e1 + qdot5 * I5x * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6y * sin((2 * q5)) / 0.4e1 + qdot5 * I6x * sin((2 * q5)) / 0.4e1 - qdot5 * I6z * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot2 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot2 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot2 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot2 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot2 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot3 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot3 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot3 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot3 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot3 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot3 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot4 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot4 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot4 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 + qdot4 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot5 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot5 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot5 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot1 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot1 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot5 * m5 * d6 * a4 * cos(q5) - qdot5 * m4 * d6 * a4 * cos(q5) - sin((2 * q6)) * qdot6 * I6x / 0.4e1 + sin((2 * q6)) * qdot6 * I6y / 0.4e1 - qdot2 * m3 * a2 * a4 * sin((q3 + q4)) / 0.2e1 - qdot1 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot1 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 -qdot5 * I5z * sin((2 * q5)) / 0.2e1 + qdot5 * I5x * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6y * sin((2 * q5)) / 0.4e1 + qdot5 * I6x * sin((2 * q5)) / 0.4e1 - qdot5 * I6z * sin((2 * q5)) / 0.2e1 - qdot5 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot5 * m6 * d6 * a4 * cos(q5) - qdot5 * m5 * d6 * a4 * cos(q5) - qdot5 * m4 * d6 * a4 * cos(q5) + qdot5 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot5 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - sin((2 * q6)) * qdot6 * I6x / 0.4e1 + sin((2 * q6)) * qdot6 * I6y / 0.4e1 - qdot6 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot6 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot6 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 -qdot1 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m5 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 + qdot1 * m6 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 - qdot2 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot2 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot2 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot3 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot3 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot3 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot4 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot4 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot4 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6x * sin((q2 + q3 + q4)) / 0.4e1 + qdot1 * I6y * sin((q2 + q3 + q4)) / 0.4e1 + qdot1 * sin((q2 + q3 + q4)) * I5y / 0.2e1 - qdot1 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I5x * sin((2 * q5)) / 0.2e1 + qdot2 * I5z * sin((2 * q5)) / 0.2e1 - qdot2 * I6y * sin((2 * q5)) / 0.4e1 - qdot2 * I6x * sin((2 * q5)) / 0.4e1 + qdot2 * I6z * sin((2 * q5)) / 0.2e1 - qdot3 * I5x * sin((2 * q5)) / 0.2e1 + qdot3 * I5z * sin((2 * q5)) / 0.2e1 - qdot3 * I6y * sin((2 * q5)) / 0.4e1 - qdot3 * I6x * sin((2 * q5)) / 0.4e1 + qdot3 * I6z * sin((2 * q5)) / 0.2e1 + qdot4 * I5z * sin((2 * q5)) / 0.2e1 - qdot4 * I5x * sin((2 * q5)) / 0.2e1 - qdot4 * I6y * sin((2 * q5)) / 0.4e1 - qdot4 * I6x * sin((2 * q5)) / 0.4e1 + qdot4 * I6z * sin((2 * q5)) / 0.2e1 + qdot6 * I6y * sin((-2 * q6 + q5)) / 0.4e1 + qdot6 * I6y * sin((2 * q6 + q5)) / 0.4e1 - qdot6 * I6x * sin((2 * q6 + q5)) / 0.4e1 - qdot6 * I6x * sin((-2 * q6 + q5)) / 0.4e1 + qdot6 * sin(q5) * I6z / 0.2e1 - qdot1 * m5 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m6 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 + qdot1 * m6 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 + qdot1 * m5 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 + qdot1 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 - qdot1 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 + qdot2 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 + qdot2 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 + qdot2 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 + qdot2 * m4 * a3 * d6 * cos((q5 + q4)) / 0.4e1 + qdot2 * m6 * d6 * a4 * cos(q5) + qdot2 * m5 * d6 * a4 * cos(q5) + qdot2 * m4 * d6 * a4 * cos(q5) + qdot3 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 + qdot3 * m4 * a3 * d6 * cos((q5 + q4)) / 0.4e1 + qdot3 * m6 * d6 * a4 * cos(q5) + qdot3 * m5 * d6 * a4 * cos(q5) + qdot3 * m4 * d6 * a4 * cos(q5) + qdot4 * m6 * d6 * a4 * cos(q5) + qdot4 * m5 * d6 * a4 * cos(q5) + qdot4 * m4 * d6 * a4 * cos(q5) - qdot1 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 qdot1 * I6z * sin((q2 + q3 + q4 - q5)) / 0.4e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6z * sin((q2 + q3 + q4 + q5)) / 0.4e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6x * sin((2 * q6)) / 0.4e1 - qdot2 * I6y * sin((2 * q6)) / 0.4e1 + qdot2 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6x * sin((2 * q6)) / 0.4e1 - qdot3 * I6y * sin((2 * q6)) / 0.4e1 + qdot3 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6x * sin((2 * q6)) / 0.4e1 - qdot4 * I6y * sin((2 * q6)) / 0.4e1 + qdot4 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot5 * I6y * sin((-2 * q6 + q5)) / 0.4e1 - qdot5 * I6y * sin((2 * q6 + q5)) / 0.4e1 + qdot5 * I6x * sin((2 * q6 + q5)) / 0.4e1 + qdot5 * I6x * sin((-2 * q6 + q5)) / 0.4e1 - qdot5 * sin(q5) * I6z / 0.2e1]';

    C5 = [qdot1 * I6x * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.16e2 - qdot1 * I6x * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.16e2 + qdot1 * I6x * sin((2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6y * sin((-2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 + qdot1 * I6y * sin((2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 + qdot1 * I6y * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.16e2 - qdot1 * I6y * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.16e2 + qdot1 * I6y * sin((-2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6y * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.16e2 + qdot1 * I6y * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.16e2 - qdot1 * I6y * sin((2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6x * sin((2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6x * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.16e2 + qdot1 * I6x * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.16e2 - qdot1 * I6x * sin((-2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 + qdot1 * I6x * sin((-2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 + qdot1 * I6y * sin((2 * q6 + 2 * q5)) / 0.16e2 - qdot1 * I6x * sin((-2 * q6 + 2 * q5)) / 0.16e2 - qdot1 * I6x * sin((2 * q6 + 2 * q5)) / 0.16e2 + qdot1 * I6y * sin((-2 * q6 + 2 * q5)) / 0.16e2 + qdot2 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot5 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot5 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot5 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot5 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot5 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot5 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot5 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot5 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * m3 * d6 ^ 2 * sin((2 * q5)) / 0.4e1 + qdot1 * m4 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * m4 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * m1 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m1 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * m2 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m2 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * m5 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m5 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m3 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * m3 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * m6 * d6 ^ 2 * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * m6 * d6 ^ 2 * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * m1 * d6 ^ 2 * sin((2 * q5)) / 0.4e1 - qdot1 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.4e1 - qdot1 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.4e1 - qdot1 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.4e1 - qdot1 * m2 * d6 ^ 2 * sin((2 * q5)) / 0.4e1 + qdot2 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m5 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 + qdot2 * m6 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 + qdot2 * m2 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m2 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * m5 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 + qdot3 * m6 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 + qdot4 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * m5 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 + qdot4 * m6 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 + qdot1 * I6z * sin((2 * q5)) / 0.4e1 - qdot1 * I6x * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 - qdot1 * I6y * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 + qdot1 * I6y * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 - qdot1 * I5x * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * I5x * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * I5z * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * I5z * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + qdot1 * I6z * sin((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * I6z * sin((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - qdot1 * I5x * sin((2 * q5)) / 0.4e1 + qdot1 * I5z * sin((2 * q5)) / 0.4e1 - qdot2 * I6x * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot2 * I6x * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I6y * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I6y * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I6x * sin((q2 + q3 + q4)) / 0.4e1 + qdot2 * I6y * sin((q2 + q3 + q4)) / 0.4e1 + qdot2 * sin((q2 + q3 + q4)) * I5y / 0.2e1 + qdot2 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot2 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot2 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I6x * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot3 * I6x * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I6y * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I6y * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I6x * sin((q2 + q3 + q4)) / 0.4e1 + qdot3 * I6y * sin((q2 + q3 + q4)) / 0.4e1 + qdot3 * sin((q2 + q3 + q4)) * I5y / 0.2e1 + qdot3 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot3 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot3 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot3 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot3 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I6x * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot4 * I6x * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I6y * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I6y * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I6x * sin((q2 + q3 + q4)) / 0.4e1 + qdot4 * I6y * sin((q2 + q3 + q4)) / 0.4e1 + qdot4 * sin((q2 + q3 + q4)) * I5y / 0.2e1 + qdot4 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot4 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot4 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot4 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot4 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot6 * I6x * sin((-2 * q6 + q4 + q3 + q2)) / 0.4e1 + qdot6 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot6 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot6 * I6x * sin((2 * q6 + q4 + q3 + q2)) / 0.4e1 - qdot6 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot6 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot6 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot6 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot6 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot6 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot6 * I6y * sin((2 * q6 + q4 + q3 + q2)) / 0.4e1 - qdot6 * I6y * sin((-2 * q6 + q4 + q3 + q2)) / 0.4e1 - qdot6 * I6z * sin((q2 + q3 + q4 - q5)) / 0.4e1 - qdot6 * I6z * sin((q2 + q3 + q4 + q5)) / 0.4e1 - qdot1 * I6y * sin((2 * q5)) / 0.8e1 - qdot1 * I6x * sin((2 * q5)) / 0.8e1 - qdot1 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.4e1 - qdot1 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.4e1 - qdot1 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot1 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot1 * m2 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 - qdot1 * m2 * a3 * d6 * cos((q5 + q4)) / 0.4e1 - qdot1 * m2 * d6 * a4 * cos(q5) / 0.2e1 - qdot1 * m2 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot1 * m2 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot1 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot1 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot1 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 - qdot1 * m4 * a3 * d6 * cos((q5 + q4)) / 0.4e1 - qdot1 * m6 * d6 * a4 * cos(q5) / 0.2e1 - qdot1 * m5 * d6 * a4 * cos(q5) / 0.2e1 - qdot1 * m4 * d6 * a4 * cos(q5) / 0.2e1 - qdot1 * m1 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 - qdot1 * m1 * a3 * d6 * cos((q5 + q4)) / 0.4e1 - qdot1 * m1 * a1 * d6 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m1 * a1 * d6 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m1 * a3 * d6 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m1 * a3 * d6 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m1 * a2 * d6 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m1 * a2 * d6 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m1 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.4e1 - qdot1 * m1 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.4e1 - qdot1 * m2 * a1 * d6 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m2 * a1 * d6 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m4 * a2 * d6 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m4 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.4e1 - qdot1 * m4 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.4e1 - qdot1 * m2 * a2 * d6 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m2 * a2 * d6 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m2 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.4e1 - qdot1 * m6 * d6 * a2 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m6 * d6 * a2 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m4 * a3 * d6 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m4 * a3 * d6 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m4 * a2 * d6 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m5 * d6 * a1 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m5 * d6 * a3 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m5 * d6 * a3 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m3 * d6 * a3 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m5 * d6 * a1 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m1 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot1 * m1 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot1 * m1 * a4 * d6 * cos(q5) / 0.2e1 - qdot1 * m5 * d6 * a2 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m5 * d6 * a2 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m6 * d6 * a3 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m6 * d6 * a3 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m6 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.4e1 - qdot1 * m6 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.4e1 - qdot1 * m6 * d6 * a1 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m6 * d6 * a1 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m3 * a1 * d6 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m3 * a1 * d6 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m4 * a1 * d6 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m4 * a1 * d6 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m3 * d6 * a3 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m3 * a2 * d6 * cos((-q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m3 * a2 * d6 * cos((q5 + q4 + q3 + 2 * q2)) / 0.4e1 - qdot1 * m5 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.4e1 - qdot1 * m5 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.4e1 - qdot1 * m2 * d6 * a4 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.4e1 - qdot1 * m2 * d6 * a3 * cos((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m2 * d6 * a3 * cos((q5 + q4 + 2 * q3 + 2 * q2)) / 0.4e1 - qdot1 * m3 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.4e1 - qdot1 * m3 * a4 * d6 * cos((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.4e1 - qdot1 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot1 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot1 * m5 * d6 * a3 * cos((q5 + q4)) / 0.4e1 - qdot1 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.4e1 - qdot1 * m6 * d6 * a3 * cos((q5 + q4)) / 0.4e1 - qdot1 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.4e1 - qdot1 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 - qdot1 * m3 * a3 * d6 * cos((q5 + q4)) / 0.4e1 - qdot1 * m3 * d6 * a4 * cos(q5) / 0.2e1 - qdot2 * m2 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot2 * m2 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot2 * m2 * a3 * d6 * cos((q5 + q3 + q2)) / 0.4e1 + qdot2 * m2 * a3 * d6 * cos((-q5 + q3 + q2)) / 0.4e1 - qdot2 * m2 * a2 * d6 * cos((q5 + q2)) / 0.4e1 + qdot2 * m2 * a2 * d6 * cos((-q5 + q2)) / 0.4e1 - qdot2 * m3 * a2 * d6 * cos((q5 + q2)) / 0.4e1 + qdot2 * m3 * a2 * d6 * cos((-q5 + q2)) / 0.4e1 - qdot2 * m4 * a2 * d6 * cos((q5 + q2)) / 0.4e1 + qdot2 * m4 * a2 * d6 * cos((-q5 + q2)) / 0.4e1 - qdot2 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot2 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot2 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot2 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot2 * m3 * d6 * a3 * cos((q5 + q3 + q2)) / 0.4e1 + qdot2 * m3 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.4e1 - qdot2 * m4 * d6 * a3 * cos((q5 + q3 + q2)) / 0.4e1 + qdot2 * m4 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.4e1 - qdot3 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot3 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot3 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot3 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot3 * m3 * d6 * a3 * cos((q5 + q3 + q2)) / 0.4e1 + qdot3 * m3 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.4e1 - qdot3 * m4 * d6 * a3 * cos((q5 + q3 + q2)) / 0.4e1 + qdot3 * m4 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.4e1 - qdot4 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot4 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 + qdot5 * m5 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 + qdot5 * m5 * d6 * a2 * cos((q5 + q2)) / 0.2e1 + qdot5 * m6 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 + qdot5 * m6 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 + qdot5 * m6 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 + qdot5 * m6 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 + qdot5 * m6 * d6 * a2 * cos((q5 + q2)) / 0.2e1 + qdot5 * m5 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 + qdot5 * m5 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 + qdot5 * m5 * d6 * a2 * cos((-q5 + q2)) / 0.2e1 + qdot5 * m6 * d6 * a1 * cos(q5) + qdot5 * m5 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 + qdot5 * m5 * d6 * a1 * cos(q5) + qdot5 * m6 * d6 * a2 * cos((-q5 + q2)) / 0.2e1 qdot1 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m5 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 - qdot1 * m6 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 + qdot2 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot2 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot2 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot3 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot3 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot3 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot4 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot4 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot4 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot2 * m2 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot3 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot3 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot3 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot3 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot3 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot3 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot3 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot3 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot4 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot4 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot4 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot4 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot4 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot4 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot5 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot5 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 + qdot5 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot5 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot1 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6x * sin((q2 + q3 + q4)) / 0.4e1 - qdot1 * I6y * sin((q2 + q3 + q4)) / 0.4e1 - qdot1 * sin((q2 + q3 + q4)) * I5y / 0.2e1 + qdot1 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * I5x * sin((2 * q5)) / 0.2e1 - qdot2 * I5z * sin((2 * q5)) / 0.2e1 + qdot2 * I6y * sin((2 * q5)) / 0.4e1 + qdot2 * I6x * sin((2 * q5)) / 0.4e1 - qdot2 * I6z * sin((2 * q5)) / 0.2e1 + qdot3 * I5x * sin((2 * q5)) / 0.2e1 - qdot3 * I5z * sin((2 * q5)) / 0.2e1 + qdot3 * I6y * sin((2 * q5)) / 0.4e1 + qdot3 * I6x * sin((2 * q5)) / 0.4e1 - qdot3 * I6z * sin((2 * q5)) / 0.2e1 - qdot4 * I5z * sin((2 * q5)) / 0.2e1 + qdot4 * I5x * sin((2 * q5)) / 0.2e1 + qdot4 * I6y * sin((2 * q5)) / 0.4e1 + qdot4 * I6x * sin((2 * q5)) / 0.4e1 - qdot4 * I6z * sin((2 * q5)) / 0.2e1 + qdot6 * I6y * sin((-2 * q6 + q5)) / 0.4e1 + qdot6 * I6y * sin((2 * q6 + q5)) / 0.4e1 - qdot6 * I6x * sin((2 * q6 + q5)) / 0.4e1 - qdot6 * I6x * sin((-2 * q6 + q5)) / 0.4e1 - qdot6 * sin(q5) * I6z / 0.2e1 + qdot1 * m5 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 + qdot1 * m6 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m6 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m5 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot1 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot2 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot2 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot2 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot2 * m6 * d6 * a4 * cos(q5) - qdot2 * m5 * d6 * a4 * cos(q5) - qdot2 * m4 * d6 * a4 * cos(q5) - qdot3 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot3 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot3 * m6 * d6 * a4 * cos(q5) - qdot3 * m5 * d6 * a4 * cos(q5) - qdot3 * m4 * d6 * a4 * cos(q5) - qdot4 * m6 * d6 * a4 * cos(q5) - qdot4 * m5 * d6 * a4 * cos(q5) - qdot4 * m4 * d6 * a4 * cos(q5) - qdot1 * m2 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot1 * m2 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot1 * m2 * a3 * d6 * cos((q5 + q3 + q2)) / 0.4e1 + qdot1 * m2 * a3 * d6 * cos((-q5 + q3 + q2)) / 0.4e1 - qdot1 * m2 * a2 * d6 * cos((q5 + q2)) / 0.4e1 + qdot1 * m2 * a2 * d6 * cos((-q5 + q2)) / 0.4e1 - qdot1 * m3 * a2 * d6 * cos((q5 + q2)) / 0.4e1 + qdot1 * m3 * a2 * d6 * cos((-q5 + q2)) / 0.4e1 - qdot1 * m4 * a2 * d6 * cos((q5 + q2)) / 0.4e1 + qdot1 * m4 * a2 * d6 * cos((-q5 + q2)) / 0.4e1 - qdot1 * m5 * d6 * a2 * cos((q5 + q2)) / 0.2e1 - qdot1 * m6 * d6 * a2 * cos((q5 + q2)) / 0.2e1 + qdot1 * m5 * d6 * a2 * cos((-q5 + q2)) / 0.2e1 + qdot1 * m6 * d6 * a2 * cos((-q5 + q2)) / 0.2e1 - qdot2 * m6 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot2 * m5 * d6 * a2 * cos((q5 + q4 + q3)) / 0.2e1 - qdot2 * m5 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot2 * m6 * d6 * a2 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot2 * m2 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m2 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot2 * m2 * d6 * a4 * cos(q5) - qdot2 * m2 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 + qdot1 * m2 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m2 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m2 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot1 * m4 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.4e1 - qdot2 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.2e1 - qdot2 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.2e1 - qdot2 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot2 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot2 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot2 * m3 * d6 * a4 * cos(q5) - qdot3 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot3 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot3 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot3 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot3 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot3 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot3 * m3 * d6 * a4 * cos(q5) - qdot4 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot4 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot4 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 - qdot4 * m4 * a3 * d6 * cos((q5 + q4)) / 0.4e1 - qdot5 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot5 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot5 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot1 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot1 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot1 * m3 * d6 * a3 * cos((q5 + q3 + q2)) / 0.4e1 + qdot1 * m3 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.4e1 + qdot1 * m6 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot1 * m6 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 + qdot1 * m5 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot1 * m5 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot1 * m4 * d6 * a3 * cos((q5 + q3 + q2)) / 0.4e1 + qdot1 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m3 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot3 * m3 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot1 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot5 * I6y * sin((-2 * q6 + q5)) / 0.4e1 + qdot5 * I6y * sin((2 * q6 + q5)) / 0.4e1 - qdot5 * I6x * sin((2 * q6 + q5)) / 0.4e1 + qdot5 * I6x * sin((-2 * q6 + q5)) / 0.4e1 qdot1 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m5 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 - qdot1 * m6 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 + qdot2 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot2 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot2 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot3 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot3 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot3 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot4 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot4 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot4 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6x * sin((q2 + q3 + q4)) / 0.4e1 - qdot1 * I6y * sin((q2 + q3 + q4)) / 0.4e1 - qdot1 * sin((q2 + q3 + q4)) * I5y / 0.2e1 + qdot1 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * I5x * sin((2 * q5)) / 0.2e1 - qdot2 * I5z * sin((2 * q5)) / 0.2e1 + qdot2 * I6y * sin((2 * q5)) / 0.4e1 + qdot2 * I6x * sin((2 * q5)) / 0.4e1 - qdot2 * I6z * sin((2 * q5)) / 0.2e1 + qdot3 * I5x * sin((2 * q5)) / 0.2e1 - qdot3 * I5z * sin((2 * q5)) / 0.2e1 + qdot3 * I6y * sin((2 * q5)) / 0.4e1 + qdot3 * I6x * sin((2 * q5)) / 0.4e1 - qdot3 * I6z * sin((2 * q5)) / 0.2e1 - qdot4 * I5z * sin((2 * q5)) / 0.2e1 + qdot4 * I5x * sin((2 * q5)) / 0.2e1 + qdot4 * I6y * sin((2 * q5)) / 0.4e1 + qdot4 * I6x * sin((2 * q5)) / 0.4e1 - qdot4 * I6z * sin((2 * q5)) / 0.2e1 + qdot6 * I6y * sin((-2 * q6 + q5)) / 0.4e1 + qdot6 * I6y * sin((2 * q6 + q5)) / 0.4e1 - qdot6 * I6x * sin((2 * q6 + q5)) / 0.4e1 - qdot6 * I6x * sin((-2 * q6 + q5)) / 0.4e1 - qdot6 * sin(q5) * I6z / 0.2e1 + qdot1 * m5 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 + qdot1 * m6 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m6 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m5 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot1 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot2 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot2 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot2 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot2 * m6 * d6 * a4 * cos(q5) - qdot2 * m5 * d6 * a4 * cos(q5) - qdot2 * m4 * d6 * a4 * cos(q5) - qdot3 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot3 * m4 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot3 * m6 * d6 * a4 * cos(q5) - qdot3 * m5 * d6 * a4 * cos(q5) - qdot3 * m4 * d6 * a4 * cos(q5) - qdot4 * m6 * d6 * a4 * cos(q5) - qdot4 * m5 * d6 * a4 * cos(q5) - qdot4 * m4 * d6 * a4 * cos(q5) + qdot1 * m4 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.4e1 - qdot2 * m3 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot2 * m3 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot2 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot2 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot2 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot2 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot2 * m3 * d6 * a4 * cos(q5) - qdot3 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot3 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot3 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot3 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot3 * m3 * a3 * d6 * cos((-q5 + q4)) / 0.2e1 - qdot3 * m3 * a3 * d6 * cos((q5 + q4)) / 0.2e1 - qdot3 * m3 * d6 * a4 * cos(q5) - qdot4 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot4 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 - qdot4 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot4 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 - qdot4 * m4 * a3 * d6 * cos((q5 + q4)) / 0.4e1 - qdot5 * m5 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot5 * m5 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot5 * m6 * d6 * a3 * cos((q5 + q4)) / 0.2e1 + qdot5 * m6 * d6 * a3 * cos((-q5 + q4)) / 0.2e1 - qdot1 * m3 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot1 * m3 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot1 * m3 * d6 * a3 * cos((q5 + q3 + q2)) / 0.4e1 + qdot1 * m3 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.4e1 + qdot1 * m6 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot1 * m6 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 + qdot1 * m5 * d6 * a3 * cos((-q5 + q3 + q2)) / 0.2e1 - qdot1 * m5 * d6 * a3 * cos((q5 + q3 + q2)) / 0.2e1 - qdot1 * m4 * d6 * a3 * cos((q5 + q3 + q2)) / 0.4e1 + qdot1 * m3 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m3 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * m3 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot3 * m3 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot1 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot5 * I6y * sin((-2 * q6 + q5)) / 0.4e1 + qdot5 * I6y * sin((2 * q6 + q5)) / 0.4e1 - qdot5 * I6x * sin((2 * q6 + q5)) / 0.4e1 + qdot5 * I6x * sin((-2 * q6 + q5)) / 0.4e1 qdot1 * m5 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m4 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m6 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m4 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m5 * d6 ^ 2 * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * m6 * d6 ^ 2 * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * m5 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 - qdot1 * m6 * d6 ^ 2 * sin((q2 + q3 + q4)) / 0.2e1 + qdot2 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot2 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot2 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot3 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot3 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot3 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot4 * m4 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot4 * m5 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot4 * m6 * d6 ^ 2 * sin((2 * q5)) / 0.2e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6y * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6y * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6x * sin((q2 + q3 + q4)) / 0.4e1 - qdot1 * I6y * sin((q2 + q3 + q4)) / 0.4e1 - qdot1 * sin((q2 + q3 + q4)) * I5y / 0.2e1 + qdot1 * I5x * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I5x * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * I5z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * I5z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I6x * sin((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + qdot1 * I6x * sin((2 * q5 + q4 + q3 + q2)) / 0.8e1 - qdot1 * I6z * sin((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - qdot1 * I6z * sin((2 * q5 + q4 + q3 + q2)) / 0.4e1 + qdot2 * I5x * sin((2 * q5)) / 0.2e1 - qdot2 * I5z * sin((2 * q5)) / 0.2e1 + qdot2 * I6y * sin((2 * q5)) / 0.4e1 + qdot2 * I6x * sin((2 * q5)) / 0.4e1 - qdot2 * I6z * sin((2 * q5)) / 0.2e1 + qdot3 * I5x * sin((2 * q5)) / 0.2e1 - qdot3 * I5z * sin((2 * q5)) / 0.2e1 + qdot3 * I6y * sin((2 * q5)) / 0.4e1 + qdot3 * I6x * sin((2 * q5)) / 0.4e1 - qdot3 * I6z * sin((2 * q5)) / 0.2e1 - qdot4 * I5z * sin((2 * q5)) / 0.2e1 + qdot4 * I5x * sin((2 * q5)) / 0.2e1 + qdot4 * I6y * sin((2 * q5)) / 0.4e1 + qdot4 * I6x * sin((2 * q5)) / 0.4e1 - qdot4 * I6z * sin((2 * q5)) / 0.2e1 + qdot6 * I6y * sin((-2 * q6 + q5)) / 0.4e1 + qdot6 * I6y * sin((2 * q6 + q5)) / 0.4e1 - qdot6 * I6x * sin((2 * q6 + q5)) / 0.4e1 - qdot6 * I6x * sin((-2 * q6 + q5)) / 0.4e1 - qdot6 * sin(q5) * I6z / 0.2e1 + qdot1 * m5 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 + qdot1 * m6 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.2e1 - qdot1 * m6 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m5 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.2e1 - qdot1 * m4 * d6 * a4 * cos((q2 + q3 + q4 + q5)) / 0.4e1 + qdot1 * m4 * d6 * a4 * cos((q2 + q3 + q4 - q5)) / 0.4e1 - qdot2 * m4 * a2 * d6 * cos((q5 + q4 + q3)) / 0.4e1 - qdot2 * m4 * a2 * d6 * cos((-q5 + q4 + q3)) / 0.4e1 - qdot2 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 - qdot2 * m4 * a3 * d6 * cos((q5 + q4)) / 0.4e1 - qdot2 * m6 * d6 * a4 * cos(q5) - qdot2 * m5 * d6 * a4 * cos(q5) - qdot2 * m4 * d6 * a4 * cos(q5) - qdot3 * m4 * a3 * d6 * cos((-q5 + q4)) / 0.4e1 - qdot3 * m4 * a3 * d6 * cos((q5 + q4)) / 0.4e1 - qdot3 * m6 * d6 * a4 * cos(q5) - qdot3 * m5 * d6 * a4 * cos(q5) - qdot3 * m4 * d6 * a4 * cos(q5) - qdot4 * m6 * d6 * a4 * cos(q5) - qdot4 * m5 * d6 * a4 * cos(q5) - qdot4 * m4 * d6 * a4 * cos(q5) + qdot1 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot5 * I6y * sin((-2 * q6 + q5)) / 0.4e1 + qdot5 * I6y * sin((2 * q6 + q5)) / 0.4e1 - qdot5 * I6x * sin((2 * q6 + q5)) / 0.4e1 + qdot5 * I6x * sin((-2 * q6 + q5)) / 0.4e1 sin((2 * q6)) * qdot6 * I6x / 0.2e1 - sin((2 * q6)) * qdot6 * I6y / 0.2e1 qdot5 * I6y * sin((2 * q6)) / 0.2e1 - qdot1 * I6z * sin((q2 + q3 + q4 - q5)) / 0.4e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot3 * sin(q5) * I6z / 0.2e1 + qdot2 * I6x * sin((-2 * q6 + q5)) / 0.4e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot4 * I6y * sin((-2 * q6 + q5)) / 0.4e1 - qdot1 * I6z * sin((q2 + q3 + q4 + q5)) / 0.4e1 - qdot2 * sin(q5) * I6z / 0.2e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot3 * I6x * sin((2 * q6 + q5)) / 0.4e1 + qdot3 * I6x * sin((-2 * q6 + q5)) / 0.4e1 + qdot4 * I6x * sin((2 * q6 + q5)) / 0.4e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2)) / 0.4e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot3 * I6y * sin((2 * q6 + q5)) / 0.4e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I6y * sin((-2 * q6 + q5)) / 0.4e1 + qdot4 * I6x * sin((-2 * q6 + q5)) / 0.4e1 - qdot4 * I6y * sin((2 * q6 + q5)) / 0.4e1 + qdot2 * I6x * sin((2 * q6 + q5)) / 0.4e1 - qdot3 * I6y * sin((-2 * q6 + q5)) / 0.4e1 - qdot4 * sin(q5) * I6z / 0.2e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2)) / 0.4e1 - qdot2 * I6y * sin((2 * q6 + q5)) / 0.4e1 - qdot5 * I6x * sin((2 * q6)) / 0.2e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2)) / 0.4e1]';

    C6 = [qdot1 * I6x * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 + qdot1 * I6y * sin((-2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6y * sin((2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 + 0.3e1 / 0.16e2 * qdot1 * I6y * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) - qdot1 * I6y * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 - qdot1 * I6y * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 + qdot1 * I6y * sin((-2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6y * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * qdot1 * I6y * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) - 0.3e1 / 0.16e2 * qdot1 * I6x * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) + 0.3e1 / 0.16e2 * qdot1 * I6x * sin((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) + qdot1 * I6x * sin((2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 + qdot1 * I6x * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - qdot1 * I6x * sin((-2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 + qdot1 * I6x * sin((2 * q6)) / 0.8e1 - qdot1 * I6y * sin((2 * q6)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + 2 * q5)) / 0.16e2 + qdot1 * I6x * sin((-2 * q6 + 2 * q5)) / 0.16e2 - qdot1 * I6x * sin((2 * q6 + 2 * q5)) / 0.16e2 - qdot1 * I6y * sin((-2 * q6 + 2 * q5)) / 0.16e2 + qdot2 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot2 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot2 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot2 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot2 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot2 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot2 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot2 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot2 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot2 * I6z * sin((q2 + q3 + q4 - q5)) / 0.4e1 - qdot2 * I6z * sin((q2 + q3 + q4 + q5)) / 0.4e1 + qdot3 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot3 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot3 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot3 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot3 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot3 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot3 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot3 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot3 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot3 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot3 * I6z * sin((q2 + q3 + q4 - q5)) / 0.4e1 - qdot3 * I6z * sin((q2 + q3 + q4 + q5)) / 0.4e1 + qdot4 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot4 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot4 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot4 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot4 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot4 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot4 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot4 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot4 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot4 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot4 * I6z * sin((q2 + q3 + q4 - q5)) / 0.4e1 - qdot4 * I6z * sin((q2 + q3 + q4 + q5)) / 0.4e1 + qdot5 * I6x * sin((-2 * q6 + q4 + q3 + q2)) / 0.4e1 + qdot5 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot5 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot5 * I6x * sin((2 * q6 + q4 + q3 + q2)) / 0.4e1 - qdot5 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot5 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot5 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot5 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot5 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot5 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot5 * I6y * sin((2 * q6 + q4 + q3 + q2)) / 0.4e1 - qdot5 * I6y * sin((-2 * q6 + q4 + q3 + q2)) / 0.4e1 - qdot5 * I6z * sin((q2 + q3 + q4 - q5)) / 0.4e1 - qdot5 * I6z * sin((q2 + q3 + q4 + q5)) / 0.4e1 -qdot1 * I6z * sin((q2 + q3 + q4 - q5)) / 0.4e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6z * sin((q2 + q3 + q4 + q5)) / 0.4e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6x * sin((2 * q6)) / 0.4e1 + qdot2 * I6y * sin((2 * q6)) / 0.4e1 - qdot2 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6x * sin((2 * q6)) / 0.4e1 + qdot3 * I6y * sin((2 * q6)) / 0.4e1 - qdot3 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6x * sin((2 * q6)) / 0.4e1 + qdot4 * I6y * sin((2 * q6)) / 0.4e1 - qdot4 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6y * sin((-2 * q6 + q5)) / 0.4e1 + qdot5 * I6y * sin((2 * q6 + q5)) / 0.4e1 - qdot5 * I6x * sin((2 * q6 + q5)) / 0.4e1 - qdot5 * I6x * sin((-2 * q6 + q5)) / 0.4e1 - qdot5 * sin(q5) * I6z / 0.2e1 -qdot1 * I6z * sin((q2 + q3 + q4 - q5)) / 0.4e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6z * sin((q2 + q3 + q4 + q5)) / 0.4e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6x * sin((2 * q6)) / 0.4e1 + qdot2 * I6y * sin((2 * q6)) / 0.4e1 - qdot2 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6x * sin((2 * q6)) / 0.4e1 + qdot3 * I6y * sin((2 * q6)) / 0.4e1 - qdot3 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6x * sin((2 * q6)) / 0.4e1 + qdot4 * I6y * sin((2 * q6)) / 0.4e1 - qdot4 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6y * sin((-2 * q6 + q5)) / 0.4e1 + qdot5 * I6y * sin((2 * q6 + q5)) / 0.4e1 - qdot5 * I6x * sin((2 * q6 + q5)) / 0.4e1 - qdot5 * I6x * sin((-2 * q6 + q5)) / 0.4e1 - qdot5 * sin(q5) * I6z / 0.2e1 -qdot1 * I6z * sin((q2 + q3 + q4 - q5)) / 0.4e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6z * sin((q2 + q3 + q4 + q5)) / 0.4e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6x * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6y * sin((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot1 * I6y * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + qdot1 * I6x * sin((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - qdot2 * I6x * sin((2 * q6)) / 0.4e1 + qdot2 * I6y * sin((2 * q6)) / 0.4e1 - qdot2 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot2 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot2 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6x * sin((2 * q6)) / 0.4e1 + qdot3 * I6y * sin((2 * q6)) / 0.4e1 - qdot3 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot3 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot3 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6x * sin((2 * q6)) / 0.4e1 + qdot4 * I6y * sin((2 * q6)) / 0.4e1 - qdot4 * I6y * sin((2 * q6 + 2 * q5)) / 0.8e1 - qdot4 * I6x * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6x * sin((2 * q6 + 2 * q5)) / 0.8e1 + qdot4 * I6y * sin((-2 * q6 + 2 * q5)) / 0.8e1 + qdot5 * I6y * sin((-2 * q6 + q5)) / 0.4e1 + qdot5 * I6y * sin((2 * q6 + q5)) / 0.4e1 - qdot5 * I6x * sin((2 * q6 + q5)) / 0.4e1 - qdot5 * I6x * sin((-2 * q6 + q5)) / 0.4e1 - qdot5 * sin(q5) * I6z / 0.2e1 -qdot5 * I6y * sin((2 * q6)) / 0.2e1 + qdot1 * I6z * sin((q2 + q3 + q4 - q5)) / 0.4e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot3 * sin(q5) * I6z / 0.2e1 - qdot2 * I6x * sin((-2 * q6 + q5)) / 0.4e1 + qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + qdot4 * I6y * sin((-2 * q6 + q5)) / 0.4e1 + qdot1 * I6z * sin((q2 + q3 + q4 + q5)) / 0.4e1 + qdot2 * sin(q5) * I6z / 0.2e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot3 * I6x * sin((2 * q6 + q5)) / 0.4e1 - qdot3 * I6x * sin((-2 * q6 + q5)) / 0.4e1 - qdot4 * I6x * sin((2 * q6 + q5)) / 0.4e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot1 * I6x * sin((-2 * q6 + q4 + q3 + q2)) / 0.4e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + qdot3 * I6y * sin((2 * q6 + q5)) / 0.4e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2)) / 0.4e1 + qdot2 * I6y * sin((-2 * q6 + q5)) / 0.4e1 - qdot4 * I6x * sin((-2 * q6 + q5)) / 0.4e1 + qdot4 * I6y * sin((2 * q6 + q5)) / 0.4e1 - qdot2 * I6x * sin((2 * q6 + q5)) / 0.4e1 + qdot3 * I6y * sin((-2 * q6 + q5)) / 0.4e1 + qdot4 * sin(q5) * I6z / 0.2e1 + qdot1 * I6y * sin((2 * q6 + q4 + q3 + q2)) / 0.4e1 + qdot2 * I6y * sin((2 * q6 + q5)) / 0.4e1 + qdot5 * I6x * sin((2 * q6)) / 0.2e1 - qdot1 * I6x * sin((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - qdot1 * I6y * sin((-2 * q6 + q4 + q3 + q2)) / 0.4e1 0]';

    C = [C1,C2,C3,C4,C5,C6];


    Cq = C*q_dot;
    block.OutputPort(1).Data=Cq;
 

