function SLcreateD_M(block)
% Level-2 MATLAB file S-Function for times two demo.
%   Copyright 1990-2009 The MathWorks, Inc.
%   $Revision: 1.1.6.2 $ 

  setup(block);
  
%endfunction

function setup(block)
  
  %% Register number of input and output ports
  block.NumInputPorts  = 1;
  block.NumOutputPorts = 1;
  block.NumDialogPrms = 3;
  %block.DialogPrmsTunable = {'Tunable','Nontunable','Nontunable'};

  %% Setup functional port properties to dynamically
  %% inherited.
  block.SetPreCompInpPortInfoToDynamic;
  block.SetPreCompOutPortInfoToDynamic;
  
  
  block.OutputPort(1).Dimensions = [6 6];
  block.InputPort(1).Dimensions = [6 1];
 
  
  block.InputPort(1).DirectFeedthrough = false;

  
  %% Set block sample time to inherited
  block.SampleTimes = [-1 0];
  
  %% Set the block simStateCompliance to default (i.e., same as a built-in block)
  block.SimStateCompliance = 'DefaultSimState';

  %% Run accelerator on TLC
  block.SetAccelRunOnTLC(true);
  
  %% Register methods
  block.RegBlockMethod('Outputs',@Output);  

  

  
%endfunction

function Output(block)

    M=block.DialogPrm(1).Data;
    Inert=block.DialogPrm(2).Data;
    LEN=block.DialogPrm(3).Data;

    m1=M(1);
    m2=M(2);
    m3=M(3);
    m4=M(4);
    m5=M(5);
    m6=M(6);
    
    d6 = LEN(1);
    a1 = LEN(2);
    a2 = LEN(3);
    a3 = LEN (4);
    a4 = LEN (5);
    
    I1x = Inert(1,1);
    I1y = Inert(1,2);
    I1z = Inert(1,3);
    I2x = Inert(2,1);
    I2y = Inert(2,2);
    I2z = Inert (2,3);
    I3x = Inert (3,1);
    I3y = Inert (3,2);
    I3z = Inert (3,3);
    I4x = Inert (4,1);
    I4y = Inert (4,2);
    I4z = Inert (4,3);
    I5x = Inert (5,1);
    I5y = Inert (5,2);
    I5z = Inert (5,3);
    I6x = Inert (6,1);
    I6y = Inert (6,2);
    I6z = Inert (6,3);

    
    q=block.InputPort(1).Data;
    q1=q(1);
    q2=q(2);
    q3=q(3);
    q4=q(4);
    q5=q(5);
    q6=q(6);
    
    


D = [-I6x * cos((2 * q6)) / 0.8e1 + I6y * cos((2 * q6)) / 0.8e1 - I5z * cos((2 * q5)) / 0.4e1 + I5x * cos((2 * q5)) / 0.4e1 - I6y * cos((2 * q6 + 2 * q5)) / 0.16e2 + I6x * cos((-2 * q6 + 2 * q5)) / 0.16e2 + I6x * cos((2 * q6 + 2 * q5)) / 0.16e2 + I6y * cos((2 * q5)) / 0.8e1 + I6x * cos((2 * q5)) / 0.8e1 - I6z * cos((2 * q5)) / 0.4e1 - I6y * cos((-2 * q6 + 2 * q5)) / 0.16e2 + I5y * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - I6z * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 + I6z * cos((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + I6z * cos((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + I6x * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - I6x * cos((-2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - I6x * cos((2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * I6x * cos((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) + I6x * cos((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 + I6x * cos((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 - I6x * cos((-2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - I6x * cos((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 - I6x * cos((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 - I6x * cos((2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 - 0.3e1 / 0.16e2 * I6x * cos((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) - I6x * cos((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 - I6x * cos((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 + I6y * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + I6y * cos((-2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 + I6y * cos((2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 + 0.3e1 / 0.16e2 * I6y * cos((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) - I6y * cos((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 - I6y * cos((-2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 + I6y * cos((-2 * q6 - 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 + I6y * cos((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.8e1 + I6y * cos((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.8e1 + I6y * cos((2 * q6 + 2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.32e2 + 0.3e1 / 0.16e2 * I6y * cos((2 * q6 + 2 * q4 + 2 * q3 + 2 * q2)) - I6y * cos((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 - I6y * cos((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.16e2 - I4x * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 + I4z * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - I5x * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - I5x * cos((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - I5x * cos((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - I2x * cos((2 * q2)) / 0.2e1 + I2y * cos((2 * q2)) / 0.2e1 - I3x * cos((2 * q2 + 2 * q3)) / 0.2e1 + I3y * cos((2 * q2 + 2 * q3)) / 0.2e1 - I5z * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 + I5z * cos((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + I5z * cos((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + I1y + m3 * a1 ^ 2 + 0.3e1 / 0.4e1 * m3 * d6 ^ 2 + m3 * a3 ^ 2 / 0.2e1 + m3 * a4 ^ 2 / 0.2e1 + m6 * a3 ^ 2 / 0.2e1 + 0.3e1 / 0.4e1 * m5 * d6 ^ 2 + 0.3e1 / 0.4e1 * m6 * d6 ^ 2 + m4 * a3 ^ 2 / 0.2e1 + 0.3e1 / 0.8e1 * I6x + 0.3e1 / 0.8e1 * I6y + I6z / 0.4e1 + m6 * a4 ^ 2 / 0.2e1 + m2 * a2 * a3 * cos(q3) - m2 * d6 * a4 * sin(q5) + m2 * a3 * d6 * sin((-q5 + q4)) / 0.2e1 - m2 * a3 * d6 * sin((q5 + q4)) / 0.2e1 + m2 * a3 * a4 * cos(q4) + m2 * a2 * d6 * sin((-q5 + q4 + q3)) / 0.2e1 - m2 * a2 * d6 * sin((q5 + q4 + q3)) / 0.2e1 + m2 * a2 * a4 * cos((q3 + q4)) - m5 * d6 * a2 * sin((q5 + q4 + q3 + 2 * q2)) / 0.2e1 + m5 * d6 * a2 * sin((-q5 + q4 + q3 + 2 * q2)) / 0.2e1 + m6 * a2 * a4 * cos((2 * q2 + q3 + q4)) - m6 * d6 * a3 * sin((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + m6 * d6 * a3 * sin((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 - m6 * d6 * a4 * sin((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + m6 * d6 * a4 * sin((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - m6 * d6 * a1 * sin((q2 + q3 + q4 + q5)) + m6 * d6 * a1 * sin((q2 + q3 + q4 - q5)) + 0.2e1 * m3 * a1 * a3 * cos((q2 + q3)) + 0.2e1 * m3 * a1 * a2 * cos(q2) + 0.2e1 * m3 * a1 * a4 * cos((q2 + q3 + q4)) + m3 * a1 * d6 * sin((q2 + q3 + q4 - q5)) - m3 * a1 * d6 * sin((q2 + q3 + q4 + q5)) + 0.2e1 * m4 * a1 * a3 * cos((q2 + q3)) + 0.2e1 * m4 * a1 * a2 * cos(q2) + 0.2e1 * m4 * a1 * a4 * cos((q2 + q3 + q4)) + m4 * a1 * d6 * sin((q2 + q3 + q4 - q5)) - m4 * a1 * d6 * sin((q2 + q3 + q4 + q5)) - m3 * d6 * a3 * sin((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + m3 * a2 * d6 * sin((-q5 + q4 + q3 + 2 * q2)) / 0.2e1 - m3 * a2 * d6 * sin((q5 + q4 + q3 + 2 * q2)) / 0.2e1 + m5 * d6 * a4 * sin((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - m5 * d6 * a4 * sin((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + m3 * a2 * a4 * cos((2 * q2 + q3 + q4)) + m5 * a3 * a4 * cos((2 * q2 + 2 * q3 + q4)) + m3 * a2 * a3 * cos((2 * q2 + q3)) + 0.2e1 * m5 * a1 * a3 * cos((q2 + q3)) + 0.2e1 * m5 * a1 * a2 * cos(q2) + 0.2e1 * m5 * a1 * a4 * cos((q2 + q3 + q4)) - m2 * d6 * a4 * sin((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + m2 * a2 * a3 * cos((2 * q2 + q3)) + m2 * a4 * a3 * cos((2 * q2 + 2 * q3 + q4)) + m2 * d6 * a3 * sin((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 - m2 * d6 * a3 * sin((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + m3 * a4 * d6 * sin((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - m3 * a4 * d6 * sin((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + 0.2e1 * m1 * a1 * a3 * cos((q2 + q3)) + 0.2e1 * m1 * a1 * a2 * cos(q2) + 0.2e1 * m1 * a1 * a4 * cos((q2 + q3 + q4)) + m1 * a1 * d6 * sin((q2 + q3 + q4 - q5)) - m1 * a1 * d6 * sin((q2 + q3 + q4 + q5)) + m1 * a3 * a2 * cos(q3) + m1 * a3 * a2 * cos((2 * q2 + q3)) + m1 * a3 * a4 * cos((2 * q2 + 2 * q3 + q4)) + m1 * a3 * d6 * sin((-q5 + q4)) / 0.2e1 - m1 * a3 * d6 * sin((q5 + q4)) / 0.2e1 - m1 * a3 * d6 * sin((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + m1 * a3 * d6 * sin((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + m1 * a3 * a4 * cos(q4) + m1 * a2 * a4 * cos((2 * q2 + q3 + q4)) + m1 * a2 * d6 * sin((-q5 + q4 + q3)) / 0.2e1 - m1 * a2 * d6 * sin((q5 + q4 + q3)) / 0.2e1 - m1 * a2 * d6 * sin((q5 + q4 + q3 + 2 * q2)) / 0.2e1 + m1 * a2 * d6 * sin((-q5 + q4 + q3 + 2 * q2)) / 0.2e1 + m1 * a2 * a4 * cos((q3 + q4)) + m1 * a4 * d6 * sin((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - m1 * a4 * d6 * sin((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 - m1 * a4 * d6 * sin(q5) + 0.2e1 * m2 * a1 * a3 * cos((q2 + q3)) + 0.2e1 * m2 * a1 * a2 * cos(q2) + 0.2e1 * m2 * a1 * a4 * cos((q2 + q3 + q4)) + m2 * a1 * d6 * sin((q2 + q3 + q4 - q5)) - m2 * a1 * d6 * sin((q2 + q3 + q4 + q5)) + m5 * a2 * a4 * cos((2 * q2 + q3 + q4)) - m4 * a2 * d6 * sin((q5 + q4 + q3 + 2 * q2)) / 0.2e1 + m4 * a2 * a4 * cos((2 * q2 + q3 + q4)) + m4 * a4 * d6 * sin((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - m4 * a4 * d6 * sin((2 * q4 + 2 * q3 + 2 * q2 + q5)) / 0.2e1 + m2 * a2 * d6 * sin((-q5 + q4 + q3 + 2 * q2)) / 0.2e1 - m2 * a2 * d6 * sin((q5 + q4 + q3 + 2 * q2)) / 0.2e1 + m2 * a2 * a4 * cos((2 * q2 + q3 + q4)) + m5 * a2 * a3 * cos((2 * q2 + q3)) + m2 * d6 * a4 * sin((2 * q4 + 2 * q3 + 2 * q2 - q5)) / 0.2e1 - m6 * d6 * a2 * sin((q5 + q4 + q3 + 2 * q2)) / 0.2e1 + m6 * d6 * a2 * sin((-q5 + q4 + q3 + 2 * q2)) / 0.2e1 + m6 * a2 * a3 * cos((2 * q2 + q3)) + m4 * a3 * d6 * sin((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 - m4 * a3 * d6 * sin((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + m4 * a3 * a4 * cos((2 * q2 + 2 * q3 + q4)) + m4 * a2 * d6 * sin((-q5 + q4 + q3 + 2 * q2)) / 0.2e1 + m4 * a2 * a3 * cos((2 * q2 + q3)) + m5 * d6 * a1 * sin((q2 + q3 + q4 - q5)) - m5 * d6 * a3 * sin((q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + m5 * d6 * a3 * sin((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 + m6 * a3 * a4 * cos((2 * q2 + 2 * q3 + q4)) + m3 * a4 * a3 * cos((2 * q2 + 2 * q3 + q4)) + m3 * d6 * a3 * sin((-q5 + q4 + 2 * q3 + 2 * q2)) / 0.2e1 - m5 * d6 * a1 * sin((q2 + q3 + q4 + q5)) + 0.2e1 * m6 * a1 * a3 * cos((q2 + q3)) + 0.2e1 * m6 * a1 * a2 * cos(q2) + 0.2e1 * m6 * a1 * a4 * cos((q2 + q3 + q4)) + m5 * a2 ^ 2 / 0.2e1 + 0.3e1 / 0.4e1 * m4 * d6 ^ 2 + m4 * a4 ^ 2 / 0.2e1 + m4 * a1 ^ 2 + m4 * a2 ^ 2 / 0.2e1 - m5 * d6 * a3 * sin((q5 + q4)) / 0.2e1 + m5 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 - m6 * d6 * a3 * sin((q5 + q4)) / 0.2e1 + m6 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 - m6 * d6 * a2 * sin((q5 + q4 + q3)) / 0.2e1 - m5 * d6 * a2 * sin((q5 + q4 + q3)) / 0.2e1 + m5 * d6 * a2 * sin((-q5 + q4 + q3)) / 0.2e1 + m6 * d6 * a2 * sin((-q5 + q4 + q3)) / 0.2e1 - m6 * d6 * a4 * sin(q5) - m5 * d6 * a4 * sin(q5) - m4 * d6 * a4 * sin(q5) + m4 * a3 * d6 * sin((-q5 + q4)) / 0.2e1 - m4 * a3 * d6 * sin((q5 + q4)) / 0.2e1 + m4 * a3 * a4 * cos(q4) + m6 * a3 * a4 * cos(q4) + m5 * a3 * a4 * cos(q4) + m6 * a2 * a4 * cos((q3 + q4)) + m4 * a2 * a4 * cos((q3 + q4)) - m4 * a2 * d6 * sin((q5 + q4 + q3)) / 0.2e1 + m5 * a2 * a4 * cos((q3 + q4)) + m4 * a2 * d6 * sin((-q5 + q4 + q3)) / 0.2e1 - m3 * d6 * a4 * sin(q5) + m3 * a3 * d6 * sin((-q5 + q4)) / 0.2e1 - m3 * a3 * d6 * sin((q5 + q4)) / 0.2e1 + m3 * a3 * a4 * cos(q4) + m3 * a2 * d6 * sin((-q5 + q4 + q3)) / 0.2e1 - m3 * a2 * d6 * sin((q5 + q4 + q3)) / 0.2e1 + m3 * a2 * a4 * cos((q3 + q4)) + m3 * a2 * a3 * cos(q3) + m4 * a2 * a3 * cos(q3) + m6 * a2 * a3 * cos(q3) + m5 * a2 * a3 * cos(q3) + I4x / 0.2e1 + m2 * a3 ^ 2 / 0.2e1 + m2 * a4 ^ 2 / 0.2e1 + m2 * a2 ^ 2 / 0.2e1 + 0.3e1 / 0.4e1 * m2 * d6 ^ 2 + m6 * a1 ^ 2 + I3x / 0.2e1 + I3y / 0.2e1 + m5 * a1 ^ 2 + m1 * a3 ^ 2 / 0.2e1 + m1 * a2 ^ 2 / 0.2e1 + m1 * a1 ^ 2 + m1 * a4 ^ 2 / 0.2e1 + 0.3e1 / 0.4e1 * m1 * d6 ^ 2 + m6 * a2 ^ 2 / 0.2e1 + m3 * a2 ^ 2 / 0.2e1 + m3 * d6 ^ 2 * cos((2 * q5)) / 0.4e1 + m4 * d6 ^ 2 * cos((2 * q5)) / 0.4e1 + m5 * d6 ^ 2 * cos((2 * q5)) / 0.4e1 + m2 * d6 ^ 2 * cos((2 * q5)) / 0.4e1 + m6 * d6 ^ 2 * cos((2 * q5)) / 0.4e1 - m3 * d6 ^ 2 * cos((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + m2 * a2 ^ 2 * cos((2 * q2)) / 0.2e1 + m2 * a3 ^ 2 * cos((2 * q2 + 2 * q3)) / 0.2e1 + m4 * a3 ^ 2 * cos((2 * q2 + 2 * q3)) / 0.2e1 - m4 * d6 ^ 2 * cos((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - m4 * d6 ^ 2 * cos((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + m4 * d6 ^ 2 * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 + m6 * a2 ^ 2 * cos((2 * q2)) / 0.2e1 + m1 * a3 ^ 2 * cos((2 * q2 + 2 * q3)) / 0.2e1 + m1 * a2 ^ 2 * cos((2 * q2)) / 0.2e1 + m1 * a4 ^ 2 * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 + m1 * d6 ^ 2 * cos((2 * q5)) / 0.4e1 + m1 * d6 ^ 2 * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - m1 * d6 ^ 2 * cos((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - m1 * d6 ^ 2 * cos((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + m2 * a4 ^ 2 * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - m2 * d6 ^ 2 * cos((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + m2 * d6 ^ 2 * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 - m2 * d6 ^ 2 * cos((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + m5 * a4 ^ 2 * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - m5 * d6 ^ 2 * cos((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - m5 * d6 ^ 2 * cos((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + m4 * a4 ^ 2 * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 + m6 * a3 ^ 2 * cos((2 * q2 + 2 * q3)) / 0.2e1 + m6 * d6 ^ 2 * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 + m3 * a2 ^ 2 * cos((2 * q2)) / 0.2e1 + m3 * a4 ^ 2 * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 + m3 * a3 ^ 2 * cos((2 * q2 + 2 * q3)) / 0.2e1 - m3 * d6 ^ 2 * cos((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + m5 * a2 ^ 2 * cos((2 * q2)) / 0.2e1 + m5 * a3 ^ 2 * cos((2 * q2 + 2 * q3)) / 0.2e1 + m5 * d6 ^ 2 * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 + m4 * a2 ^ 2 * cos((2 * q2)) / 0.2e1 + m6 * a4 ^ 2 * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.2e1 - m6 * d6 ^ 2 * cos((-2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 - m6 * d6 ^ 2 * cos((2 * q5 + 2 * q4 + 2 * q3 + 2 * q2)) / 0.8e1 + m3 * d6 ^ 2 * cos((2 * q4 + 2 * q3 + 2 * q2)) / 0.4e1 + m2 * a1 ^ 2 + I5x / 0.4e1 + I5y / 0.2e1 + I5z / 0.4e1 + I2x / 0.2e1 + I2y / 0.2e1 + m5 * a3 ^ 2 / 0.2e1 + m5 * a4 ^ 2 / 0.2e1 + I4z / 0.2e1 I6y * cos((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + I6y * cos((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + I6x * cos((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + I6x * cos((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6y * cos((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6y * cos((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6x * cos((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6x * cos((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6x * cos((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6x * cos((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6y * cos((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6y * cos((-2 * q5 + q4 + q3 + q2)) / 0.8e1 - I6y * cos((2 * q5 + q4 + q3 + q2)) / 0.8e1 + I6y * cos((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I5x * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + I5x * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - I5z * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + I5z * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + I6y * cos((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6y * cos((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6x * cos((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + I6x * cos((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6x * cos((2 * q5 + q4 + q3 + q2)) / 0.8e1 - I6z * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - I6x * cos((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6z * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m3 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m3 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m3 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m3 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 - m2 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m2 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m2 * a3 * d6 * sin((q5 + q3 + q2)) / 0.2e1 - m2 * a3 * d6 * sin((-q5 + q3 + q2)) / 0.2e1 - m2 * a2 * d6 * sin((q5 + q2)) / 0.2e1 - m2 * a2 * d6 * sin((-q5 + q2)) / 0.2e1 - m3 * a2 * d6 * sin((q5 + q2)) / 0.2e1 - m3 * a2 * d6 * sin((-q5 + q2)) / 0.2e1 - m4 * a2 * d6 * sin((q5 + q2)) / 0.2e1 - m4 * a2 * d6 * sin((-q5 + q2)) / 0.2e1 - m5 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m5 * d6 * a2 * sin((q5 + q2)) / 0.2e1 - m6 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 - m6 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m6 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m6 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m6 * d6 * a2 * sin((q5 + q2)) / 0.2e1 - m5 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 - m5 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m5 * d6 * a2 * sin((-q5 + q2)) / 0.2e1 - m5 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m6 * d6 * a2 * sin((-q5 + q2)) / 0.2e1 - m4 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m4 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m4 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m4 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 + m2 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + m5 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + m4 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - m6 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m4 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m5 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + m3 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + m6 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - m3 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m2 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 I6y * cos((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + I6y * cos((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + I6x * cos((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + I6x * cos((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6y * cos((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6y * cos((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6x * cos((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6x * cos((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6x * cos((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6x * cos((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6y * cos((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6y * cos((-2 * q5 + q4 + q3 + q2)) / 0.8e1 - I6y * cos((2 * q5 + q4 + q3 + q2)) / 0.8e1 + I6y * cos((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I5x * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + I5x * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - I5z * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + I5z * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + I6y * cos((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6y * cos((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6x * cos((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + I6x * cos((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6x * cos((2 * q5 + q4 + q3 + q2)) / 0.8e1 - I6z * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - I6x * cos((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6z * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m3 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m3 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m3 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m3 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 - m5 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m6 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 - m6 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m6 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m6 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m5 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 - m5 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m5 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m4 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m4 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m4 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m4 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 + m5 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + m4 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - m6 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m4 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m5 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + m3 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + m6 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - m3 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 I6y * cos((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + I6y * cos((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + I6x * cos((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + I6x * cos((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6y * cos((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6y * cos((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6x * cos((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6x * cos((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6x * cos((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6x * cos((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6y * cos((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6y * cos((-2 * q5 + q4 + q3 + q2)) / 0.8e1 - I6y * cos((2 * q5 + q4 + q3 + q2)) / 0.8e1 + I6y * cos((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I5x * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + I5x * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - I5z * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + I5z * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + I6y * cos((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6y * cos((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6x * cos((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + I6x * cos((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6x * cos((2 * q5 + q4 + q3 + q2)) / 0.8e1 - I6z * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - I6x * cos((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6z * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m5 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m6 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m6 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m5 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m4 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m4 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 + m5 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + m4 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - m6 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m4 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m5 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + m6 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 -cos((q2 + q3 + q4)) * I5y - I6y * cos((q2 + q3 + q4)) / 0.2e1 + I6x * cos((-2 * q6 + q4 + q3 + q2)) / 0.4e1 + I6y * cos((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6y * cos((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + I6x * cos((2 * q6 + q4 + q3 + q2)) / 0.4e1 + I6x * cos((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6x * cos((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + I6y * cos((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6y * cos((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6x * cos((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + I6x * cos((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6y * cos((2 * q6 + q4 + q3 + q2)) / 0.4e1 - I6y * cos((-2 * q6 + q4 + q3 + q2)) / 0.4e1 - I6x * cos((q2 + q3 + q4)) / 0.2e1 - m5 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 + m5 * d6 * a2 * sin((q5 + q2)) / 0.2e1 - m6 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 + m6 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m6 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 + m6 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 + m6 * d6 * a2 * sin((q5 + q2)) / 0.2e1 - m5 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 + m5 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m5 * d6 * a2 * sin((-q5 + q2)) / 0.2e1 + m6 * d6 * a1 * sin(q5) + m5 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 + m5 * d6 * a1 * sin(q5) - m6 * d6 * a2 * sin((-q5 + q2)) / 0.2e1 - m5 * d6 ^ 2 * cos((q2 + q3 + q4)) - m6 * d6 ^ 2 * cos((q2 + q3 + q4)) -I6z * cos((q2 + q3 + q4 - q5)) / 0.2e1 + I6z * cos((q2 + q3 + q4 + q5)) / 0.2e1; I6y * cos((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + I6y * cos((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + I6x * cos((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + I6x * cos((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6y * cos((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6y * cos((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6x * cos((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6x * cos((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6x * cos((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6x * cos((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6y * cos((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6y * cos((-2 * q5 + q4 + q3 + q2)) / 0.8e1 - I6y * cos((2 * q5 + q4 + q3 + q2)) / 0.8e1 + I6y * cos((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I5x * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + I5x * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - I5z * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + I5z * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + I6y * cos((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6y * cos((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6x * cos((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + I6x * cos((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6x * cos((2 * q5 + q4 + q3 + q2)) / 0.8e1 - I6z * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - I6x * cos((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6z * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m3 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m3 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m3 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m3 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 - m2 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m2 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m2 * a3 * d6 * sin((q5 + q3 + q2)) / 0.2e1 - m2 * a3 * d6 * sin((-q5 + q3 + q2)) / 0.2e1 - m2 * a2 * d6 * sin((q5 + q2)) / 0.2e1 - m2 * a2 * d6 * sin((-q5 + q2)) / 0.2e1 - m3 * a2 * d6 * sin((q5 + q2)) / 0.2e1 - m3 * a2 * d6 * sin((-q5 + q2)) / 0.2e1 - m4 * a2 * d6 * sin((q5 + q2)) / 0.2e1 - m4 * a2 * d6 * sin((-q5 + q2)) / 0.2e1 - m5 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m5 * d6 * a2 * sin((q5 + q2)) / 0.2e1 - m6 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 - m6 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m6 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m6 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m6 * d6 * a2 * sin((q5 + q2)) / 0.2e1 - m5 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 - m5 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m5 * d6 * a2 * sin((-q5 + q2)) / 0.2e1 - m5 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m6 * d6 * a2 * sin((-q5 + q2)) / 0.2e1 - m4 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m4 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m4 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m4 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 + m2 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + m5 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + m4 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - m6 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m4 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m5 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + m3 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + m6 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - m3 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m2 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 I6x * cos((2 * q6)) / 0.4e1 - I6y * cos((2 * q6)) / 0.4e1 + I5z * cos((2 * q5)) / 0.2e1 - I5x * cos((2 * q5)) / 0.2e1 + I6y * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((-2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6y * cos((2 * q5)) / 0.4e1 - I6x * cos((2 * q5)) / 0.4e1 + I6z * cos((2 * q5)) / 0.2e1 + I6y * cos((-2 * q6 + 2 * q5)) / 0.8e1 + m3 * d6 ^ 2 / 0.2e1 + m3 * a3 ^ 2 + m3 * a4 ^ 2 + m6 * a3 ^ 2 + m5 * d6 ^ 2 / 0.2e1 + m6 * d6 ^ 2 / 0.2e1 + m4 * a3 ^ 2 + I6x / 0.4e1 + I6y / 0.4e1 + I6z / 0.2e1 + m6 * a4 ^ 2 + 0.2e1 * m2 * a2 * a3 * cos(q3) - 0.2e1 * m2 * d6 * a4 * sin(q5) + m2 * a3 * d6 * sin((-q5 + q4)) - m2 * a3 * d6 * sin((q5 + q4)) + 0.2e1 * m2 * a3 * a4 * cos(q4) + m2 * a2 * d6 * sin((-q5 + q4 + q3)) - m2 * a2 * d6 * sin((q5 + q4 + q3)) + 0.2e1 * m2 * a2 * a4 * cos((q3 + q4)) + m5 * a2 ^ 2 + m4 * d6 ^ 2 / 0.2e1 + m4 * a4 ^ 2 + m4 * a2 ^ 2 + I4y - m5 * d6 * a3 * sin((q5 + q4)) + m5 * d6 * a3 * sin((-q5 + q4)) - m6 * d6 * a3 * sin((q5 + q4)) + m6 * d6 * a3 * sin((-q5 + q4)) - m6 * d6 * a2 * sin((q5 + q4 + q3)) - m5 * d6 * a2 * sin((q5 + q4 + q3)) + m5 * d6 * a2 * sin((-q5 + q4 + q3)) + m6 * d6 * a2 * sin((-q5 + q4 + q3)) - 0.2e1 * m6 * d6 * a4 * sin(q5) - 0.2e1 * m5 * d6 * a4 * sin(q5) - 0.2e1 * m4 * d6 * a4 * sin(q5) + m4 * a3 * d6 * sin((-q5 + q4)) - m4 * a3 * d6 * sin((q5 + q4)) + 0.2e1 * m4 * a3 * a4 * cos(q4) + 0.2e1 * m6 * a3 * a4 * cos(q4) + 0.2e1 * m5 * a3 * a4 * cos(q4) + 0.2e1 * m6 * a2 * a4 * cos((q3 + q4)) + 0.2e1 * m4 * a2 * a4 * cos((q3 + q4)) - m4 * a2 * d6 * sin((q5 + q4 + q3)) + 0.2e1 * m5 * a2 * a4 * cos((q3 + q4)) + m4 * a2 * d6 * sin((-q5 + q4 + q3)) - 0.2e1 * m3 * d6 * a4 * sin(q5) + m3 * a3 * d6 * sin((-q5 + q4)) - m3 * a3 * d6 * sin((q5 + q4)) + 0.2e1 * m3 * a3 * a4 * cos(q4) + m3 * a2 * d6 * sin((-q5 + q4 + q3)) - m3 * a2 * d6 * sin((q5 + q4 + q3)) + 0.2e1 * m3 * a2 * a4 * cos((q3 + q4)) + 0.2e1 * m3 * a2 * a3 * cos(q3) + 0.2e1 * m4 * a2 * a3 * cos(q3) + 0.2e1 * m6 * a2 * a3 * cos(q3) + 0.2e1 * m5 * a2 * a3 * cos(q3) + m2 * a3 ^ 2 + m2 * a4 ^ 2 + m2 * a2 ^ 2 + m2 * d6 ^ 2 / 0.2e1 + I3z + m6 * a2 ^ 2 + m3 * a2 ^ 2 - m3 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m4 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m5 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m2 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m6 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 + I5x / 0.2e1 + I5z / 0.2e1 + I2z + m5 * a3 ^ 2 + m5 * a4 ^ 2 I6x * cos((2 * q6)) / 0.4e1 - I6y * cos((2 * q6)) / 0.4e1 + I5z * cos((2 * q5)) / 0.2e1 - I5x * cos((2 * q5)) / 0.2e1 + I6y * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((-2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6y * cos((2 * q5)) / 0.4e1 - I6x * cos((2 * q5)) / 0.4e1 + I6z * cos((2 * q5)) / 0.2e1 + I6y * cos((-2 * q6 + 2 * q5)) / 0.8e1 + m3 * d6 ^ 2 / 0.2e1 + m3 * a3 ^ 2 + m3 * a4 ^ 2 + m6 * a3 ^ 2 + m5 * d6 ^ 2 / 0.2e1 + m6 * d6 ^ 2 / 0.2e1 + m4 * a3 ^ 2 + I6x / 0.4e1 + I6y / 0.4e1 + I6z / 0.2e1 + m6 * a4 ^ 2 + m4 * d6 ^ 2 / 0.2e1 + m4 * a4 ^ 2 + I4y - m5 * d6 * a3 * sin((q5 + q4)) + m5 * d6 * a3 * sin((-q5 + q4)) - m6 * d6 * a3 * sin((q5 + q4)) + m6 * d6 * a3 * sin((-q5 + q4)) - m6 * d6 * a2 * sin((q5 + q4 + q3)) / 0.2e1 - m5 * d6 * a2 * sin((q5 + q4 + q3)) / 0.2e1 + m5 * d6 * a2 * sin((-q5 + q4 + q3)) / 0.2e1 + m6 * d6 * a2 * sin((-q5 + q4 + q3)) / 0.2e1 - 0.2e1 * m6 * d6 * a4 * sin(q5) - 0.2e1 * m5 * d6 * a4 * sin(q5) - 0.2e1 * m4 * d6 * a4 * sin(q5) + m4 * a3 * d6 * sin((-q5 + q4)) - m4 * a3 * d6 * sin((q5 + q4)) + 0.2e1 * m4 * a3 * a4 * cos(q4) + 0.2e1 * m6 * a3 * a4 * cos(q4) + 0.2e1 * m5 * a3 * a4 * cos(q4) + m6 * a2 * a4 * cos((q3 + q4)) + m4 * a2 * a4 * cos((q3 + q4)) - m4 * a2 * d6 * sin((q5 + q4 + q3)) / 0.2e1 + m5 * a2 * a4 * cos((q3 + q4)) + m4 * a2 * d6 * sin((-q5 + q4 + q3)) / 0.2e1 - 0.2e1 * m3 * d6 * a4 * sin(q5) + m3 * a3 * d6 * sin((-q5 + q4)) - m3 * a3 * d6 * sin((q5 + q4)) + 0.2e1 * m3 * a3 * a4 * cos(q4) + m3 * a2 * d6 * sin((-q5 + q4 + q3)) / 0.2e1 - m3 * a2 * d6 * sin((q5 + q4 + q3)) / 0.2e1 + m3 * a2 * a4 * cos((q3 + q4)) + m3 * a2 * a3 * cos(q3) + m4 * a2 * a3 * cos(q3) + m6 * a2 * a3 * cos(q3) + m5 * a2 * a3 * cos(q3) + I3z - m3 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m4 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m5 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m6 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 + I5x / 0.2e1 + I5z / 0.2e1 + m5 * a3 ^ 2 + m5 * a4 ^ 2 I6x * cos((2 * q6)) / 0.4e1 - I6y * cos((2 * q6)) / 0.4e1 + I5z * cos((2 * q5)) / 0.2e1 - I5x * cos((2 * q5)) / 0.2e1 + I6y * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((-2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6y * cos((2 * q5)) / 0.4e1 - I6x * cos((2 * q5)) / 0.4e1 + I6z * cos((2 * q5)) / 0.2e1 + I6y * cos((-2 * q6 + 2 * q5)) / 0.8e1 + m5 * d6 ^ 2 / 0.2e1 + m6 * d6 ^ 2 / 0.2e1 + I6x / 0.4e1 + I6y / 0.4e1 + I6z / 0.2e1 + m6 * a4 ^ 2 + m4 * d6 ^ 2 / 0.2e1 + m4 * a4 ^ 2 + I4y - m5 * d6 * a3 * sin((q5 + q4)) / 0.2e1 + m5 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 - m6 * d6 * a3 * sin((q5 + q4)) / 0.2e1 + m6 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 - m6 * d6 * a2 * sin((q5 + q4 + q3)) / 0.2e1 - m5 * d6 * a2 * sin((q5 + q4 + q3)) / 0.2e1 + m5 * d6 * a2 * sin((-q5 + q4 + q3)) / 0.2e1 + m6 * d6 * a2 * sin((-q5 + q4 + q3)) / 0.2e1 - 0.2e1 * m6 * d6 * a4 * sin(q5) - 0.2e1 * m5 * d6 * a4 * sin(q5) - 0.2e1 * m4 * d6 * a4 * sin(q5) + m4 * a3 * d6 * sin((-q5 + q4)) / 0.2e1 - m4 * a3 * d6 * sin((q5 + q4)) / 0.2e1 + m4 * a3 * a4 * cos(q4) + m6 * a3 * a4 * cos(q4) + m5 * a3 * a4 * cos(q4) + m6 * a2 * a4 * cos((q3 + q4)) + m4 * a2 * a4 * cos((q3 + q4)) - m4 * a2 * d6 * sin((q5 + q4 + q3)) / 0.2e1 + m5 * a2 * a4 * cos((q3 + q4)) + m4 * a2 * d6 * sin((-q5 + q4 + q3)) / 0.2e1 - m4 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m5 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m6 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 + I5x / 0.2e1 + I5z / 0.2e1 + m5 * a4 ^ 2 -m6 * d6 * a2 * sin((q5 + q4 + q3)) / 0.2e1 + I6y * cos((-2 * q6 + q5)) / 0.4e1 - I6y * cos((2 * q6 + q5)) / 0.4e1 - m5 * d6 * a3 * sin((q5 + q4)) / 0.2e1 - m5 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 - m5 * d6 * a2 * sin((q5 + q4 + q3)) / 0.2e1 - m5 * d6 * a2 * sin((-q5 + q4 + q3)) / 0.2e1 + I6x * cos((2 * q6 + q5)) / 0.4e1 - I6x * cos((-2 * q6 + q5)) / 0.4e1 - m6 * d6 * a3 * sin((q5 + q4)) / 0.2e1 - m6 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 - m6 * d6 * a2 * sin((-q5 + q4 + q3)) / 0.2e1 cos(q5) * I6z; I6y * cos((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + I6y * cos((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + I6x * cos((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + I6x * cos((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6y * cos((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6y * cos((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6x * cos((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6x * cos((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6x * cos((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6x * cos((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6y * cos((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6y * cos((-2 * q5 + q4 + q3 + q2)) / 0.8e1 - I6y * cos((2 * q5 + q4 + q3 + q2)) / 0.8e1 + I6y * cos((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I5x * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + I5x * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - I5z * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + I5z * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + I6y * cos((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6y * cos((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6x * cos((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + I6x * cos((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6x * cos((2 * q5 + q4 + q3 + q2)) / 0.8e1 - I6z * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - I6x * cos((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6z * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m3 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m3 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m3 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m3 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 - m5 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m6 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 - m6 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m6 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m6 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m5 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 - m5 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m5 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m4 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m4 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m4 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m4 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 + m5 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + m4 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - m6 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m4 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m5 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + m3 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + m6 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - m3 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 I6x * cos((2 * q6)) / 0.4e1 - I6y * cos((2 * q6)) / 0.4e1 + I5z * cos((2 * q5)) / 0.2e1 - I5x * cos((2 * q5)) / 0.2e1 + I6y * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((-2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6y * cos((2 * q5)) / 0.4e1 - I6x * cos((2 * q5)) / 0.4e1 + I6z * cos((2 * q5)) / 0.2e1 + I6y * cos((-2 * q6 + 2 * q5)) / 0.8e1 + m3 * d6 ^ 2 / 0.2e1 + m3 * a3 ^ 2 + m3 * a4 ^ 2 + m6 * a3 ^ 2 + m5 * d6 ^ 2 / 0.2e1 + m6 * d6 ^ 2 / 0.2e1 + m4 * a3 ^ 2 + I6x / 0.4e1 + I6y / 0.4e1 + I6z / 0.2e1 + m6 * a4 ^ 2 + m4 * d6 ^ 2 / 0.2e1 + m4 * a4 ^ 2 + I4y - m5 * d6 * a3 * sin((q5 + q4)) + m5 * d6 * a3 * sin((-q5 + q4)) - m6 * d6 * a3 * sin((q5 + q4)) + m6 * d6 * a3 * sin((-q5 + q4)) - m6 * d6 * a2 * sin((q5 + q4 + q3)) / 0.2e1 - m5 * d6 * a2 * sin((q5 + q4 + q3)) / 0.2e1 + m5 * d6 * a2 * sin((-q5 + q4 + q3)) / 0.2e1 + m6 * d6 * a2 * sin((-q5 + q4 + q3)) / 0.2e1 - 0.2e1 * m6 * d6 * a4 * sin(q5) - 0.2e1 * m5 * d6 * a4 * sin(q5) - 0.2e1 * m4 * d6 * a4 * sin(q5) + m4 * a3 * d6 * sin((-q5 + q4)) - m4 * a3 * d6 * sin((q5 + q4)) + 0.2e1 * m4 * a3 * a4 * cos(q4) + 0.2e1 * m6 * a3 * a4 * cos(q4) + 0.2e1 * m5 * a3 * a4 * cos(q4) + m6 * a2 * a4 * cos((q3 + q4)) + m4 * a2 * a4 * cos((q3 + q4)) - m4 * a2 * d6 * sin((q5 + q4 + q3)) / 0.2e1 + m5 * a2 * a4 * cos((q3 + q4)) + m4 * a2 * d6 * sin((-q5 + q4 + q3)) / 0.2e1 - 0.2e1 * m3 * d6 * a4 * sin(q5) + m3 * a3 * d6 * sin((-q5 + q4)) - m3 * a3 * d6 * sin((q5 + q4)) + 0.2e1 * m3 * a3 * a4 * cos(q4) + m3 * a2 * d6 * sin((-q5 + q4 + q3)) / 0.2e1 - m3 * a2 * d6 * sin((q5 + q4 + q3)) / 0.2e1 + m3 * a2 * a4 * cos((q3 + q4)) + m3 * a2 * a3 * cos(q3) + m4 * a2 * a3 * cos(q3) + m6 * a2 * a3 * cos(q3) + m5 * a2 * a3 * cos(q3) + I3z - m3 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m4 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m5 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m6 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 + I5x / 0.2e1 + I5z / 0.2e1 + m5 * a3 ^ 2 + m5 * a4 ^ 2 I6x * cos((2 * q6)) / 0.4e1 - I6y * cos((2 * q6)) / 0.4e1 + I5z * cos((2 * q5)) / 0.2e1 - I5x * cos((2 * q5)) / 0.2e1 + I6y * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((-2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6y * cos((2 * q5)) / 0.4e1 - I6x * cos((2 * q5)) / 0.4e1 + I6z * cos((2 * q5)) / 0.2e1 + I6y * cos((-2 * q6 + 2 * q5)) / 0.8e1 + m3 * d6 ^ 2 / 0.2e1 + m3 * a3 ^ 2 + m3 * a4 ^ 2 + m6 * a3 ^ 2 + m5 * d6 ^ 2 / 0.2e1 + m6 * d6 ^ 2 / 0.2e1 + m4 * a3 ^ 2 + I6x / 0.4e1 + I6y / 0.4e1 + I6z / 0.2e1 + m6 * a4 ^ 2 + m4 * d6 ^ 2 / 0.2e1 + m4 * a4 ^ 2 + I4y - m5 * d6 * a3 * sin((q5 + q4)) + m5 * d6 * a3 * sin((-q5 + q4)) - m6 * d6 * a3 * sin((q5 + q4)) + m6 * d6 * a3 * sin((-q5 + q4)) - 0.2e1 * m6 * d6 * a4 * sin(q5) - 0.2e1 * m5 * d6 * a4 * sin(q5) - 0.2e1 * m4 * d6 * a4 * sin(q5) + m4 * a3 * d6 * sin((-q5 + q4)) - m4 * a3 * d6 * sin((q5 + q4)) + 0.2e1 * m4 * a3 * a4 * cos(q4) + 0.2e1 * m6 * a3 * a4 * cos(q4) + 0.2e1 * m5 * a3 * a4 * cos(q4) - 0.2e1 * m3 * d6 * a4 * sin(q5) + m3 * a3 * d6 * sin((-q5 + q4)) - m3 * a3 * d6 * sin((q5 + q4)) + 0.2e1 * m3 * a3 * a4 * cos(q4) + I3z - m3 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m4 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m5 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m6 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 + I5x / 0.2e1 + I5z / 0.2e1 + m5 * a3 ^ 2 + m5 * a4 ^ 2 I6x * cos((2 * q6)) / 0.4e1 - I6y * cos((2 * q6)) / 0.4e1 + I5z * cos((2 * q5)) / 0.2e1 - I5x * cos((2 * q5)) / 0.2e1 + I6y * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((-2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6y * cos((2 * q5)) / 0.4e1 - I6x * cos((2 * q5)) / 0.4e1 + I6z * cos((2 * q5)) / 0.2e1 + I6y * cos((-2 * q6 + 2 * q5)) / 0.8e1 + m5 * d6 ^ 2 / 0.2e1 + m6 * d6 ^ 2 / 0.2e1 + I6x / 0.4e1 + I6y / 0.4e1 + I6z / 0.2e1 + m6 * a4 ^ 2 + m4 * d6 ^ 2 / 0.2e1 + m4 * a4 ^ 2 + I4y - m5 * d6 * a3 * sin((q5 + q4)) / 0.2e1 + m5 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 - m6 * d6 * a3 * sin((q5 + q4)) / 0.2e1 + m6 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 - 0.2e1 * m6 * d6 * a4 * sin(q5) - 0.2e1 * m5 * d6 * a4 * sin(q5) - 0.2e1 * m4 * d6 * a4 * sin(q5) + m4 * a3 * d6 * sin((-q5 + q4)) / 0.2e1 - m4 * a3 * d6 * sin((q5 + q4)) / 0.2e1 + m4 * a3 * a4 * cos(q4) + m6 * a3 * a4 * cos(q4) + m5 * a3 * a4 * cos(q4) - m4 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m5 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m6 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 + I5x / 0.2e1 + I5z / 0.2e1 + m5 * a4 ^ 2 I6y * cos((-2 * q6 + q5)) / 0.4e1 - I6y * cos((2 * q6 + q5)) / 0.4e1 - m5 * d6 * a3 * sin((q5 + q4)) / 0.2e1 - m5 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 + I6x * cos((2 * q6 + q5)) / 0.4e1 - I6x * cos((-2 * q6 + q5)) / 0.4e1 - m6 * d6 * a3 * sin((q5 + q4)) / 0.2e1 - m6 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 cos(q5) * I6z; I6y * cos((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + I6y * cos((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + I6x * cos((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + I6x * cos((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6y * cos((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6y * cos((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6x * cos((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6x * cos((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6x * cos((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6x * cos((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6y * cos((2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6y * cos((-2 * q5 + q4 + q3 + q2)) / 0.8e1 - I6y * cos((2 * q5 + q4 + q3 + q2)) / 0.8e1 + I6y * cos((-2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I5x * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + I5x * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - I5z * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + I5z * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + I6y * cos((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6y * cos((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6x * cos((-2 * q5 + q4 + q3 + q2)) / 0.8e1 + I6x * cos((-2 * q6 - 2 * q5 + q4 + q3 + q2)) / 0.16e2 - I6x * cos((2 * q5 + q4 + q3 + q2)) / 0.8e1 - I6z * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - I6x * cos((2 * q6 + 2 * q5 + q4 + q3 + q2)) / 0.16e2 + I6z * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m5 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m6 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 - m6 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m5 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m4 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 - m4 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 + m5 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 + m4 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 - m6 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m4 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 - m5 * d6 ^ 2 * cos((2 * q5 + q4 + q3 + q2)) / 0.4e1 + m6 * d6 ^ 2 * cos((-2 * q5 + q4 + q3 + q2)) / 0.4e1 I6x * cos((2 * q6)) / 0.4e1 - I6y * cos((2 * q6)) / 0.4e1 + I5z * cos((2 * q5)) / 0.2e1 - I5x * cos((2 * q5)) / 0.2e1 + I6y * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((-2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6y * cos((2 * q5)) / 0.4e1 - I6x * cos((2 * q5)) / 0.4e1 + I6z * cos((2 * q5)) / 0.2e1 + I6y * cos((-2 * q6 + 2 * q5)) / 0.8e1 + m5 * d6 ^ 2 / 0.2e1 + m6 * d6 ^ 2 / 0.2e1 + I6x / 0.4e1 + I6y / 0.4e1 + I6z / 0.2e1 + m6 * a4 ^ 2 + m4 * d6 ^ 2 / 0.2e1 + m4 * a4 ^ 2 + I4y - m5 * d6 * a3 * sin((q5 + q4)) / 0.2e1 + m5 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 - m6 * d6 * a3 * sin((q5 + q4)) / 0.2e1 + m6 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 - m6 * d6 * a2 * sin((q5 + q4 + q3)) / 0.2e1 - m5 * d6 * a2 * sin((q5 + q4 + q3)) / 0.2e1 + m5 * d6 * a2 * sin((-q5 + q4 + q3)) / 0.2e1 + m6 * d6 * a2 * sin((-q5 + q4 + q3)) / 0.2e1 - 0.2e1 * m6 * d6 * a4 * sin(q5) - 0.2e1 * m5 * d6 * a4 * sin(q5) - 0.2e1 * m4 * d6 * a4 * sin(q5) + m4 * a3 * d6 * sin((-q5 + q4)) / 0.2e1 - m4 * a3 * d6 * sin((q5 + q4)) / 0.2e1 + m4 * a3 * a4 * cos(q4) + m6 * a3 * a4 * cos(q4) + m5 * a3 * a4 * cos(q4) + m6 * a2 * a4 * cos((q3 + q4)) + m4 * a2 * a4 * cos((q3 + q4)) - m4 * a2 * d6 * sin((q5 + q4 + q3)) / 0.2e1 + m5 * a2 * a4 * cos((q3 + q4)) + m4 * a2 * d6 * sin((-q5 + q4 + q3)) / 0.2e1 - m4 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m5 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m6 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 + I5x / 0.2e1 + I5z / 0.2e1 + m5 * a4 ^ 2 I6x * cos((2 * q6)) / 0.4e1 - I6y * cos((2 * q6)) / 0.4e1 + I5z * cos((2 * q5)) / 0.2e1 - I5x * cos((2 * q5)) / 0.2e1 + I6y * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((-2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6y * cos((2 * q5)) / 0.4e1 - I6x * cos((2 * q5)) / 0.4e1 + I6z * cos((2 * q5)) / 0.2e1 + I6y * cos((-2 * q6 + 2 * q5)) / 0.8e1 + m5 * d6 ^ 2 / 0.2e1 + m6 * d6 ^ 2 / 0.2e1 + I6x / 0.4e1 + I6y / 0.4e1 + I6z / 0.2e1 + m6 * a4 ^ 2 + m4 * d6 ^ 2 / 0.2e1 + m4 * a4 ^ 2 + I4y - m5 * d6 * a3 * sin((q5 + q4)) / 0.2e1 + m5 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 - m6 * d6 * a3 * sin((q5 + q4)) / 0.2e1 + m6 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 - 0.2e1 * m6 * d6 * a4 * sin(q5) - 0.2e1 * m5 * d6 * a4 * sin(q5) - 0.2e1 * m4 * d6 * a4 * sin(q5) + m4 * a3 * d6 * sin((-q5 + q4)) / 0.2e1 - m4 * a3 * d6 * sin((q5 + q4)) / 0.2e1 + m4 * a3 * a4 * cos(q4) + m6 * a3 * a4 * cos(q4) + m5 * a3 * a4 * cos(q4) - m4 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m5 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m6 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 + I5x / 0.2e1 + I5z / 0.2e1 + m5 * a4 ^ 2 I6x * cos((2 * q6)) / 0.4e1 - I6y * cos((2 * q6)) / 0.4e1 + I5z * cos((2 * q5)) / 0.2e1 - I5x * cos((2 * q5)) / 0.2e1 + I6y * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((-2 * q6 + 2 * q5)) / 0.8e1 - I6x * cos((2 * q6 + 2 * q5)) / 0.8e1 - I6y * cos((2 * q5)) / 0.4e1 - I6x * cos((2 * q5)) / 0.4e1 + I6z * cos((2 * q5)) / 0.2e1 + I6y * cos((-2 * q6 + 2 * q5)) / 0.8e1 + m5 * d6 ^ 2 / 0.2e1 + m6 * d6 ^ 2 / 0.2e1 + I6x / 0.4e1 + I6y / 0.4e1 + I6z / 0.2e1 + m6 * a4 ^ 2 + m4 * d6 ^ 2 / 0.2e1 + m4 * a4 ^ 2 + I4y - 0.2e1 * m6 * d6 * a4 * sin(q5) - 0.2e1 * m5 * d6 * a4 * sin(q5) - 0.2e1 * m4 * d6 * a4 * sin(q5) - m4 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m5 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 - m6 * d6 ^ 2 * cos((2 * q5)) / 0.2e1 + I5x / 0.2e1 + I5z / 0.2e1 + m5 * a4 ^ 2 I6y * cos((-2 * q6 + q5)) / 0.4e1 - I6y * cos((2 * q6 + q5)) / 0.4e1 + I6x * cos((2 * q6 + q5)) / 0.4e1 - I6x * cos((-2 * q6 + q5)) / 0.4e1 cos(q5) * I6z; -cos((q2 + q3 + q4)) * I5y - I6y * cos((q2 + q3 + q4)) / 0.2e1 + I6x * cos((-2 * q6 + q4 + q3 + q2)) / 0.4e1 + I6y * cos((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6y * cos((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + I6x * cos((2 * q6 + q4 + q3 + q2)) / 0.4e1 + I6x * cos((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6x * cos((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 + I6y * cos((-2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6y * cos((2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 - I6x * cos((-2 * q6 + q4 + q3 + q2 - q5)) / 0.8e1 + I6x * cos((2 * q6 + q4 + q3 + q2 + q5)) / 0.8e1 - I6y * cos((2 * q6 + q4 + q3 + q2)) / 0.4e1 - I6y * cos((-2 * q6 + q4 + q3 + q2)) / 0.4e1 - I6x * cos((q2 + q3 + q4)) / 0.2e1 - m5 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 + m5 * d6 * a2 * sin((q5 + q2)) / 0.2e1 - m6 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 + m6 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m6 * d6 * a4 * sin((q2 + q3 + q4 - q5)) / 0.2e1 + m6 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 + m6 * d6 * a2 * sin((q5 + q2)) / 0.2e1 - m5 * d6 * a3 * sin((-q5 + q3 + q2)) / 0.2e1 + m5 * d6 * a3 * sin((q5 + q3 + q2)) / 0.2e1 - m5 * d6 * a2 * sin((-q5 + q2)) / 0.2e1 + m6 * d6 * a1 * sin(q5) + m5 * d6 * a4 * sin((q2 + q3 + q4 + q5)) / 0.2e1 + m5 * d6 * a1 * sin(q5) - m6 * d6 * a2 * sin((-q5 + q2)) / 0.2e1 - m5 * d6 ^ 2 * cos((q2 + q3 + q4)) - m6 * d6 ^ 2 * cos((q2 + q3 + q4)) -m6 * d6 * a2 * sin((q5 + q4 + q3)) / 0.2e1 + I6y * cos((-2 * q6 + q5)) / 0.4e1 - I6y * cos((2 * q6 + q5)) / 0.4e1 - m5 * d6 * a3 * sin((q5 + q4)) / 0.2e1 - m5 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 - m5 * d6 * a2 * sin((q5 + q4 + q3)) / 0.2e1 - m5 * d6 * a2 * sin((-q5 + q4 + q3)) / 0.2e1 + I6x * cos((2 * q6 + q5)) / 0.4e1 - I6x * cos((-2 * q6 + q5)) / 0.4e1 - m6 * d6 * a3 * sin((q5 + q4)) / 0.2e1 - m6 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 - m6 * d6 * a2 * sin((-q5 + q4 + q3)) / 0.2e1 I6y * cos((-2 * q6 + q5)) / 0.4e1 - I6y * cos((2 * q6 + q5)) / 0.4e1 - m5 * d6 * a3 * sin((q5 + q4)) / 0.2e1 - m5 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 + I6x * cos((2 * q6 + q5)) / 0.4e1 - I6x * cos((-2 * q6 + q5)) / 0.4e1 - m6 * d6 * a3 * sin((q5 + q4)) / 0.2e1 - m6 * d6 * a3 * sin((-q5 + q4)) / 0.2e1 I6y * cos((-2 * q6 + q5)) / 0.4e1 - I6y * cos((2 * q6 + q5)) / 0.4e1 + I6x * cos((2 * q6 + q5)) / 0.4e1 - I6x * cos((-2 * q6 + q5)) / 0.4e1 m5 * d6 ^ 2 + m6 * d6 ^ 2 - I6x * cos((2 * q6)) / 0.2e1 + I6x / 0.2e1 + I6y / 0.2e1 + I6y * cos((2 * q6)) / 0.2e1 + I5y 0; -I6z * cos((q2 + q3 + q4 - q5)) / 0.2e1 + I6z * cos((q2 + q3 + q4 + q5)) / 0.2e1 cos(q5) * I6z cos(q5) * I6z cos(q5) * I6z 0 I6z;];


block.OutputPort(1).Data = D;


%endfunction